#include <bits/stdc++.h>
#define all(a) a.begin(), a.end()

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pii;

vector<vector<pii> > graph;
vector<int> dpth;
vector<pii> best_two;

pii insert(pii me, int guy) {
    if (me.first <= guy) {
        me.second = me.first;
        me.first = guy;
    } else if (me.second < guy)
        me.second = guy;
    return me;
}

ll get(int curr, int p = -1) {
    ll out = 0;
    best_two[curr].first = dpth[curr];
    for (auto [f, w] : graph[curr]) {
        if (f == p)
            continue;
        dpth[f] = dpth[curr] + w;
        out = max(out, get(f, curr));
        best_two[curr] = insert(best_two[curr], best_two[f].first);
    }
    out = max(out, best_two[curr].first + best_two[curr].second - (ll)dpth[curr]*2LL);
    return out;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n, k;
    cin >> n >> k;
    graph = vector<vector<pii> >(n + 1);
    dpth = vector<int>(n + 1);
    best_two = vector<pii>(n + 1, pii(0, 0));
    for (int i = 1; i < n; i++) {
        int f, t, w;
        cin >> f >> t >> w;
        graph[f].emplace_back(t, w);
        graph[t].emplace_back(f, w);
    }

    cout << get(1) << "\n";
}