#include <bits/stdc++.h>
#define all(a) a.begin(), a.end()

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pii;
typedef array<ll, 3> tupl;

vector<vector<pii> > graph;
vector<int> dpth;
vector<tupl> best_two;

tupl insert(tupl me, int guy) {
    if (me[0] <= guy) {
        me[2] = me[1];
        me[1] = me[0];
        me[0] = guy;
    } else if (me[1] <= guy) {
        me[2] = me [1];
        me[1] = guy;
    } else if (me[2] < guy)
        me[2] = guy;
    return me;
}

ll get_reduced(tupl me) {
    me[0]--;
    ll out = 0;
    for (int i = 0; i < 3; i++)
        for (int j = i + 1; j < 3; j++)
            out = max(out, me[i] + me[j]);
    return out;
}

int k;
multiset<ll> allo;
ll get(int curr, int p = -1) {
    ll out = 0;
    best_two[curr][0] = dpth[curr];
    for (auto [f, w] : graph[curr]) {
        if (f == p)
            continue;
        dpth[f] = dpth[curr] + w;
        out = max(out, get(f, curr));
        best_two[curr] = insert(best_two[curr], best_two[f][0]);
    }
    allo.insert(best_two[curr][0] + best_two[curr][1] - (ll)dpth[curr]*2LL);
    return out;
}

ll try_dec(int curr, int p = -1) {
    ll out = 1e18;
    for (auto [f, w] : graph[curr]) {
        if (f == p)
            continue;
        out = min(out, try_dec(f, curr));
    }
    ll val2 = get_reduced(best_two[curr]) - (ll)dpth[curr]*2LL;
    ll val1 = best_two[curr][0] + best_two[curr][1] - (ll)dpth[curr]*2LL;
    allo.erase(allo.find(val1));    
    allo.insert(val2);
    out = min(out, *prev(allo.end()));

    allo.erase(allo.find(val2));
    allo.insert(val1);
    
    return out;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n;
    cin >> n >> k;
    graph = vector<vector<pii> >(n + 1);
    dpth = vector<int>(n + 1);
    best_two = vector<tupl>(n + 1, tupl({0, 0, 0}));
    for (int i = 1; i < n; i++) {
        int f, t, w;
        cin >> f >> t >> w;
        graph[f].emplace_back(t, w);
        graph[t].emplace_back(f, w);
    }

    get(1);

    if (k == 0)
        cout << *prev(allo.end()) << "\n";
    else
        cout << try_dec(1) << "\n";
}