#include <bits/stdc++.h>
#include <vector>
#include <cassert>
#include <algorithm>
#include "cycles.h"
using namespace std;

void finish(vector<int> v)
{
	if (v.size()==1)
		return;
	int k = v.size();
	int a = rand()%k;
	int b = rand()%k;
	while(b==a)
		b = rand()%k;
	int prev = performSwap(v[a],v[b]);
	vector<int> va,vb;
	va.push_back(v[a]);
	vb.push_back(v[b]);
	for (int i = 0; i < k; i++)
		if (i != a && i != b)
		{
			int cur = performSwap(v[i],v[a]);
			if (cur > prev)
				va.push_back(v[i]);
			else
				vb.push_back(v[i]);
			prev = performSwap(v[i],v[a]);
		}
	finish(va);
	finish(vb);
}

void sortPermutation(int n){
	vector<int> here;
	here.push_back(0);
	vector<int> oth;
	for(int i = 1; i < n; i++)
		oth.push_back(i);
	performSwap(0,1);
	int prev = performSwap(0,1);
	int cur = prev;
	while(cur > 1)
	{
		int a = rand()%here.size();

		int b = rand()%oth.size();
		cur = performSwap(here[a],oth[b]);
		if(cur > prev)
			cur = performSwap(here[a],oth[b]),here.push_back(oth[b]),oth.erase(oth.begin()+b);
		prev = cur;
	}
	vector<int> aa;
	for (int i = 0; i < n; i++)
		aa.push_back(i);
	finish(aa);
}