#include <bits/stdc++.h>
#define int long long

using namespace std;

const int nmax = 2e5;

int n, k;
vector<pair<int,int>> G[nmax + 5];

vector<int> pref[nmax + 5];

int l[nmax + 5];

int Max = 1, c = 1;

void get_l(int nod, int dad = 0)
{
    l[nod] = 0;
    if(G[nod].size() == 1 && nod != 1)
    {
        return;
    }
    for(auto it : G[nod])
    {
        if(it.first == dad)
        {
            continue;
        }
        get_l(it.first, nod);
        l[nod] = max(l[nod], l[it.first] + it.second);
    }
    if(G[nod][0].first == dad)
    {
        pref[nod].push_back(0);
    }
    else
    {
        pref[nod].push_back(l[G[nod][0].first] + G[nod][0].second);
    }
    for(int i=1; i<G[i].size(); i++)
    {
        if(G[nod][i].first == dad)
        {
            pref[nod].push_back(pref[nod].back());
        }
        else
        {
            pref[nod].push_back(max(pref[nod].back(), l[G[nod][i].first] + G[nod][i].second));
        }
    }
}

void get_center(int nod, int dad = 0, int l_sus = 0)
{
    int suf = 0;
    vector<int> lst;
    lst.push_back(l_sus);
    for(auto it : G[nod])
    {
        if(it.first == dad)
        {
            continue;
        }
        lst.push_back(l[it.first] + it.second);
    }
    sort(lst.begin(), lst.end(), greater<int>());
    if(lst.size() >= 2 && lst[0] + lst[1] > Max)
    {
        Max = lst[0] + lst[1];
        c = nod;
    }
    for(int i=(int)G[nod].size()-1; i>=0; i--)
    {
        if(G[nod][i].first == dad)
        {
            continue;
        }
        int val = l_sus;
        val = max(val, suf);
        if(i != 0)
        {
            val = max(val, pref[nod][i - 1]);
        }
        get_center(G[nod][i].first, nod, val + G[nod][i].second);
    }
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
#ifdef home
    freopen("nr.in","r",stdin);
    freopen("nr.out","w",stdout);
#endif // home
    cin>>n>>k;
    for(int i=1; i<n; i++)
    {
        int x, y, c;
        cin>>x>>y>>c;
        G[x].push_back({y, c});
        G[y].push_back({x, c});
        Max = max(Max, c);
    }
    for(int i=1; i<=n; i++)
    {
        get_l(i);
        vector<int> lst;
        for(auto it : G[i])
        {
            lst.push_back(l[it.first] + it.second);
        }
        sort(lst.begin(), lst.end(), greater<int>());
        if(lst.size() >= 2 && lst[0] + lst[1] > Max)
        {
            Max = lst[0] + lst[1];
            c = i;
        }
    }
    //get_center(1);
    cout<<Max<<'\n';
    /* int st = 1;
     int dr = 2e9;
     int rez = 0;
     while(st <= dr)
     {
         int mij = (st + dr) >> 1LL;
         if(ok(mij))
         {
             rez = mij;
             dr = mij - 1;
         }
         else
         {
             st = mij + 1;
         }
     }
     cout<<rez<<'\n';
     */
    return 0;
}
