#include <bits/stdc++.h>
#define int long long

using namespace std;

const int nmax = 2e5;

int n, k;
vector<pair<int,int>> G[nmax + 5];

vector<int> pref[nmax + 5];

int l[nmax + 5], t[nmax + 5];

int Max = 0, c = 1;
int Min_dif = INT_MAX;

void get_l(int nod, int dad = 0)
{
    l[nod] = 0;
    if(G[nod].size() == 1 && nod != 1)
    {
        return;
    }
    for(auto it : G[nod])
    {
        if(it.first == dad)
        {
            continue;
        }
        get_l(it.first, nod);
        l[nod] = max(l[nod], l[it.first] + it.second);
    }
    if(G[nod][0].first == dad)
    {
        pref[nod].push_back(0);
    }
    else
    {
        pref[nod].push_back(l[G[nod][0].first] + G[nod][0].second);
    }
    for(int i=1; i<G[nod].size(); i++)
    {
        if(G[nod][i].first == dad)
        {
            pref[nod].push_back(pref[nod].back());
        }
        else
        {
            pref[nod].push_back(max(pref[nod].back(), l[G[nod][i].first] + G[nod][i].second));
        }
    }
}

void get_center(int nod, int dad = 0, int l_sus = 0)
{
    int suf = 0;
    vector<int> lst;
    lst.push_back(l_sus);
    for(auto it : G[nod])
    {
        if(it.first == dad)
        {
            continue;
        }
        lst.push_back(l[it.first] + it.second);
    }
    sort(lst.begin(), lst.end(), greater<int>());
    if(lst.size() >= 2 && (lst[0] + lst[1] > Max || (lst[0] + lst[1] == Max && lst[0] - lst[1] < Min_dif)))
    {
        Max = lst[0] + lst[1];
        Min_dif = lst[0] - lst[1];
        c = nod;
    }
    for(int i=(int)G[nod].size()-1; i>=0; i--)
    {
        if(G[nod][i].first == dad)
        {
            continue;
        }
        int val = l_sus;
        val = max(val, suf);
        if(i != 0)
        {
            val = max(val, pref[nod][i - 1]);
        }
        get_center(G[nod][i].first, nod, val + G[nod][i].second);
        suf = max(suf, l[G[nod][i].first] + G[nod][i].second);
    }
}

void get_l_new(int nod, int dad = 0)
{
    l[nod] = 0;
    for(auto it : G[nod])
    {
        if(it.first == dad)
        {
            continue;
        }
        get_l(it.first, nod);
        l[nod] = max(l[nod], l[it.first] + t[it.first]);
    }
}

void build(int nod, int dad = 0)
{
    for(auto it : G[nod])
    {
        if(it.first == dad)
        {
            continue;
        }
        t[it.first] = it.second;
        build(it.first, nod);
    }
}

bool elim(int nod, int dad = 0)
{
    for(auto it : G[nod])
    {
        if(it.first == dad)
        {
            continue;
        }
        if(l[it.first] + t[it.first] == l[nod] && t[it.first] != 0)
        {
            --t[it.first];
            return true;
        }
        bool ok = elim(it.first, nod);
        if(ok)
        {
            return true;
        }
    }
    return false;
}

int ok()
{
    build(c);
    int cnt = 0;
    while(cnt < k)
    {
        get_l_new(c);
        bool ok = elim(c);
        if(!ok)
        {
            break;
        }
        ++cnt;
    }
    get_l_new(c);
    Max = 0;
    vector<int> lst;
    for(auto it : G[c])
    {
        lst.push_back(l[it.first] + t[it.first]);
    }
    sort(lst.begin(), lst.end(), greater<int>());
    if(lst.size() >= 2 && lst[0] + lst[1] > Max)
    {
        Max = lst[0] + lst[1];
    }
    else
    {
        Max = INT_MAX;
    }
    return Max;
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
#ifdef home
    freopen("nr.in","r",stdin);
    freopen("nr.out","w",stdout);
#endif // home
    cin>>n>>k;
    for(int i=1; i<n; i++)
    {
        int x, y, c;
        cin>>x>>y>>c;
        G[x].push_back({y, c});
        G[y].push_back({x, c});
    }
    get_l(1);
    get_center(1);
    int rez = INT_MAX;
    for(int i=1;i<=n;i++)
    {
        c = i;
        rez = min(rez, ok());
    }
    cout<<rez<<'\n';
    return 0;
}
