#include<bits/stdc++.h>
using namespace std;
const int N = 2e5 + 1;
vector <pair<int, int>> e[N];
int mxd[N];
int mxid = -1, mx = -1;
pair <int, int> badedge;
set <pair<int, int>> cand;
int mpoint;
int p2, p1;
int diam;
int n, k;
int ans = 0;
int pre[N], pr[N];
int deledge(int x, int y){
    int f = 0;
    for(int _ = 0;_ < 2;_++){
        for(int i = 0;i < e[x].size();i++){
            if(e[x][i].first == y){
                f = e[x][i].second;
                swap(e[x][i], e[x].back());
                e[x].pop_back();
            }
        }
        swap(x, y);
    }
    return f;
}
void lowerone(int x, int y){
    for(int _ = 0;_ < 2;_++){
        for(int i = 0;i < e[x].size();i++){
            if(e[x][i].first == y){
                e[x][i].second--;
            }
        }
        swap(x, y);
    }
}
void delnode(int x){
    for(auto [i, d] : e[x]){
        deledge(i, x);
    }
}
void dfs(int node, int p, int r){
    if(mx < r){
        mx = r;
        mxid = node;
    }
    for(auto [i, d] : e[node]){
        if(i == p)continue;
        dfs(i, node, r + d);
    }
}
void dfs4(int node, int p){
    /// remove node -> p edge
    if(p != -1){
        pr[node] = p;
    }
    mxd[node] = 0;
    for(auto [i, d] : e[node]){
        if(i == p)continue;
        dfs4(i, node);
        mxd[i]+=d;
        pre[i] = d;
        mxd[node] = max(mxd[node], mxd[i]);
    }
    //cout<<node<<' '<<mxd[node]<<'\n';

}
void dfs3(int node, int p, int r, pair<int, int> edge){
    if(mx < r){
        mx = r;
        mxid = node;
        badedge = edge;
    }
    for(auto [i, d] : e[node]){
        if(i == p)continue;
        if(d > 0 && edge == pair<int,int>{-1, -1}){
            dfs3(i, node, r + d, pair<int,int>{node, i});
        }else{
            dfs3(i, node, r + d, edge);
        }
    }
}
bool dfs2(int node, int p, int target, int r){
    //cout<<"???\n"<<node<<' '<<target<<'\n';
    if(target == node)return 1;
    bool ok = 0;
    int l, l2, other;
    for(auto [i, d] : e[node]){
        if(i == p)continue;
        int x = dfs2(i, node, target, r + d);
        if(x){
            l = r;
            l2 = r + d;
            ok = 1;
            other = i;
        }
    }
    if(ok){
        //cout<<l<<' '<<l2<<' '<<node<<' '<<diam<<' '<<other<<'\n';
        if(l < diam/2 && diam/2 < l2){
            deledge(node, other);
            e[node].push_back({n, diam/2 - l});
            e[n].push_back({node, diam/2 - l});
            e[n].push_back({other, l2 - diam/2});
            e[other].push_back({n, l2 - diam/2});
            mpoint = n;
            n++;
        }
        if(l == diam/2){
            mpoint = node;
        }
        return 1;
    }
    return 0;
}
void lookfordiam(){
    mx = mxid = -1;
    p1 = p2 = -1;
    dfs(0, -1, 0);
    p1 = mxid;
    mx = mxid = -1;
    dfs(p1, -1, 0);
    p2 = mxid;
    diam = mx;
}
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin>>n>>k;
    for(int i = 0;i < n - 1;i++){
        int u, w, x;
        cin>>u>>w>>x;
        u--;w--;
        e[u].push_back({w, x});
        e[w].push_back({u, x});
    }
    lookfordiam();
    dfs2(p1, -1, p2, 0);
    dfs4(mpoint, -1);
    for(auto [i, d] : e[mpoint]){
        cand.insert({mxd[i], i});
    }
    for(int i = 0;i < n;i++){
        if(i == mpoint)continue;
        deledge(i, pr[i]);
    }
    /*
    while(k > 0){
        /// find longest edge
        mxid = mx = -1;
        badedge = {-1, -1};
        dfs3(mpoint, -1, 0, pair<int,int>{-1, -1});
        lowerone(badedge.first, badedge.second);
        k--;
    }*/
    while(k > 0){
        /// pick an edge and lower its value
        auto x = *cand.rbegin();
        cand.erase(x);
        if(pre[x.second] == 0){
            for(auto [i, d] : e[x.second]){
                cand.insert({mxd[i], i});
            }
        }else{
            cand.insert(pair<int,int>{x.first - 1, x.second});
            //cout<<x.second<<'\n';
            pre[x.second]--;
        }
        k--;
    }
    /// redo graph
    for(int i = 0;i < n;i++){
        e[i].clear();
        //cout<<mxd[i]<<' ';
    }
    for(int i = 0;i < n;i++){
        if(i != mpoint){
            e[i].push_back({pr[i], pre[i]});
            e[pr[i]].push_back({i, pre[i]});
        }
    }
    lookfordiam();
    cout<<diam;
    return 0;
}
