#include<bits/stdc++.h>
using namespace std;
const int N = 2e5 + 1;
const int inf = 1e9;
vector <pair<int, int>> e[N];
int mxd[N];
int mxid = -1, mx = -1;
int mpoint;
int p2, p1;
int diam;
int n, k;
int ans = 0;
pair <int, int> badedge;
int deledge(int x, int y){
    int f = 0;
    for(int _ = 0;_ < 2;_++){
        for(int i = 0;i < e[x].size();i++){
            if(e[x][i].first == y){
                f = e[x][i].second;
                swap(e[x][i], e[x].back());
                e[x].pop_back();
            }
        }
        swap(x, y);
    }
    return f;
}
void dfs(int node, int p, int r){
    if(mx < r){
        mx = r;
        mxid = node;
    }
    for(auto [i, d] : e[node]){
        if(i == p)continue;
        dfs(i, node, r + d);
    }
}
int l1, l2, other, node1;
bool dfs2(int node, int p, int target, int r){
    //cout<<"???\n"<<node<<' '<<target<<'\n';
    if(target == node)return 1;
    bool ok = 0;
    for(auto [i, d] : e[node]){
        if(i == p)continue;
        int x = dfs2(i, node, target, r + d);
        if(x){
            if(r <= diam/2 && diam/2 < r + d){
                l1 = r;
                l2 = r + d;
                other = i;
                node1 = node;
            }
            ok = 1;
        }
    }
    if(ok){
        //cout<<l<<' '<<l2<<' '<<node<<' '<<diam<<' '<<other<<'\n';
        return 1;
    }
    return 0;
}
void lookfordiam(){
    mx = mxid = -1;
    p1 = p2 = -1;
    dfs(0, -1, 0);
    p1 = mxid;
    mx = mxid = -1;
    dfs(p1, -1, 0);
    p2 = mxid;
    diam = mx;
}
int res = 0;
int atedge = 0;
int pre2[N], pr[N];
void dfs3(int node, int p, int pre, int t, bool ok){
    mxd[node] = 0;
    for(auto [i, d] : e[node]){
        if(i == p)continue;
        dfs3(i, node, d, t, ok);
        mxd[node] = max(mxd[node], mxd[i]);
    }
    mxd[node]+=pre;
    res+=max(min(pre, mxd[node] - t), 0);
    if(ok){
        pre2[node] = pre - max(min(pre, mxd[node] - t), 0);
        pr[node] = p;
    }
}
int c(int x, bool ok){
    res = 0;
    dfs3(mpoint, -1, 0, x, ok);
    return res;
}
void lowerone(int x, int y){
    for(int _ = 0;_ < 2;_++){
        for(int i = 0;i < e[x].size();i++){
            if(e[x][i].first == y){
                e[x][i].second--;
            }
        }
        swap(x, y);
    }
}
void dfs4(int node, int p, int r, pair<int, int> edge){
    if(mx < r){
        mx = r;
        mxid = node;
        badedge = edge;
    }
    for(auto [i, d] : e[node]){
        if(i == p)continue;
        if(d > 0 && edge == pair<int,int>{-1, -1}){
            dfs4(i, node, r + d, pair<int,int>{node, i});
        }else{
            dfs4(i, node, r + d, edge);
        }
    }
}
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin>>n>>k;
    for(int i = 0;i < n - 1;i++){
        int u, w, x;
        cin>>u>>w>>x;
        u--;w--;
        e[u].push_back({w, x});
        e[w].push_back({u, x});
    }
    lookfordiam();
    dfs2(p1, -1, p2, 0);
    //cout<<l1<<' '<<l2<<' '<<node1<<' '<<other<<'\n';
    if(l1 < diam/2 && diam/2 < l2){
        deledge(node1, other);
        e[node1].push_back({n, diam/2 - l1});
        e[n].push_back({node1, diam/2 - l1});
        e[n].push_back({other, l2 - diam/2});
        e[other].push_back({n, l2 - diam/2});
        mpoint = n;
        n++;
    }
    if(l1 == diam/2){
        mpoint = node1;
    }
    int l = 0, r = inf;
    while(l != r){
        int m = (l + r)/2;
        if(c(m, 0) <= k)r = m;
        else l = m + 1;
    }
    k = k - c(l, 1);
    for(int i = 0;i < n;i++){
        e[i].clear();
    }
    for(int i = 0;i < n;i++){
        e[pr[i]].push_back({i, pre2[i]});
        e[i].push_back({pr[i], pre2[i]});
    }
    while(k > 0){
        /// find longest edge
        mxid = mx = -1;
        badedge = {-1, -1};
        dfs4(mpoint, -1, 0, pair<int,int>{-1, -1});
        lowerone(badedge.first, badedge.second);
        k--;
    }
    lookfordiam();
    cout<<diam;
    return 0;
}
