#include <bits/stdc++.h>
using namespace std;
#include "soft_drinks.h"
const int NMAX = 1e5;
const int INF = 2e9;
const double EPS = 1e-6;

int b[NMAX+1], a[NMAX+1];
int n;
void init( const vector<int>& A, const vector<int>& B ) {
  int i;
  n = B.size();
  for( i = 0; i < A.size(); i++ )
    a[i] = A[i];
  for( i = 0; i < B.size(); i++ )
    b[i] = B[i];
  if( a[0] > a[1] )
    swap( a[0], a[1] ), swap( b[0], b[1] );
}

bool check( double val, int zahar, int acid ) {
  double low, high;
  low = (double)( (double)val * (double)a[1] - (double)zahar ) / (double)( (double)a[1] - (double)a[0] );
  high = (double)( (double)acid - (double)val * (double)b[1] ) / (double)( (double)b[0] - (double)b[1] );
  if( high < 0 || low > val || low > high )
    return false;
  return true;
}
double friendDrink( int zahar, int acid, int l, int r ) {
  if( n == 1 ) {
    while( true ) {

    }
  }
  if( l > r )
    return 0;
  if( n == 1 ) {
    if( r < a[0] || l > a[0] )
      return 0;
    double x1, x2;
    x1 = (double)zahar / (double)a[0];
    x2 = (double)acid / (double)b[0];
    return min( x1, x2 );
  }
  if( r < a[0] || l > a[1] || ( l > a[0] && r < a[1] ) )
    return 0;
  if( l <= a[0] && r >= a[0] && r < a[1] ) {   // o ia doar pe prima
    double x1, x2;
    x1 = (double)zahar / (double)a[0];
    x2 = (double)acid / (double)b[0];
    return min( x1, x2 );
  }
  if( l <= a[1] && r >= a[1] && l > a[0] ) {   // o ia doar pe a doua
    double x1, x2;
    x1 = (double)zahar / (double)a[1];
    x2 = (double)acid / (double)b[1];
    return min( x1, x2 );
  }
  if( b[0] <= b[1] ) {   // una e superioara
    double x1, x2;
    x1 = (double)zahar / (double)a[0];
    x2 = (double)acid / (double)b[0];
    return min( x1, x2 );
  }
  if( a[0] == a[1] ) {
    double x1, x2;
    int bb = min( b[0], b[1] );
    x1 = (double)zahar / (double)a[0];
    x2 = (double)acid / (double)bb;
  }
  double st, dr, mij;
  st = 0.0;
  dr = (double)INF;
  while( dr - st > EPS ) {
    mij = ( st + dr ) / 2;
    if( check( mij, zahar, acid ) )
      st = mij;
    else
      dr = mij;
  }
  return st;
}
