#include <iostream>
#include <algorithm>
#include <vector>

#define nMax 2001

using namespace std;


struct nod{
    int mark=0;
    vector<int> kids;
};

int n, k, x, y, z, curMark, curNod, curRoot;
int dist[nMax][nMax];
nod tree[nMax];

struct edge{
    int x;
    int y;
    int z;
};

vector<edge> top;

void dfs(){
    tree[curNod].mark=curMark;
    for(auto i : tree[curNod].kids){
        if(tree[i].mark!=curMark){
            dist[curNod][i]++;
            dist[i][curNod]++;
            int aux=curNod;
            curNod=i;
            dfs();
            curNod=aux;
        }
    }
}

int compare(edge a, edge b){
    return a.z>b.z;
}

int main()
{
    cin>>n>>k;
    for(int i=1;i<n;i++){
        cin>>x>>y>>z;
        dist[x][y]=dist[y][x]=z;
        tree[x].kids.push_back(y);
        tree[y].kids.push_back(x);
    }

    if(k>=n-1)cout<<0;
    else cout<<n-1;

//    for(int i=1;i<=n;i++){
//        curMark++;
//        curRoot=i;
//        curNod=i;
//        dfs();
//    }
//
//    for(int i=1;i<n;i++)
//        for(int j=i+1;j<=n;j++){
//            if(!dist[i][j])continue;
//            top.push_back({i, j, dist[i][j]});
//        }
//
//
//    sort(top.begin(), top.end(), compare);

    return 0;
}
