#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <vector>
#include <algorithm>
#define MAXN 200005
using namespace std;

struct NOD{
  int neigh,cost;
};

int suma[MAXN][2];
vector <NOD> graf[MAXN];

int n,k;

int ma;

bool cmp(NOD a,NOD b){
  return a.cost>b.cost;
}

void DFS(int node,int fath){
  int aux,c;
  vector <NOD> vec[2];

  vec[0].clear();
  vec[1].clear();
  vec[0].shrink_to_fit();
  vec[1].shrink_to_fit();

  suma[node][0]=0;
  suma[node][1]=0;

  c=0;
  for(NOD neigh : graf[node]){
    if(neigh.neigh!=fath){
      DFS(neigh.neigh,node);

      suma[node][0]=max(suma[node][0],suma[neigh.neigh][0]+neigh.cost);
      vec[0].push_back({neigh.neigh,suma[neigh.neigh][0]+neigh.cost});

      aux=neigh.cost;
      if(aux>0){
        aux--;
      }

      int mi=min(suma[neigh.neigh][0]+aux,suma[neigh.neigh][1]+neigh.cost);

      if(suma[node][1]==mi){
        c++;
      }else{
        if(suma[node][1]<mi){
          suma[node][1]=mi;
          c=1;
        }
      }
      vec[1].push_back({neigh.neigh,mi});
    }
  }

  if(c>1){
    suma[node][1]++;
  }

  sort(vec[0].begin(),vec[0].end(),cmp);
  sort(vec[1].begin(),vec[1].end(),cmp);

  if(vec[1].size()==1){
    if(ma<vec[1][0].cost){
      ma=vec[1][0].cost;
    }
    return;
  }
  if(vec[1].size()>1){
    if(vec[1][0].neigh!=vec[0][0].neigh){
      if(ma<vec[1][0].cost+vec[0][0].cost){
        ma=vec[1][0].cost;
      }
      return;
    }
    if(ma<vec[1][0].cost+vec[0][1].cost && vec[1][0].neigh!=vec[0][1].neigh){
      ma=vec[1][0].cost+vec[0][1].cost;
    }
    return;
  }
}

int main(){
  int i,j,x,y,c,mi;


  scanf("%d%d",&n,&k);
  for(i=0;i<n-1;i++){
    scanf("%d%d%d",&x,&y,&c);
    graf[x].push_back({y,c});
    graf[y].push_back({x,c});
  }

  DFS(1,-1);

  printf("%d\n",ma);

  return 0;
}
