#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>
#include "soft_drinks.h"

using ld = double;

int n;
std::vector<int> a, b;
int minA = 0;

void init(const std::vector<int>& A, const std::vector<int>& B) {
  n = (int) A.size();
  a = A;
  b = B;
  std::swap(a, b);
  minA = *std::min_element(a.begin(), a.end());
}

ld friendDrink(int mA, int mB, int lA, int rA) {
  if (lA > 0) {
    return 0;
  } 
  std::swap(mA, mB);
  return (ld) mA / minA;
}