#include <bits/stdc++.h>

using namespace std;

const int NMAX = 1e5;

int a[NMAX];
int b[NMAX];
int n;

void init(const std::vector<int>& A, const std::vector<int>& B) {
    n = A.size();
    for ( int i = 0; i < n; i ++ ) {
        a[i] = A[i];
        b[i] = B[i];
    }
}

double minDrink( int i, int Ma, int Mb ) {
    if ( b[i] == 0 ) return (double)Ma / a[i];
    if ( a[i] == 0 ) return (double)Mb / b[i];
    return min( (double)Ma / a[i], (double)Mb / b[i] );
}
double friendDrink(const int Ma, const int Mb, const int La, const int Ra) {
    int minA = -1, minB = -1;

    for ( int i = 0; i < n; i ++ ) {
        if ( La <= a[i] && a[i] <= Ra ) {
            if ( minA == -1 || a[i] < a[minA] ) minA = i;
            if ( minB == -1 || b[i] < b[minB] ) minB = i;
        }
    }
    if ( minA == minB ) {
        return minDrink( minA, Ma, Mb );
    }
    int i = minA, j = minB;
    double t = (double)( Mb * a[j] - Ma * b[j] ) / ( Ma * ( b[i] - b[j] ) - Mb * ( a[i] - a[j] ) );

    if ( 0 <= t && t <= 1 ) {
        return (double)Ma / ( a[j] + t * ( a[i] - a[j] ) );
    }
    return max( minDrink( minA, Ma, Mb ), minDrink( minB, Ma, Mb ) );
}
