#include "cycles.h"
#include <iostream>
#include <cctype>
using namespace std;

#define MAXN 1000
int perm[MAXN],pos[MAXN];

int readInt(){
  int nr;
  char ch;

  do{
    cin.get(ch);
  }while(!isdigit(ch));

  nr=0;
  while(ch!='\n'&&!cin.eof()&&isdigit(ch)){
    nr=nr*10+ch-'0';
    cin.get(ch);
  }
  return nr;
}

void sortPermutation(int n){
  int i;

  cin.seekg(0);
  n=readInt();
  for(i=0;i<n;i++){
    perm[i]=readInt();
    pos[perm[i]]=i;
  }
  for(i=0;i<n;i++){
    if(perm[i]!=i){
      performSwap(i,pos[i]);
      int aux=pos[i];
      pos[i]=i;
      pos[perm[i]]=aux;
      perm[aux]=perm[i];
      perm[i]=i;
    }
  }
}