#include <iostream>
#include <climits>
#include <vector>

using namespace std;

const long long nmax = 2e5 + 5;

struct idk{
    long long v1, v2;
} sub[nmax];

struct ceva{
    long long vec, cost;
};

long long n, k, s, fr[nmax], lant[nmax];
vector<ceva> v[nmax];

bool cmp(ceva x, ceva y){
    return x.vec < y.vec;
}

void dfs(long long nod)
{
    fr[nod] = 1;
    for(auto [x, c] : v[nod])
    {
        if(fr[x])continue;

        dfs(x);

        lant[nod] = max(lant[nod], lant[x] + c);

        if(sub[nod].v1 <= lant[x] + c){
            sub[nod].v2 = sub[nod].v1;
            sub[nod].v1 = lant[x] + c;
        }

        else if(sub[nod].v2 < lant[x] + c)
             sub[nod].v2 = lant[x] + c;

    }
}

int main()
{
    cin >> n >> k;
    for(long long i = 1; i < n; i ++)
    {
        long long x, y, w;
        cin >> x >> y >> w;
        v[x].push_back({y, w});
        v[y].push_back({x, w});

        s += w;
    }

    if(s <= k){
        cout << 0;
        return 0;
    }

    dfs(1); long long mini = 0;
    for(long long i = 1; i <= n; i ++)
        mini = max(mini, sub[i].v1 + sub[i].v2);

    for(; k >= 1; k --)
    {
        long long a1, a2;
        for(long long x = 1; x <= n; x ++)
            for(auto [y, c] : v[x])
            {
                if(!c) continue;

                for(long long i = 1; i <= n; i ++) sub[i] = {0, 0}, lant[i] = fr[i] = 0;

                long long p, p2;
                for(long long i = 0; i < v[x].size(); i ++)
                    if(v[x][i].vec == y){
                        p = i; break;
                    }

                for(long long i = 0; i < v[y].size(); i ++)
                    if(v[y][i].vec == x){
                        p2 = i; break;
                    }

                v[x][p].cost --; v[y][p2].cost --;

                dfs(1);

                v[x][p].cost ++; v[y][p2].cost ++;

                long long maxi = 0;
                for(long long i = 1; i <= n; i ++)
                    maxi = max(maxi, sub[i].v1 + sub[i].v2);

                if(maxi < mini)
                    mini = maxi, a1 = x, a2 = y;
            }

        long long p, p2;
        for(long long i = 0; i < v[a1].size(); i ++)
            if(v[a1][i].vec == a2){
                p = i; break;
            }

        for(long long i = 0; i < v[a2].size(); i ++)
            if(v[a2][i].vec == a1){
                p2 = i; break;
            }

        v[a1][p].cost --; v[a2][p2].cost --;
    }

    cout << mini;
    return 0;
}
