#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <stack>
#include <queue>
#include <map>
#include <algorithm>
#include <string>
#include <climits>
#include <cassert>
//#include <random>

//#include <bits/stdc++.h>

#include "cycles.h"

using namespace std;

#define DEFINES 1
#if DEFINES
    #define DEBUG           1
    #define STATISTICS_TREE 0

    #if DEBUG
        #define DEBUG_LOG_ONLY if(DEBUG)
        #define DEBUG_PAUSE_SYSTEM system("pause");
        #define DEBUG_CLEAR system("cls");
        #define DEBUG_PRINT_VAR_BOLD(name, var) cout << "log /> " << name << " " << var << "\n";
    #endif // DEBUG

    #if STATISTICS_TREE
        #include <ext/pb_ds/assoc_container.hpp>
        #include <ext/pb_ds/tree_policy.hpp>

        using namespace __gnu_pbds;

        template<class type, class comarator = less<type>>
        using OrderedSet = tree<type, null_type, less<type>, rb_tree_tag, tree_order_statistics_node_update>;
    #endif // STATISTICS_TREE

    /*int ModularInverse(int n, int mod) {
        if(n == 1) return 1;
        return mod - (mod / n) * ModularInverse(mod % n) % mod;
    }*/
#endif // DEFINES


/// !O pemutare sortata are n cicluri

int cicluriOrg;

bool PerformEvenSwap(int n) {
    for(int i = 0; i < n; i += 2) {
        if(performSwap(i, i + 1) <= cicluriOrg) performSwap(i, i + 1);
    }
}

void sortPermutation(int n) {
    performSwap(0, 1);
    cicluriOrg = performSwap(0, 1);

    if(PerformEvenSwap(n)) return;
}
