#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <stack>
#include <queue>
#include <map>
#include <algorithm>
#include <string>
#include <climits>
#include <cassert>
//#include <random>

//#include <bits/stdc++.h>

#include "cycles.h"

using namespace std;

#define DEBUG           1

#if DEBUG
    #define DEBUG_LOG_ONLY if(DEBUG)
    #define DEBUG_PAUSE_SYSTEM system("pause");
    #define DEBUG_CLEAR system("cls");
    #define DEBUG_PRINT_VAR_BOLD(name, var) cout << "log /> " << name << " " << var << "\n";
#endif // DEBUG

/// !O pemutare sortata are n cicluri

int cicluriOrg;

bool PerformEvenSwap(int n) {
    int cicluriCur = cicluriOrg;
    for(int i = 0; i < n; i += 2) {
        if(performSwap(i, i + 1) <= cicluriCur) {
            performSwap(i, i + 1);
        }
        else cicluriCur++;
    }
    return cicluriCur == n;
}

void sortPermutation(int n) {
    performSwap(0, 1);
    cicluriOrg = performSwap(0, 1);

    if(PerformEvenSwap(n)) return;
}
