#include "cycles.h"

#include <cstdlib>
#include <ctime>

void sortPermutation(int N) {
    srand(time(0));
    int cnt = 1e6;

    int cycles = performSwap(0, 1);
    --cnt;

    while (cnt && cycles < N) {
        int i = rand() % (N - 1);
        int j = i + 1 + rand() % (N - i - 1);
        cycles = performSwap(i, j);
        --cnt;
    }
}
