#include "cycles.h"

#include <bits/stdc++.h>

using namespace std;

void sortPermutation(int N) {
    performSwap(0, 1);

    int cnt = performSwap(0, 1);
    int pos = -1;

    for (int i = 1; i < N; ++i) {
        int c = performSwap(i - 1, i);
        if (c < cnt) cnt = c;
        else {
            pos = i;
            break;
        }
    }

    for (int i = pos; i > 0; --i)
        cnt = performSwap(i - 1, i);

    for (int i = 0; i < pos; ++i) {
        int c = performSwap(i, pos);
        if (c == N) return;
        performSwap(i, pos);
    }

    int cycles = performSwap(0, 1);
    for (int i = 0; i < N - 1; ++i)
    for (int j = i + 1; j < N; ++j) {
        int c = performSwap(i, j);
        if (c <= cycles) performSwap(i, j);
        else cycles = c;
        if (cycles == N) return;
    }
}
