#include <bits/stdc++.h>

using namespace std;

constexpr int LIM = 2e5;
int N, K, diam, cnt, u, v, w;
vector<pair<int, int>> adj[LIM + 1];

int update(int d) {
    if (d > diam)
        diam = d, cnt = 0;
    if (d == diam) ++cnt;
}

int dfs(int u, int p = -1) {
    int h = 0;
    for (auto[v, w] : adj[u]) {
        if (v == p) continue;
        int h_v = dfs(v, u);
        update(h + h_v + w)
        h = max(h, h_v + w);
    }
    update(h);
    return h;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N >> K;
    for (int i = 0; i < N - 1; ++i) {
        cin >> u >> v >> w;
        adj[u].push_back(make_pair(v, w));
        adj[v].push_back(make_pair(u, w));
    }

    dfs(1);
    if (K == 0 || cnt == 1) cout << diam;
    else cout << diam - 1;

    return 0;
}
