#include "bits/stdc++.h"
#include "cycles.h"

using namespace std;

#define for0(i, n) for (ll i = 0; i < n; ++i)
#define pb push_back
#define con continue
#define ret return
#define be(x) x.begin()

typedef long long ll;
typedef vector<ll> vll;
typedef pair<ll, ll> pll;
typedef vector<pll> vpll;

void sortPermutation(int n);

int performSwap(int i, int j);

int get() {
    performSwap(0, 1);
    ret performSwap(0, 1);
}

mt19937_64 rn(chrono::steady_clock::now().time_since_epoch().count());

int rnd(int l, int r) {
    ret rn() % (r - l + 1);
}

const int N = 1e3 + 5, M = 10;

int used[N];
int n, c;

void prec() {
    for (int i = 0; i < n; i++) {
        for0(_, 10) {
            int j = rnd(0, n - 1);
            while (j == i) j = rnd(0, n - 1);
            performSwap(i, j);
        }
    }
}

void solve(vector<int> p) {
    if (p.size() == 1) return;
    int p1 = rnd(0, p.size() - 1);
    int p2 = p1;
    while (p2 == p1) p2 = rnd(0, p.size() - 1);
    performSwap(p[p1], p[p2]);
    c++;
    vector<int> c1{p[p1]}, c2{p[p2]};
    for (int i = 0; i < p.size(); i++) {
        if (i == p1 || i == p2) con;
        if (performSwap(p[p1], p[i]) == c + 1) c1.push_back(p[i]);
        else c2.push_back(p[i]);
        performSwap(p[p1], p[i]);
    }
    solve(c1), solve(c2);
}

void sortPermutation(int _n) {
    c = get();
    n = _n;
    prec();
    for (int i = 0; i < n; i++) {
        if (used[i]) con;
        vector<int> p{i};
        for (int j = i + 1; j < n; j++) {
            if (used[j]) con;
            if (performSwap(i, j) == c + 1) p.push_back(j), used[j] = 1;
            performSwap(i, j);
        }
        solve(p);
    }
}