#include "bits/stdc++.h"

using namespace std;

#define for0(i, n) for (ll i = 0; i < n; ++i)
#define pb push_back
#define con continue
#define ret return
#define be(x) x.begin()

typedef long long ll;
typedef vector<ll> vll;
typedef pair<ll, ll> pll;
typedef vector<pll> vpll;


const ll N = 2e5 + 5;

ll n, k, pr[N], c[N], h[N], ds[N];
vpll g[N];
ll mx[N], s[N];

void dfs(ll v, ll p) {
    pr[v] = p;
    h[v] = h[p] + 1;
    for (auto [x, w]: g[v]) {
        if (x == p) con;
        dfs(x, v);
    }
}

ll get(ll v) {
    for0(i, n) ds[i] = 2e9 + 5;
    ds[v] = 0;
    queue<ll> q;
    q.push(v);
    while (q.size()) {
        v = q.front();
        q.pop();
        for (auto [x, w]: g[v]) {
            if (ds[x] != 2e9 + 5) con;
            ds[x] = ds[v] + w;
            q.push(x);
        }
    }
    ret max_element(ds, ds + n) - ds;
}

ll get() {
    ll rt = get(0);
    ret ds[get(rt)];
}

signed main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    cin >> n >> k;
    for0(i, n - 1) {
        ll u, v, w;
        cin >> u >> v >> w;
        u--;
        v--;
        g[u].pb({v, w});
        g[v].pb({u, w});
    }
    ll d = get();
    dfs(0, 0);
    iota(c, c + n, 0);
    sort(c, c + n, [&](ll x, ll y) { ret h[x] > h[y]; });
    ll l = (k < 2 ? max(-1ll, d - 5) : -1), r = (k < 2 ? d + 5 : 2e9 + 5);
    while (l + 1 < r) {
        ll m = (l + r) / 2;
        for0(_, n) {
            ll v = c[_];
            s[v] = 0;
            mx[v] = 0;
            for (auto [x, w]: g[v]) {
                if (x == pr[v]) con;
                mx[x] += w;
                s[v] += s[x];
                while (mx[x] + mx[v] > m) {
                    if (mx[v] < mx[x]) swap(mx[x], mx[v]);
                    ll nd = min((mx[x] + mx[v]) - m, mx[v] - m / 2);
                    mx[v] -= nd;
                    s[v] += nd;
                }
                mx[v] = max(mx[v], mx[x]);
            }
        }
        (s[0] <= k ? r : l) = m;
    }
    cout << r;
}