#include <bits/stdc++.h>
#include "cycles.h"

using namespace std;

using ll = long long;

mt19937 mt(123);

void sortPermutation(int n) {
    int cyc = performSwap(0, 1);
    for (int i = 1; i < n; i++) {
        int nw = performSwap(0, i);
        if (nw > cyc) {
            performSwap(0, i);
        } else {
            cyc = nw;
        }
    }
    assert(cyc == 1);
    auto rec {[&](auto rec, vector<int> pos) -> void {
        if (pos.size() == 1) return;

        {
            int x = mt() % pos.size();
            int y = mt() % pos.size();
            while (x == y) {
                x = mt() % pos.size();
                y = mt() % pos.size();
            }
            cyc = performSwap(pos[x], pos[y]);
        }

        vector<int> pos1(1, pos[0]), pos2;
        for (int i = 1; i < pos.size(); i++) {
            int nw = performSwap(pos[0], pos[i]);
            performSwap(pos[0], pos[i]);
            if (nw > cyc) {
                pos1.push_back(pos[i]);
            } else {
                pos2.push_back(pos[i]);
            }
        }

        rec(rec, pos1);
        rec(rec, pos2);
    }};
    {
        vector<int> al(n);
        iota(al.begin(), al.end(), 0);
        rec(rec, al);
    }
}
