#include <bits/stdc++.h>

using namespace std;

using ll = long long;

#define x first
#define y second

mt19937 mt(123);

void solve();

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}

#define int ll

void solve() {
    int n, k, sm = 0;
    cin >> n >> k;
    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < n - 1; i++) {
        int u, v, w;
        cin >> u >> v >> w; u--; v--;
        g[u].emplace_back(v, w);
        g[v].emplace_back(u, w);
        sm += w;
    }
    k = min(k, sm);
    int diam, v = -1;
    {
        int be, en;
        {
            auto dfs {[&](auto dfs, int s, int p) -> pair<int, int> {
                pair<int, int> res = {0, s};
                for (auto [i, w] : g[s]) {
                    if (i != p) {
                        auto nw = dfs(dfs, i, s);
                        nw.x += w;
                        res = max(res, nw);
                    }
                }
                return res;
            }};
            be = dfs(dfs, 0, -1).y;
        }
        vector<int> pr(n), dpr(n, 0);
        auto dfs {[&](auto dfs, int s, int p) -> pair<int, int> {
            pair<int, int> res = {0, s};
            pr[s] = p;
            for (auto [i, w] : g[s]) {
                if (i != p) {
                    dpr[i] = w;
                    auto nw = dfs(dfs, i, s);
                    nw.x += w;
                    res = max(res, nw);
                }
            }
            return res;
        }};
        auto [d, jopa] = dfs(dfs, be, -1);
        diam = d;
        en = jopa;
        {
            int oink1 = en, oink2 = en, cur = 0, cur2;
            while (2 * cur < diam) {
                cur2 = cur;
                cur += dpr[oink1];
                oink2 = oink1;
                oink1 = pr[oink1];
            }
            if (2 * cur == diam) {
                v = oink1;
            } else {
                if (min(abs(2 * cur2 - diam), abs(2 * cur - diam)) >= k) {
                    cout << diam - k << '\n';
                    return;
                }
                int used = min(abs(2 * cur2 - diam), abs(2 * cur - diam));
                k -= used;
                diam -= used;
                for (auto &[i, w] : g[oink1]) {
                    if (i == oink2) {
                        w -= used;
                    }
                }
                for (auto &[i, w] : g[oink2]) {
                    if (i == oink1) {
                        w -= used;
                    }
                }
                if (abs(2 * cur2 - diam) < abs(2 * cur - diam)) {
                    v = oink2;
                } else {
                    v = oink1;
                }
            }
        }
    }
    vector<int> maxd(n), pr(n), dpr(n);
    {
        auto dfs {[&](auto dfs, int s, int p) -> void {
            maxd[s] = 0;
            pr[s] = p;
            for (auto [i, w] : g[s]) {
                if (i != p) {
                    dpr[i] = w;
                    dfs(dfs, i, s);
                    maxd[s] = max(maxd[s], maxd[i] + w);
                }
            }
        }};
        dfs(dfs, v, -1);
    }
    cout << v << ' ' << k << ' ' << diam << '\n';
    set<pair<int, int>> mx, nmx;
    mx.emplace(INT32_MAX / 2, -1);
    nmx.emplace(INT32_MAX / 2, -1);
    int cur = maxd[v];
    auto update {[&](int s) -> void {
        for (auto [i, w] : g[s]) {
            if (i != pr[s] && maxd[i] + w == cur) {
                mx.emplace(w, i);
            } else if (i != pr[s]) {
                nmx.emplace(maxd[i] + w, i);
            }
        }
    }};
    update(v);
    while (true) {
        auto [fd, s1] = *mx.begin();
        auto [sd, s2] = *nmx.begin();
        sd = cur - sd;
        // cout << mx.size() - 1 << ' ' << nmx.size() - 1 << '\n';
        if (fd > 0 && sd > 0 && k == 0) break;
        if (1ll * min(fd, sd) * (mx.size() - 1) > k) {
            int can = k / (mx.size() - 1);
            cur -= can;
            k -= can * (mx.size() - 1);
            if ((mx.size() - 1) - k == 1) {
                cout << 2 * cur - 1 << '\n';
                return;
            } else {
                cout << 2 * cur << '\n';
                return;
            }
        }
        int can = min(fd, sd);
        k -= can * (mx.size() - 1);
        fd -= can;
        sd -= can;
        cur -= can;
        while (sd == 0) {
            nmx.erase(nmx.begin());
            mx.emplace(dpr[s2], s2);
            sd = nmx.begin()->x;
            sd = cur - sd;
        }
        if (fd == 0) {
            mx.erase(mx.begin());
            update(s1);
        }
    }
    cout << 2 * cur << '\n';
}