#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <cstdio>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <deque>
#include <bitset>
#include <algorithm>
#include <cmath>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <chrono>
#include <random>
#include <complex>
#include <numeric>
#include <assert.h>
#include <functional>
#include <climits>
#include <cstring>
#include <iterator>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using ushort = unsigned short;

#ifndef LOCAL
#define endl "\n"
#endif
#define f first
#define s second
#define vec vector
#define pii pair<int, int>
#define all(x) x.begin(), x.end()
#define pb push_back
#define mp make_pair
template<typename T1, typename T2>
istream& operator>> (istream &in, pair<T1, T2> &p) { in >> p.f >> p.s; return in; }
template<typename T1, typename T2>
ostream& operator<< (ostream &out, pair<T1, T2> p) { out << "(" << p.f << " " << p.s << ")"; return out; }
#define printv(v) cerr << #v << " "; for (auto &x : v) { cerr << x << " "; } cerr << endl;
#define printvv(v) cerr << #v << " "; for (auto &x : v) { for (auto &y : x) { cerr << y << " "; } cerr << endl; }
#define debug(x) cerr << #x << " " << x << endl;

template<typename T>
istream& operator>> (istream &in, vector<T> &v) {
    for (auto &x : v) {
        in >> x;
    }
    return in;
}
template<typename T>
ostream& operator<< (ostream &out, vector<T> v) {
    for (auto &x : v) {
        out << x << " ";
    }
    return out;
}
template<typename T>
void operator-=(vector<T> &v, int delta) {
    for (auto &x : v) {
        x -= delta;
    }
}
template<typename T>
void operator+=(vector<T> &v, int delta) {
    for (auto &x : v) {
        x += delta;
    }
}

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define double ld

int best = 1e9 + 1;

void init(const vector<int> &A, const vector<int> &B) {
    int n = A.size();
    for (auto &x : B) {
        best = min(best, x);
    }
}

double friendDrink(int Ma, int Mb, int La, int Ra) {
    if (La > 0) {
        return 0;
    }
    return ((double)Mb) / ((double)best);
}

#ifdef LOCAL
int main() {
    std::ios_base::sync_with_stdio(false); std::cin.tie(NULL);
    freopen("in.txt", "r", stdin);

    int n, q;
    std::cin >> n >> q;

    std::vector<int> A(n), B(n);
    for (int i = 0; i < n; i ++) {
        std::cin >> A[i] >> B[i];
    }
    init(A, B);

    for (int i = 0; i < q; i ++) {
        int a, b, l, r;
        std::cin >> a >> b >> l >> r;
        const auto ret = friendDrink(a, b, l, r);
        std::cout << fixed << setprecision(6) << ret << "\n";
    }

    return 0;
}

#endif