#include<bits/stdc++.h>
#include "soft_drinks.h"

using namespace std;

typedef long long ll;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

const double eps = 1e-7;
const ll INF = 1'000'000'000'000;

set<ll> all;

void init(const vector<int>& a, const vector<int>& b) {
	for (ll i = 0; i < a.size(); i++) {
		all.insert(a[i]);
	}
}

double friendDrink(int Ma, int Mb, int La, int Ra) {
	double ans = 0;
	auto it = all.lower_bound(La);
	if (it != all.end()) {
		ll x = *it;
		if (x < Ra) {
			ans = ((double)min(Ma, Mb)) / x;
		}
	}
	return ans;
}

#ifdef LOCAL
int main() {
        std::ios_base::sync_with_stdio(false); std::cin.tie(NULL);

        int n, q;
        std::cin >> n >> q;

        std::vector<int> A(n), B(n);
        for (int i = 0; i < n; i ++) {
                std::cin >> A[i] >> B[i];
        }
        init(A, B);

        for (int i = 0; i < q; i ++) {
                int a, b, l, r;
                std::cin >> a >> b >> l >> r;
                const auto ret = friendDrink(a, b, l, r);
                std::cout << ret << "\n";
        }

        return 0;
}
#endif
