#include <bits/stdc++.h>

#include "cycles.h"

using namespace std;

mt19937 rnd(INT_MAX);

int get_rnd() {
    int x = rnd();
    return x < 0 ? -x : x;
}

void to_do(vector<int> cycle) {
    if (cycle.size() == 1)
        return;
    int n = (int) cycle.size(), i = get_rnd() % n, j = get_rnd() % n;
    if (j == i) j = (j + 1) % n;
    int cnt = performSwap(cycle[i], cycle[j]);
    vector<int> c1 = {cycle[i]}, c2 = {cycle[j]};
    for (int v: cycle) {
        if (v == cycle[i] || v == cycle[j]) continue;
        int copy = performSwap(cycle[i], v);
        if (copy > cnt)
            c1.emplace_back(v);
        else
            c2.emplace_back(v);
        performSwap(cycle[i], v);
    }
    to_do(c1), to_do(c2);
}

void sortPermutation(int n) {
    int cnt = performSwap(0, 1);
    for (int i = 1; i < n; i++) {
        int get = performSwap(0, i);
        if (get < cnt) {
            cnt = get;
            continue;
        }
        performSwap(0, i);
    }
    vector<int> cycle;
    for (int i = 0; i < n; i++) cycle.emplace_back(i);
    to_do(cycle);
}