#include <bits/stdc++.h>

using namespace std;

pair<int,int> minB = {2e9,2e9};
pair<int,int> minA = {2e9,2e9};
pair<int,int> minB0 = {2e9,2e9};
pair<int,int> minA0 = {2e9,2e9};

typedef long double ld;
 
const ld INF = 1e18;
const ld EPS = 1e-8;

void init(const std::vector<int>& A, const std::vector<int>& B)
{
    for(int i = 0;i < A.size();++i)
    {
        if(minA.first > A[i])
        {
            minA = {A[i],B[i]};
        }
        if(minB.first > B[i])
        {
            minB = {B[i],A[i]};
        }
        if(minA0.first > A[i] && B[i] == 0)
        {
            minA0 = {A[i],B[i]};
        }
        if(minB0.first > B[i] && A[i] == 0)
        {
            minB0 = {B[i],A[i]};
        }
    }
}
double friendDrink(const int Ma, const int Mb, const int La, const int Ra)
{
    if(Ma == 0)
        return double(Mb)/minB0.first;
    else if(Mb == 0)
        return double(Ma)/minA0.first;
    ld maxb = min((minB.second == 0 ? INF : ld(Ma)/minB.second),(minB.first == 0 ? INF : ld(Mb)/minB.first));
    ld maxa = min((minA.first == 0 ? INF : ld(Ma)/minA.first),(minA.second == 0 ? INF : ld(Mb)/minA.second));
    if(abs(maxb*minB.first-Mb) < EPS)
    {
        return maxb;
    }
    else if(abs(maxa*minA.first-Ma) < EPS)
    {
        return maxa;
    }
    else
    {
        ld x = (ld(Ma)*minB.first-ld(Mb)*minB.second)/(ld(minA.first)*minB.first-ld(minA.second)*minB.second);
        ld y = (ld(Ma)*minA.second-ld(Mb)*minA.first)/(ld(minA.second)*minB.second-ld(minA.first)*minB.first);
        return x + y;
    }
}