#include <bits/stdc++.h>

using namespace std;

typedef long double ld;
typedef long long ll;
 
const ld INF = 1e18;
const ld EPS = 1e-8;
const int maxn = 5005;

vector<pair<int,int>> ab;

int ans[maxn][maxn];

ld znb(pair<int,int> a,pair<int,int> b)
{
    return (ld(b.second)*a.first-ld(a.second)*b.first)/(a.first-b.first);
}
ld zna(pair<int,int> a,pair<int,int> b)
{
    return (ld(b.first)*a.second-ld(a.first)*b.second)/(a.second-b.second);
}
ld getAns(pair<int,int> d1,pair<int,int> d2,int Ma,int Mb)
{
    //cout << d1.first << ' ' << d1.second << ' ' << d2.first << ' ' << d2.second << endl;
    if(ll(d1.first) * d2.second > ll(d1.second)*d2.first)
    {
        swap(d1,d2);
    }
    ld max2 = min((d2.second == 0 ? INF : ld(Mb)/d2.second),(d2.first == 0 ? INF : ld(Ma)/d2.first));
    ld max1 = min((d1.first == 0 ? INF : ld(Ma)/d1.first),(d1.second == 0 ? INF : ld(Mb)/d1.second));
    //cout << max1 << ' ' << max2 << endl;
    if(ll(d2.first)*Mb <= ll(Ma)*d2.second)
    {
        return max2;
    }
    else if(ll(d1.first)*Mb >= ll(Ma)*d1.second)
    {
        return max1;
    }
    else
    {
        //swap(d1,d2);
        ld x = (ld(Ma)*d2.second-ld(Mb)*d2.first)/(ld(d1.first)*d2.second-ld(d1.second)*d2.first);
        ld y = (ld(Ma)*d1.second-ld(Mb)*d1.first)/(ld(d1.second)*d2.first-ld(d1.first)*d2.second);
        //cout << x+y << endl;
        return max({x + y,max1,max2});
    }
}

void init(const std::vector<int>& A, const std::vector<int>& B)
{  
    for(int i = 0;i < A.size();++i)
    {
        ab.push_back({A[i],B[i]});
    }
    sort(ab.begin(),ab.end());
    for(int j = 0;j < A.size();++j)
    {
        for(int k = j;k < A.size();++k)
        {
            ans[j][k] = (j == k ? j : (getAns(ab[j],ab[k],ab[j].first+1,ab[j].second) > getAns(ab[j],ab[ans[j][k-1]],ab[j].first+1,ab[j].second) && ab[k].second < ab[j].second ? k : ans[j][k-1]));
        //     if(j == 1 && k == 2)
        //         cout << getAns(ab[j],ab[k],ab[j].first,ab[j].second + 1e9) << ' ' << getAns(ab[j],ab[ans[j][k-1]],ab[j].first,ab[j].second + 1e9) << ' ' << ans[j][k] << endl;
        }
    }
}


double friendDrink(const int Ma, const int Mb, const int La, const int Ra)
{
    int lg = lower_bound(ab.begin(),ab.end(),make_pair(La,-1))-ab.begin();
    int rg = lower_bound(ab.begin(),ab.end(),make_pair(Ra,int(ab.size())+1))-ab.begin()-1;
    ld res = 0;
    for(int j = lg;j <= rg;++j)
    {
        //cout << ans[j][rg] << ' ';
        res = max(res,getAns(ab[j],ab[j],Ma,Mb));
        res = max(res,getAns(ab[j],ab[ans[j][rg]],Ma,Mb));
    }
    return res;
}