#include <bits/stdc++.h>
#include "cycles.h"

using namespace std;

mt19937 rnd(228);

void makeOneCycle(int n)
{
    int x = performSwap(0,1);
    int cycles = performSwap(0,1);
    for(int i = 1;i < n;++i)
    {
        int cur = performSwap(i-1,i);
        if(cur > cycles)
        {
            performSwap(i-1,i);
        }   
    }
}

void sortPermutation(int n)
{
    makeOneCycle(n);
    // print();
    vector<vector<int>> cycles(1);
    for(int i = 0;i < n;++i)
    {
        cycles[0].push_back(i);
    } 
    while(cycles.size())
    {
        int sz = cycles.back().size();
        int x = rnd()%sz;
        int y = rnd()%(sz-1);
        y = (y >= x ? y+1 : y);
        x = cycles.back()[x];
        y = cycles.back()[y];
        //cout << sz << ' ' << x << ' ' << y << ' ' << cycles.back()[0] << ' ' << cycles.back()[1] << endl;
        int cur = performSwap(x,y);
        vector<int> fs,sc;
        fs.push_back(cycles.back()[0]);
        int p = 0;
        for(int j = 1;j < sz;++j)
        {
            int ne = performSwap(cycles.back()[j-1],cycles.back()[j]);
            if(ne < cur)
            {
                p ^= 1;
            }
            //cout << p << endl;
            (p == 0 ? fs.push_back(cycles.back()[j]) : sc.push_back(cycles.back()[j]));
            performSwap(cycles.back()[j-1],cycles.back()[j]);
        }
        cycles.pop_back();
        if(fs.size() > 1)
            cycles.push_back(fs);
        if(sc.size() > 1)
            cycles.push_back(sc);
        // for(auto x:fs)
        // {
        //     cout << x << ' ';
        // }
        // cout << "\n";
        // for(auto x:sc)
        // {
        //     cout << x << ' ';
        // }
        // cout << "\n";
        // print();
    }
    return ;
}