#include <bits/stdc++.h>

using namespace std;

const int maxn = 200005;

vector<vector<pair<int,int>>> g;
int diam1[maxn];
int diam2[maxn];
int dp1[maxn],dp2[maxn];
int ans =0;

pair<int,int> dfs(int v,int p)
{
    pair<int,int> ans = {0,v};
    for(auto [u,d]:g[v])
    {
        if(u != p)
        {
            pair<int,int> cc = dfs(u,v);
            ans = max(ans,{cc.first+d,cc.second});
        }
    }
    return ans;
}
void cd1(int v,int p)
{
    int fm = 0,sm = 0;
    diam1[v] = 0;
    dp1[v] = 0;
    for(auto [u,d] : g[v])
    {
        if(u != p)
        {
            cd1(u,v);
            dp1[v]  =max(dp1[v],dp1[u] + d);
            if(dp1[u]+d > fm)
            {
                sm = fm;
                fm = dp1[u]+d;
            }
            else if(dp1[u]+d > sm)
                sm = dp1[u] + d;
            diam1[v] = max(diam1[v],diam1[u]);
        }
    }
    diam1[v] = max(diam1[v],fm + sm);
    return ; 
}
void cd2(int v,int p)
{
    int fm = 0,sm = 0;
    diam2[v] = 0;
    dp2[v] = 0;
    for(auto [u,d] : g[v])
    {
        if(u != p)
        {
            cd2(u,v);
            dp2[v]  =max(dp2[v],dp2[u] + d);
            if(dp2[u]+d > fm)
            {
                sm = fm;
                fm = dp1[u]+d;
            }
            else if(dp2[u]+d > sm)
                sm = dp2[u] + d;
            diam2[v] = max(diam2[v],diam2[u]);
        }
    }
    diam2[v] = max(diam2[v],fm + sm);
    return ; 
}


bool dfs_check(int v,int f,int p,bool & low)
{
    if(v == f)
        return true;
    for(auto [u,d]:g[v])
    {
        if(u != p)
        {
            if(dfs_check(u,f,v,low))
            {
                if(diam1[u] < ans && diam2[v] < ans && d)
                {
                    low = 1;
                }
                return true;
            }
        }
    }
    return false;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n,k;
    cin >> n >> k;
    g.resize(n);
    for(int i = 0;i < n-1;++i)
    {
        int u,v,w;
        cin >> u >> v >> w;
        u--;
        v--;
        g[u].push_back({v,w});
        g[v].push_back({u,w});
    }
    int v = dfs(0,-1).second;
    ans = dfs(v,-1).first;
    int u = dfs(v,-1).second;
    cd1(v,-1);
    cd2(u,-1);
    bool low = 0;
    // << "!" << endl;
    dfs_check(v,u,-1,low);
//    cout << "!" << endl;
    cout << ans-low << "\n";
}