#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int INF = 2e9 + 100;
int ans = INF;
int n, k;
vector<vector<pair<int, int>>> gr;
vector<int> mx1, mxh;

void dfs1(int v, int pr) {
    for (auto e : gr[v]) {
        int u = e.first, w = e.second;
        if (u == pr) continue;
        dfs1(u, v);
        mx1[v] = max(mx1[v], mx1[u]);
        mx1[v] = max(mx1[v], mxh[v] + mxh[u] + w);
        mxh[v] = max(mxh[v], mxh[u] + w);
    }
}

void dfs2(int v, int pr, int mx2, int mxh2) { // mx2 - диаметр снаружи mx2h - максимальный путь снаружи
    vector<int> hs, mx2s;
    hs.push_back(mxh2);
    for (auto e : gr[v]) {
        int u = e.first, w = e.second;
        if (u == pr) continue;
        hs.push_back(mxh[u] + w);
        mx2s.push_back(mx1[u]);
    }
    sort(hs.rbegin(), hs.rend());
    while (hs.size() < 3) hs.push_back(0);
    sort(mx2s.rbegin(), mx2s.rend());
    while (mx2s.size() < 3) mx2s.push_back(0);
    for (auto e : gr[v]) {
        int u = e.first, w = e.second;
        if (u == pr) continue;
        {
            int mxh3 = hs[1];
            if (hs[0] != mxh[u] + w) mxh3 = hs[0];
            int a1 = mxh[u] + mxh3 + w - 1;
            int a2 = max(mx2, mx2s[0]);
            vector<bool> ffuck(3);
            for (int i = 0; i < 3; ++i) {
                if (hs[i] == mxh[u] + w) {
                    ffuck[i] = 1;
                    break;
                }
            }

            for (int i = 0; i < 3; ++i) {
                for (int j = i + 1; j < 3; ++j) {
                    if (ffuck[i]) continue;
                    if (ffuck[j]) continue;
                    a2 = max(a2, hs[i] + hs[j]);
                }
            }
            ans = min(ans, max(a1, a2));
        }
        int new_mxh2 = hs[1] + w;
        if (hs[0] != mxh[u] + w) new_mxh2 = hs[0] + w;
        int new_mx2 = max(mx2, mx2s[1]);
        if (mx2s[0] != mx1[u]) new_mx2 = max(new_mx2, mx2s[0]);
        vector<bool> ffuck(3);
        for (int i = 0; i < 3; ++i) {
            if (hs[i] == mxh[u] + w) {
                ffuck[i] = 1;
                break;
            }
        }

        for (int i = 0; i < 3; ++i) {
            for (int j = i + 1; j < 3; ++j) {
                if (ffuck[i]) continue;
                if (ffuck[j]) continue;
                new_mx2 = max(new_mx2, hs[i] + hs[j]);
            }
        }
        dfs2(u, v, new_mx2, new_mxh2);
    }
}

void solve() {
    cin >> n >> k;
    gr.resize(n);
    mx1.resize(n); mxh.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u; --v;
        gr[u].push_back({v, w});
        gr[v].push_back({u, w});
    }
    dfs1(0, -1);
    dfs2(0, -1, 0, 0);
    cout << ans << '\n';
}

int main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    solve();
}