#include<iostream>
#include<vector>
#include<string>
#include<set>
#include<map>
#include<queue>
#include<deque>
#include<stack>
#include<cmath>
#include<algorithm>
#include<iomanip>
#include<cstdio>
#include<bitset>
#include<random>
#include<ctime>
#include<unordered_map>
#include<unordered_set>

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;
using ll = long long;
using ld = long double;
using uint = unsigned int;
using ull = unsigned long long;

const int N = 5e3 + 2, inf = 2e9 + 100;
const ll llinf = 1e18 + 1000;

int n;
struct st {
    ll a, b;
};
bool cmp(st a, st b) {
    return a.a < b.a;
}
st a[N];
void init(const vector<int>& a1, const vector<int>& b1) {
    n = a1.size();
    for (int i = 0; i < n; ++i) {
        a[i].a = a1[i];
        a[i].b = b1[i];
    }
    sort(a, a + n, cmp);
}
ld get2(ll ma, ll mb, int i, int j) {
    ld k = (ld)a[j].b - ld(a[j].a * a[i].b) / a[i].a;
    ld s = (ld)mb - (ld)(a[i].b * ma) / a[i].a;
    ld k2 = s / k;
    ld k1 = ld(ma - k2 * a[j].a) / a[i].a;
    if (k1 < 0 || k2 < 0) return 0;
    return k1 + k2;
}
ld get1(ll ma, ll mb, int i) {
    return min((ld)ma / a[i].a, (ld)mb / a[i].b);
}
double friendDrink(int ma, int mb, int la, int ra) {
    int l = 0, r = n - 1;
    for (; l < n && a[l].a < la; ++l);
    for (; r >= 0 && a[r].a > ra; --r);
    ld ans = 0;
    for (int i = l; i <= r; ++i) {
        ans = max(ans, get1(ma, mb, i));
        for (int j = i + 1; j <= r; ++j) ans = max(ans, get2(ma, mb, i, j));
    }
    return ans;
}

//void solve() {
//    init({ 1, 2 }, { 2, 1 });
//    cout << friendDrink(100, 100, 0, 1) << '\n';
//}
//
//signed main() {
//    ios_base::sync_with_stdio(0);
//    cin.tie(0);
//    int tt = 1;
//    //cin >> tt;
//    while (tt--) {
//        solve();
//        cout << endl;
//    }
//    return 0;
//}