#include<iostream>
#include<vector>
#include<string>
#include<set>
#include<map>
#include<queue>
#include<deque>
#include<stack>
#include<cmath>
#include<algorithm>
#include<iomanip>
#include<cstdio>
#include<bitset>
#include<random>
#include<ctime>
#include<unordered_map>
#include<unordered_set>

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;
using ll = long long;
using ld = long double;
using uint = unsigned int;
using ull = unsigned long long;

const int N = 1000 + 2, inf = 2e9 + 100;
const ll llinf = 1e18 + 1000;

int performSwap(int x, int y);
int val = 0;
int rec(int l, int r) {
	if (r - l == 1) return -1;
	int m = (l + r) >> 1;
	int gl = rec(l, m);
	if (gl != -1) return gl;
	int gr = rec(m, r);
	if (gr != -1) return gr;
	int g = val;
	int ans = -1;
	for (int i = l; i + 1 < m; ++i) g = performSwap(i, i + 1);
	for (int i = m; i < r; ++i) {
		int g2 = performSwap(l, i);
		if (g2 > g) {
			ans = i;
			for (int j = i; j >= m; --j) performSwap(l, j);
			break;
		}
		g = g2;
	}
	if (ans == -1) {
		for (int j = r - 1; j >= m; --j) performSwap(l, j);
	}
	for (int i = m - 2; i >= l; --i) performSwap(i, i + 1);
	return ans;
}
void sortPermutation(int n) {
	val = performSwap(0, 1);
	val = performSwap(0, 1);
	int ind = rec(0, n);
	for (int i = 0; i < n; ++i) {
		if (i == ind) continue;
		if (performSwap(i, ind) == n) break;
		performSwap(i, ind);
	}
}

//void solve() {
//    
//}
//
//signed main() {
//    ios_base::sync_with_stdio(0);
//    cin.tie(0);
//    int tt = 1;
//    //cin >> tt;
//    while (tt--) {
//        solve();
//        cout << endl;
//    }
//    return 0;
//}