#include<iostream>
#include<vector>
#include<string>
#include<set>
#include<map>
#include<queue>
#include<deque>
#include<stack>
#include<cmath>
#include<algorithm>
#include<iomanip>
#include<cstdio>
#include<bitset>
#include<random>
#include<ctime>
#include<unordered_map>
#include<unordered_set>

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;
using ll = long long;
using ld = long double;
using uint = unsigned int;
using ull = unsigned long long;

const int N = 2e3 + 2, inf = 1e9 + 100;
const ll llinf = 1e18 + 1000;

int n, k, dp[N][N];
vector<pair<int, int>> g[N];
void dfs1(int v, int p) {
    for (int i = 0; i < g[v].size(); ++i) {
        int to = g[v][i].first;
        if (to == p) {
            swap(g[v][i], g[v].back());
            g[v].pop_back();
            --i;
            continue;
        }
        dfs1(to, v);
    }
}
void dfs(int v, int mxd) {
    for (auto i : g[v]) {
        int to = i.first;
        dfs(to, mxd);
    }
    for (int len = 0; len < n; ++len) {
        int len2 = min(len, mxd - len);
        dp[v][len] = len == 0 ? inf : dp[v][len - 1];
        if (g[v].size() == 0) dp[v][0] = 0;
        int sum = 0;
        for (int i = 0; i < g[v].size(); ++i) {
            int to = g[v][i].first;
            sum += min(len2 > 0 ? dp[to][len2 - 1] : inf, dp[to][len2] + 1);
        }
        for (int i = 0; i < g[v].size(); ++i) {
            int to = g[v][i].first;
            int val = min(len > 0 ? dp[to][len - 1] : inf, dp[to][len] + 1);
            int val2 = min(len2 > 0 ? dp[to][len2 - 1] : inf, dp[to][len2] + 1);
            dp[v][len] = min(dp[v][len], sum - val2 + val);
        }
    }
}

void solve() {
    cin >> n >> k;
    for (int i = 0; i + 1 < n; ++i) {
        int x, y, w;
        cin >> x >> y >> w;
        --x, --y;
        g[x].push_back({ y, w });
        g[y].push_back({ x, w });
    }
    dfs1(0, -1);
    int l = -1, r = n - 1;
    while (l + 1 < r) {
        int m = (l + r) >> 1;
        dfs(0, m);
        if (dp[0][m] <= k) r = m;
        else
            l = m;
    }
    cout << r;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
        cout << endl;
    }
    return 0;
}