// ConsoleApplication1.cpp : This file contains the 'main' function. Program execution begins and ends there.
//
#pragma GCC optimize("O3")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include "soft_drinks.h"

using namespace std;
using ll = long long;
using ld = long double;

//int main()
//{
//    ios_base::sync_with_stdio(false);
//    cin.tie(NULL);
//}

vector <int> a, b;

void init(const std::vector<int>& A, const std::vector<int>& B)
{
	a = A;
	b = B;
}

double GetBestB(double L, double A)
{
	double res = 1e9;
	if (L - 1e-6 > A)
		return res;
	int n = a.size();
	for (size_t i = 0; i < n; i++)
	{
		if (L - 1e-6 <= a[i] && a[i] <= A + 1e-6)
		{
			res = min(res, (double)b[i]);
		}
	}
	for (size_t i = 0; i < n; i++)
	{
		for (size_t j = 0; j < n; j++)
		{
			if (a[i] <= A + 1e-6 && A - 1e-6 <= a[j])
			{
				double x, y;
				if (abs(a[i] - A) < 1e-3)
					x = 1.0, y = 0.0;
				else if (abs(a[j] - A) < 1e-3)
					x = 0.0, y = 1.0;
				else
					y = (A - a[i]) / (double)(a[j] - a[i]), x = 1.0 - y;
				res = min(res, x * b[i] + y * b[j]);
			}
		}
	}
	return res;
}

double result(double Ma, double Mb, double A, double B)
{
	if (abs(A) < 0.0001 || abs(Ma) < 0.5)
	{
		return Mb / B;
	}
	if (abs(B) < 0.0001 || abs(Mb) < 0.5)
	{
		return Ma / A;
	}
	return min(Ma / A, Mb / B);
}

double friendDrink(const int Ma, const int Mb, const int La, const int Ra)
{
	double ans = result(Ma, Mb, La, GetBestB(La, La));
	double ql = ans, qr = Ma + 1;
	for (size_t i = 0; i < 100; i++)
	{
		double qm = (ql + qr) / 2.0;
		double res = Mb / max(GetBestB(La, Ma / qm), 0.001);
		if (res - qm > -1e-6)
			ql = qm;
		else
			qr = qm;
	}
	ans = max(ans, result(Ma, Mb, Ma / ql, GetBestB(La, Ma / ql)));
	return ans;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
