// ConsoleApplication1.cpp : This file contains the 'main' function. Program execution begins and ends there.
//
#pragma GCC optimize("O3")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using ll = long long;
using ld = long double;

const int MAXN = 2e5 + 10;
vector <pair<int, int>> g[MAXN];
ll ans = 0, D = 0;

ll dfs(int v, int p)
{
    //vector <int> cur;
    ll mx = 0, our = -1;
    bool dbl = false;
    for (auto& [i, w] : g[v])
    {
        if (i == p)
            continue;
        ll x = dfs(i, v) + w;
        if (x <= D / 2)
        {
            mx = max(mx, x);
            continue;
        }
        if (our == -1)
        {
            our = x;
            continue;
        }
        dbl = true;
        mx = D / 2;
        ans += (our - D / 2);
        our = x;
    }
    if (our != -1 && D < mx + our)
        ans += (1ll * our - (D - mx));
    else
        return max({ our, 0ll, mx });
    return D - mx;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n, k;
    cin >> n >> k;
    for (size_t i = 1; i < n; i++)
    {
        int a, b, c;
        cin >> a >> b >> c;
        a--; b--;
        g[a].emplace_back(b, c);
        g[b].emplace_back(a, c);
    }
    ll l = 0, r = 1e10;
    while (r - l > 1)
    {
        ll m = (l + r) / 2ll;
        D = m;
        ans = 0;
        dfs(0, 0);
        if (ans > k)
            l = m;
        else
            r = m;
    }
    cout << r << '\n';
    return 0;
}


// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
