﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <cmath>
#include <array>
#include <random>
#include <queue>

#include "cycles.h"
using namespace std;
typedef long long ll;
typedef long double ld;

void sortPermutation(int n) {
	performSwap(0, 1);
	int cnt = performSwap(0, 1);
	int i = 1;
	for (; i < n; i++) {
		int x = performSwap(0, i);
		if (x > cnt) {
			cnt = x;
			break;
		}
		cnt = x;
	}
	for (int j = i; j > 0; j--) {
		cnt = performSwap(0, j);
	}
	for (int j = 0; j < i; j++) {
		int x = performSwap(j, i);
		if (x > cnt) {
			break;
		} else {
			performSwap(j, i);
		}
	}
}

//int main() {
//	ios_base::sync_with_stdio(0);
//	cin.tie(0);
//	cout.tie(0);
//
//	return 0;
//}