#include <vector>
#include <algorithm>

using namespace std;

constexpr int INF = 1e9 + 7;

int n;

vector<int> a, b;

void init(const vector<int>& A, const vector<int>& B) {
    n = A.size();
    a = A, b = B;
}

double friendDrink(const int Ma, const int Mb, const int La, const int Ra) {
    vector<pair<int, int>> nw;
    for (int i = 0; i < n; ++i) {
        if (La <= a[i] && a[i] <= Ra) {
            nw.emplace_back(a[i], b[i]);
        }
    }
    sort(nw.begin(), nw.end());
    int pos = 0;
    int mn_b = INF;
    while (pos < (int)nw.size() && nw[pos].first == 0) {
        mn_b = min(mn_b, nw[pos].second);
        pos++;
    }
    if (pos == nw.size()) {
        return Mb / (double)mn_b;
    }
    double ans = Ma / (double)nw[pos].first;
    if (pos != 0) {
        ans += Mb / (double)mn_b;
    }
    while (pos + 1 < (int)nw.size()) {
        mn_b = min(mn_b, nw[pos].second);
        pos++;
        if (mn_b == 0) {
            break;
        }
        ans = min(ans, Ma / (double)nw[pos].first + Mb / (double)mn_b);
    }
    mn_b = min(mn_b, nw[pos].second);
    if (mn_b != 0) {
        ans = min(ans, Mb / (double)mn_b);
    }
    return ans;
}
