#include <vector>
#include <assert.h>

#include "cycles.h"

using namespace std;

void sortPermutation(int n) {
    performSwap(0, 1);
    int cnt_nw = performSwap(0, 1);
    int l = 1, r = n;
    while (l < r - 1) {
        int m = (l + r) / 2;
        int cnt_nw2 = cnt_nw;
        bool check = false;
        for (int i = 1; i < m; ++i) {
            int cnt_nxt2 = performSwap(0, i);
            if (cnt_nxt2 < cnt_nw2) {
                check = true;
            }
            cnt_nw2 = cnt_nxt2;
        }
        for (int i = m - 1; i > 0; ++i) {
            performSwap(0, i);
        }
        if (check) {
            r = m;
        } else {
            l = m;
        }
    }
    assert(l < n);
    for (int i = 0; i < l; ++i) {
        int cnt_nw = performSwap(i, l);
        if (cnt_nw == n) {
            return;
        }
        performSwap(i, l);
    }
}
