#include <bits/stdc++.h>
#include <vector>
#include "soft_drinks.h"
#include <cassert>

using namespace std;
using ll = long long;

#define all(x) (x).begin(), (x).end()
#define pb push_back
#define sz(x) (int)(x).size()

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

vector<pair<ll, ll>> dr;

void init(const std::vector<int>& A, const std::vector<int>& B) {
    int n = sz(A);
    for (int i = 0; i < n; i++) dr.pb({(ll)A[i], (ll)B[i]});
}
double friendDrink(const int Ma, const int Mb, const int La, const int Ra) {
    double ans = 0;
    for (int i = 0; i < sz(dr); i++) {
        if (dr[i].first >= La && dr[i].second <= Ra) {
            ans = max(ans, min(double(Ma) / double(dr[i].first), double(Mb) / double(dr[i].second)));
            for (int j = 0; j < sz(dr); j++) {
                if (dr[j].first >= La && dr[j].second <= Ra) {
                    auto relax = [&](double x) {
                        if (x < 0) return;
                        ans = max(ans, x + min(double(Ma - double(dr[i].first) * x) / dr[j].first, double(Mb - double(dr[i].second) * x) / dr[j].second));
                    };
                    relax(0); relax(min(double(Ma) / double(dr[i].first), double(Mb) / double(dr[i].second)));
                    // if (dr[i].first * dr[j].second == dr[i].second * dr[j].first) {
                    //     ans = max(ans, double(Ma + Mb) / double(1 + double(max(dr[i].first, dr[i].second) / min(dr[i].first, dr[i].second))));
                    // } else {
                    //     double A1 = dr[j].first, A = dr[i].first, B = dr[i].second, B1 = dr[j].second, L1 = Ma, L2 = Mb;
                    //     relax((A1 * L2 - B1 * L1) / (A1 * B - A * B1));
                    // }
                }
            }
        }
    }
    return ans;
}
