#include <bits/stdc++.h>
#include <vector>
#include "cycles.h"

using namespace std;

#define all(x) (x).begin(), (x).end()
#define pb push_back
#define sz(x) (int)(x).size()

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

void sortPermutation(int n) {
    int current = performSwap(0, 1);
    for (int i = 1; i < n; i++) {
        if (performSwap(0, i) >= current) {
            performSwap(0, i);
        }
    }
    vector<vector<int>> loops = {{}};
    for (int i= 0; i < n; i++) loops.back().pb(i);
    int mxsiz = n;
    while (mxsiz > 1) {
        vector<vector<int>> newloops;
        for (auto u : loops) {
            if (u.size() == 1) {
                newloops.pb(u); continue;
            }
            int p1 = rnd() % sz(u), p2 = (p1 + rnd() % (sz(u) - 1) + 1) % sz(u);
            int cur = performSwap(u[p1], u[p2]);
            newloops.pb({u[p1]});
            newloops.pb({u[p2]});
            for (int j = 0; j < sz(u); j++) {
                if (j != p1 && j != p2) {
                    if (performSwap(u[j], u[p1]) > cur) {
                        newloops.end()[-2].pb(u[j]);
                    } else {
                        newloops.back().pb(u[j]);
                    }
                    performSwap(u[j], u[p1]);
                }
            }
        }
        swap(loops, newloops);
        mxsiz = 1;
        for (auto u : loops) mxsiz = max(mxsiz, (int)u.size());
    }
}