#include <bits/stdc++.h>
#include <cassert>

using namespace std;
using ll = long long;

#define all(x) (x).begin(), (x).end()
#define pb push_back
#define sz(x) (int)(x).size()
#define int ll

void solve() {
    int n, k; cin >> n >> k;
    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < n - 1; i++) {
        int u, v, w; cin >> u >> v >> w;
        u--; v--;
        g[u].pb({v, w});
        g[v].pb({u, w});
    }

    int L = -1, R = 1e9;
    auto calc = [&](int M) {
        int made = 0;
        auto dfs = [&](int v, int p, auto&&self) -> int {
            vector<int> sons;
            for (auto [u, w] : g[v]) {
                if (u != p) {
                    sons.pb(w + self(u, v, self));
                }
            }
            if (sons.empty()) return 0;
            int mx = 0, mx2 = 0;
            for (int u : sons) {
                if (mx < u) {
                    mx2 = mx; mx = u;
                } else if (mx2 < u) mx2 = u;
            }
            if (mx + mx2 <= M) return mx;
            if (M % 2 == 0) {
                if (mx2 >= M / 2) {
                    int S = 0, S2 = 0;
                    for (int u : sons) {
                        S += u;
                        S2 += min(u, M / 2);
                    }
                    made += S - S2;
                    return M / 2;
                } else {
                    made += mx - (M - mx2);
                    return M - mx2;
                }
            } else {
                if (mx2 >= M / 2) {
                    int S = 0, S2 = 0;
                    for (int u : sons) {
                        S += u;
                        S2 += min(u, M / 2);
                    }
                    made += S - S2 - 1;
                    return M / 2 + 1;
                } else {
                    made += mx - (M - mx2);
                    return M - mx2;
                }
            }
        };
        dfs(0, 0, dfs);
        return made;
    };
    // for (int x = 0; x <= 12; x++) cout << calc(x) << ' ';
    // cout << '\n';
    while (R - L > 1) {
        int M = (L + R) / 2;
        int made = calc(M);
        //cout << M << ' ' << made << '\n';
        if (made <= k) R = M;
        else L = M;
    }
    cout << R << '\n';
}

signed main() {
    int tt = 1;
    #ifdef LOCAL 
        freopen("in.txt", "r", stdin);
        freopen("out.txt", "w", stdout);
        cin >> tt;
    #else 
        cin.tie(0)->sync_with_stdio(false);
    #endif

    while (tt--) {
        solve();
    }
}