#include <vector>
#include <iostream>

using namespace std;
using ll = long long;

vector<vector<pair<int, ll>>> g(2e5);

pair<int, ll> dfs(int v, int p = -1) {
	ll mx = 0; int vr = v;
	for (auto u : g[v]) {
		if (u.first != p) {
			auto rs = dfs(u.first, v);
			if (rs.second + u.second > mx) {
				mx = rs.second + u.second;
				vr = rs.first;
			}
		}
	}
	return { vr, mx };
}

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);

	int n, k;
	cin >> n >> k;
	for (int i = 0; i < n - 1; ++i) {
		int u, v, w;
		cin >> u >> v >> w;
		--u;
		--v;
		g[u].push_back({ v, w });
		g[v].push_back({ u, w });
	}

	int v = dfs(0).first;
	cout << dfs(v).second - k;

	return 0;
}
