#include <bits/stdc++.h>
using namespace std;
const long long mxN = 2e5+5;
const long long INF = 1e12;
vector<pair<long long, long long>> adj[mxN];
vector<long long> dist(mxN);
vector<int> parr(mxN);
long long n,k;
void dfs(int node, int par){
    parr[node]=par;
    for(auto next : adj[node]){
        if(next.first==par){
            continue;
        }
        dist[next.first]=dist[node]+next.second;
        dfs(next.first,node);
    }
}
pair<pair<long long, long long>, long long> find_diameter(){
    dist.assign(mxN,0);
    parr.assign(mxN,-1);
    dfs(1,0);
    long long currdist = -INF; long long a = -1;
    for(int i=1; i<=n; i++){
        if(dist[i]>currdist){
            a = i;
            currdist = dist[i];
        }
    }
    dist.assign(mxN,0);
    parr.assign(mxN,-1);
    dfs(a,0);
    long long ans = -INF;
    long long b = -1;
    for(int i=1; i<=n; i++){
        if(dist[i]>ans){
            ans = dist[i];
            b = i;
        }
    }
    return make_pair(make_pair(a,b),ans);
}
int main(){
    cin >> n >> k;
    for(int i=0; i<n-1; i++){
        long long a,b,c; cin >> a >> b >> c;
        adj[a].emplace_back(b,c);
        adj[b].emplace_back(a,c);
    }
    auto x = find_diameter(); auto a = x.first.first; auto b = x.first.second; auto c = x.second;
    vector<long long> path;
    long long tmp = b;
    while(tmp!=a){
        path.push_back(tmp);
        tmp = parr[tmp];
    }
    path.push_back(a);
    reverse(path.begin(),path.end());
    long long max_edge = -INF;
    pair<long long, long long> ends;
    for(int i=0; i<path.size()-1; i++){
        long long next = path[i+1];
        for(auto x : adj[i]){
            if(x.first==next){
                if(max_edge>x.second){
                    max_edge = x.second;
                    ends = make_pair(i,x.first);
                }
            }
        }
    }
    if(k==1){
    for(auto&x : adj[ends.first]){
        if(x.first==ends.second){
            x.second--;
        }
    }
    }
    cout << find_diameter().second;
}
