#include <bits/stdc++.h>
#include "soft_drinks.h"
using namespace std;
const long long MAXN=100009;
int N,mi=INT_MAX;
vector<pair<int,int>> dr;

long long min1(long long a,long long b)
{
    if(a>b)return b;
    return a;
}

long long max1(long long a,long long b)
{
    if(a<b)return b;
    return a;
}

struct node
{
    int l;
    int r;
    int v;
    void cons(int _l,int _r,int _v)
    {
        l=_l;
        r=_r;
        v=_v;
    }
};

node tree[4*MAXN];

void build(int n,int l,int r)
{
    tree[n].cons(l,r,0);
    if(l==r)return;
    build(2*n,l,(l+r)/2);
    build(2*n+1,(l+r)/2+1,r);
}

void change(int n,int v,int t)
{
    if(tree[n].l==tree[n].r)
    {
        tree[n].v=v;
        return;
    }

    if(t>tree[2*n].r)
    {
        change(2*n+1,v,t);
    }
    else
    {
        change(2*n,v,t);
    }

    tree[n].v=min1(tree[2*n].v,tree[2*n+1].v);
}

long long getAns(int n,int l,int r)
{
    if(tree[n].l==l&&tree[n].r==r)
    {
        return tree[n].v;
    }

    if(l>tree[2*n].r)
    {
        return getAns(2*n+1,l,r);
    }

    if(r<tree[2*n+1].l)
    {
        return getAns(2*n,l,r);
    }

    return min1(getAns(2*n,l,tree[2*n].r),getAns(2*n+1,tree[2*n+1].l,r));
}

void init(const std::vector<int>& A, const std::vector<int>& B)
{
    N=A.size();
    build(1,0,N-1);
    for(int i=0;i<N;i++)
    {
        dr.push_back({A[i],B[i]});
    }
    sort(dr.begin(),dr.end());
    for(int i=0;i<N;i++)change(1,max1(dr[i].first,dr[i].second),i);
}

double friendDrink(const int Ma, const int Mb, const int La, const int Ra)
{
    pair<int,int> t={La,0};
    int x=lower_bound(dr.begin(),dr.end(),t)-dr.begin();
    t={Ra+1,0};
    int y=lower_bound(dr.begin(),dr.end(),t)-dr.begin()-1;
    if(x==N||y==-1||x>y)return 0;
    //cout<<"  "<<x<<" "<<y<<endl;
    long double c=getAns(1,x,y);
    //cout<<"   "<<c<<endl;
    return (long double)(Ma)/c;
}
