#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAX = (2e5) + 5;

int n, k, p[MAX];
bool used[MAX];
vector<pair<int, int>> v[MAX];

void Dfs(int g, int dist)
{
    used[g] = 1;
    p[g] = dist;
    pair<int, int> nb;
    for (int i = 0; i < v[g].size(); i++)
    {
        nb = v[g][i];
        if (!used[nb.first])
            Dfs(nb.first, dist + nb.second);
    }
}

void Solve()
{
    cin >> n >> k;
    int x, y, w;
    for (int i = 1; i < n; i++)
    {
        cin >> x >> y >> w;
        v[x].push_back({y, w});
        v[y].push_back({x, w});
    }
    Dfs(1, 0);
    int maxs = 0, op;
    for (int i = 1; i <= n; i++)
    {
        if (maxs < p[i])
        {
            maxs = p[i];
            op = i;
        }
        used[i] = 0;
        p[i] = 0;
    }
    Dfs(op,0);
    maxs = 0;
    for (int i = 1; i <= n; i++)
    {
        maxs = max(maxs, p[i]);
    }
    cout << maxs << endl;
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    Solve();
    return 0;
}