#include <bits/stdc++.h>
using namespace std;

#define endl "\n"
#define out(x) #x << " = " << x << " "

#ifndef LOCAL
#define cerr \
    if (false) cerr
#endif

const int MAX_N = 2 * 1e5 + 10;
const int INF = 1e9 + 10;

int n, k;
vector<pair<int, int>> v[MAX_N];
int dist[MAX_N];
bool visited[MAX_N];
int cntDepth[MAX_N];
int maxDepth = 0;
int bfs(int start) {
    for (int i = 0; i < n; i++) {
        dist[i] = INF;
        visited[i] = false;
        cntDepth[i] = 0;
    }
    maxDepth = 0;

    queue<int> q;
    q.push(start);
    dist[start] = 0;

    int maxDist = 0, maxDistInd = -1;

    while (!q.empty()) {
        int current = q.front();
        q.pop();

        if (visited[current]) continue;
        visited[current] = true;

        for (int i = 0; i < v[current].size(); i++) {
            int sus = v[current][i].first;
            int ds = v[current][i].second;
            if (dist[sus] <= dist[current] + ds || visited[sus]) continue;
            dist[sus] = dist[current] + ds;
            cntDepth[dist[sus]]++;
            maxDepth = max(maxDepth, dist[sus]);
            q.push(sus);

            if (maxDist < dist[sus]) {
                maxDist = dist[sus];
                maxDistInd = sus;
            }
        }
    }

    return maxDistInd;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int longest = 0;
    pair<int, int> indA, indB;

    cin >> n >> k;
    for (int i = 0; i < n - 1; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;

        v[a].push_back({b, c});
        v[b].push_back({a, c});
    }

    int start = bfs(0);
    int end = bfs(start);

    while (k >= cntDepth[maxDepth]) {
        k -= cntDepth[maxDepth];
        maxDepth--;
    }
    cout << maxDepth << endl;

    return 0;
}