# include <iostream>
# include <vector>
# include <algorithm>
using namespace std;
# include "soft_drinks.h"
//# include "Lgrader.cpp"

const int MAX=1e5+11;

struct drink
{
    double x,y;
};

int n;
drink a[MAX];

void init(const std::vector<int>& A, const std::vector<int>& B)
{
    n=A.size();
    for(int i=0;i<n;i++) a[i+1]={A[i],B[i]};
}

double calc(double Ma, double Mb, drink A)
{
    double ans=1e9+1;
    if(A.x!=0) ans=min(ans,Ma/A.x);
    if(A.y!=0) ans=min(ans,Mb/A.y);
    return ans;
}

double friendDrink(int Ma, int Mb, int La, int Ra)
{
    vector<drink> use;
    for(int i=1;i<=n;i++)
    {
        if(La<=a[i].x and a[i].x<=Ra) use.push_back(a[i]);
    }

    int sz=use.size();
    //cout<<"->"<<sz<<"\n";
    double ans=0;
    for(int i=0;i<sz;i++)
    {
        drink A=use[i];
        ans=max(ans,calc(Ma,Mb,A));
    }

    for(int i=0;i<sz;i++)
    {
        for(int j=0;j<sz;j++)
        {
            if(i==j) continue;

            drink A=use[i],B=use[j];
            double curr=0;
            curr+=calc(Ma,Mb,A);
            curr+=calc(Ma-curr*A.x,Mb-curr*A.y,B);
            ans=max(ans,curr);
        }
    }

    return ans;
}
