#include <iostream>
#include <vector>
#include <cassert>
#include <algorithm>
#include "cycles.h"

static int64_t cnt = 0;
static std::vector<int> perm;
static int64_t n;

static int findPermCount()
{
    std::vector<bool> used(n, false);
    int64_t cntc = 0;
    for (int64_t i = 0; i < n; i ++)
    {
        if (used[i])
        {
            continue;
        }
        int64_t curr = i;
        cntc ++;
        while (!used[curr])
        {
            used[curr] = true;
            curr = perm[curr];
        }
    }
    return cntc;
}

int idx[1024];
void sortPermutation(int n)
{
    for(int i=0; i<n-1; i++)
    {
        idx[i] = i;
    }
    for(int i=0; i<n; i++)
    {
        if(perm[i] != i)
        {
            int m = perm[i];
            performSwap(i, m);
        }

    }
}
