#include "cycles.h"
#include<iostream>
#include<ctime>
#include<random>

using namespace std;

typedef long long ll;

mt19937 rng(time(nullptr));

void sortPermutation(int n)
{
    int best = 0;
    while(1)
    {
        if(best == n)
            return;

        int first = rng() % n;
        int second = rng() % n;

        while(first == second)
            second = rng() % n;

        int cycles = performSwap(first, second);

        if(cycles > best)
        {
            best = cycles;
        }
        else
        {
            performSwap(first, second);
        }
    }
}