#include "cycles.h"
#include<iostream>
#include<ctime>
#include<random>
#include<cassert>

using namespace std;

typedef long long ll;

mt19937 rng(time(nullptr));

void sortPermutation(int n)
{
    int best = 0;
    for(int i = 0; i < n - 1; i += 2)
    {
        int cur = performSwap(i, i + 1);

        if(cur > best)
        {
            best = cur;
        }
        else
        {
            performSwap(i, i + 1);
        }
    }

    assert(best == n);
}