#include "cycles.h"
#include<iostream>
#include<ctime>
#include<random>
#include<cassert>

using namespace std;

typedef long long ll;

mt19937 rng(time(nullptr));

void sortPermutation(int n)
{
    int best = n - 1;
    vector < bool > tru(n, false);

    for(int i = 0; i < n; i++)
    {
        for(int j = n - 1; j > i; j--)
        {
            if(best == n)
                return;

            int cur = performSwap(i, j);

            if(cur > best)
            {
                best = cur;
            }
            else
            {
                performSwap(i, j);
                break;
            }
        }

    }

    assert(best == n);
}