#include <bits/stdc++.h>
#define int long long
#define endl '\n'

using namespace std;

const int N = 2e5 + 5;

int n, k;
vector < pair <int, int> > g[N];

int dp_down[N][2];
int dp[N];

void dfs1(int u, int p)
{
    for (auto c : g[u])
    {
        int v = c.first;
        int w = c.second;

        if (v == p)
        {
            continue;
        }

        dfs1(v, u);

        if (dp_down[u][0] <= dp_down[v][0] + w)
        {
            dp_down[u][1] = dp_down[u][0];
            dp_down[u][0] = dp_down[v][0] + w;
        }
        else
        {
            dp_down[u][1] = max(dp_down[v][0] + w, dp_down[u][1]);
        }
    }
}

int ass = 0;

void dfs2(int u, int p)
{
    dp[u] = dp_down[u][0] + dp_down[u][1];

    for (auto c : g[u])
    {
        int v = c.first;
        int w = c.second;

        if (v == p)
        {
            continue;
        }

        dfs2(v, u);
        ///dp[u] = max(dp[u], dp_down[]);
    }
}

signed main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> k;

    for (int i = 1; i < n; i++)
    {
        int u, v, w;

        cin >> u >> v >> w;

        g[u].push_back({v, w});
        g[v].push_back({u, w});
    }

    dfs1(1, 0);
    dfs2(1, 0);

    for (int i = 1; i <= n; i++)
    {
        ///cout << "i: " << i << " " << dp[i] << " " << dp_down[i][0] << " " << dp_down[i][1] << endl;

        ass = max(ass, dp[i]);
    }

    if (k == 1)
    {
        ass = max(ass, 0LL);
    }

    cout << ass << endl;

    return 0;
}
/**
8 0
1 8 10
1 2 1
2 3 2
2 5 4
3 4 3
2 6 5
6 7 6
**/