#include "soft_drinks.h"
#include <bits/stdc++.h>

using namespace std;

const int maxn=1e5+5;
int n,a[maxn],b[maxn];

double drink(int idx,int Ma,int Mb)
{
    double d1=(double(Ma))/(double(a[idx]));
    double d2=(double(Mb))/(double(b[idx]));
    double curr=min(d1,d2);
    return curr;
}

double binsearch(double Ma,double Mb)
{
    if(a[0]>a[1])
    {
        swap(a[0],a[1]);
        swap(b[0],b[1]);
    }
    double l=0,r=1e9,mid0;
    double curra,currb,mid1;
    while(l<=r)
    {
        mid0=(l+r)/2;
        curra=mid0*a[0];
        mid1=(Ma-curra)/a[1];
        currb=(mid0*b[0])+(mid1*b[1]);
        if(currb>Mb)
            l=mid0+0.01;
        else
            r=mid0-0.01;
    }
    curra=l*a[0];
    mid1=(Ma-curra)/a[1];
    return l+mid1;
}

double friendDrink(int Ma, int Mb, int La, int Ra)
{
    if((!(a[0]>=La&&a[0]<=Ra))&&(!(a[1]>=La&&a[1]<=Ra)))
        return 0;
    else if(!(a[0]>=La&&a[0]<=Ra))
        return drink(1,Ma,Mb);
    else if(!(a[1]>=La&&a[1]<=Ra))
        return drink(0,Ma,Mb);
    else
    {
        double ret=binsearch(double(Ma),double(Mb));
        return ret;
    }
}

void init(const std::vector<int>& A, const std::vector<int>& B)
{
    n=A.size();
    for(int i=0;i<A.size();i++)
        a[i]=A[i];
    for(int i=0;i<B.size();i++)
        b[i]=B[i];
}
