#include <bits/stdc++.h>

using namespace std;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

struct edge
{
    int ver,dist;
    edge(){};
    edge(int ve,int di)
    {
        ver=ve;
        dist=di;
    }
};

const int maxn=2e5+5;
int n,k,idx,start[2],maxnode,secondinpath[2];
vector<edge>v[maxn];
long long maxpath,max2;

void dfs(int node,int parent,long long path,int scd)
{
    if(v[node].size()==1&&path>maxpath)
    {
        maxpath=path;
        maxnode=node;
        secondinpath[idx]=scd;
        return;
    }

    for(edge i : v[node])
    {
        if(i.ver!=parent)
        {
            if(node==start[idx])
                dfs(i.ver,node,path+i.dist,i.ver);
            else
                dfs(i.ver,node,path+i.dist,scd);
        }
    }
}

void find_diameter()
{
    maxpath=0;
    start[0]=1;
    idx=0;
    dfs(1,-1,0,0);

    maxpath=0;
    start[1]=maxnode;
    idx++;
    dfs(maxnode,-1,0,0);
}

void dfs2(int node,int parent,long long path)
{
    if(v[node].size()==0&&path>max2)
    {
        max2=path;
        return;
    }
    for(edge i : v[node])
    {
        if(i.ver!=parent)
        {
            if(node==start[idx]&&i.ver==secondinpath[idx])
                continue;
            else
                dfs2(i.ver,node,path+i.dist);
        }
    }
}

void read()
{
    cin>>n>>k;
    int a,b,c;
    for(int i=1;i<n;i++)
    {
        cin>>a>>b>>c;
        v[a].push_back({b,c});
        v[b].push_back({a,c});
    }

    find_diameter();

    if(k==1)
    {
        idx=0;
        max2=0;
        dfs2(1,-1,0);
        idx++;
        dfs2(start[idx],-1,0);

        if(max2==maxpath)
            cout<<maxpath<<endl;
        else
            cout<<maxpath-1<<endl;
    }
    else
        cout<<maxpath<<endl;
}

int main()
{
    speed();
    read();
    return 0;
}
