#include "soft_drinks.h"
#define INF 1000000000
#include <algorithm>

using namespace std;
vector <int> kiselinost;

void init(const vector<int>& A, const vector<int>& B)
{
    kiselinost.resize(B.size());
    for (int i = 0; i < B.size(); i++)
    {
        kiselinost[i] = B[i];
    }
    sort(kiselinost.begin(), kiselinost.end());
}


double friendDrink(int Ma, int Mb, int La, int Ra)
{
    int minKiselinost = INF;
    for (int i = 0; i < kiselinost.size(); i++)
    {
        if (kiselinost[i] >= La)
        {
            minKiselinost = min(minKiselinost, kiselinost[i]);
            break;
        }
    }
    double a = min(Ma, Mb) / (double)minKiselinost;
    double b = (max(Ma, Mb) - min(Ma, Mb)) / (double)minKiselinost;
    //cout << a << " " << b << endl;
    return a + b;
}
