#include <bits/stdc++.h>
#define endl '\n'
#define pii pair<int, int>
#define INF 1000000
using namespace std;

int n, k;
vector < vector <pii> > v;
priority_queue <pii, vector<pii>, greater<pii>  > pq;
vector <int> d;
vector <bool> used;

void dijkstra(int s)
{
    used.resize(n + 1, false);
    d.resize(n + 1 , INF);
    d[s] = 0;
    pq.push({0, s});
    while (!pq.empty())
    {
        s = pq.top().second;
        //int sdist = pq.top().first;
        //cout << s << endl;
        pq.pop();

        //if (d[s] + sdist < d[s]) continue;
        //if (used[s]) continue;
        //used[s] = true;

        for (auto edge : v[s])
        {
            //cout << edge.first << " " << edge.second;
            if (d[s] + edge.first < d[edge.second])
            {
                d[edge.second] = d[s] + edge.first;
                pq.push({d[edge.second], edge.second});
                //used[edge.second] = true;
                //cout << edge.first << " " << d[edge.second] << endl;
            }
        }
    }
}

int main ()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> k;
    v.resize(n + 1);
    for (int i = 0; i < n - 1; i++)
    {
        int from, to, tg;
        cin >> from >> to >> tg;
        v[from].push_back({tg, to});
    }

    dijkstra(1);
    int maxD = 0;
    /*for (int i = 0; i < v.size(); i++)
    {
        for (int j = 0; j < v[i].size(); j++)
        {
            cout << v[i][j].first << " " << v[i][j].second << endl;
        }
    }*/
    for (int i = 1; i < n + 1; i++)
    {
        maxD = max(maxD, d[i]);
    }
    cout << maxD << endl;
}


