#include "soft_drinks.h"
#include <bits/stdc++.h>
using namespace std;

vector<pair<int,int>> wut(1,{-INT_MAX,-INT_MAX});
int n;

vector<int> seg(500001,INT_MAX);

void build(int l, int r, int x) {
    if(l == r) {
        seg[x] = wut[l].second;
        return;
    }
    int mid = (l+r)/2;
    build(l,mid,x*2);
    build(mid+1,r,x*2+1);
    seg[x] = min(seg[x*2],seg[x*2+1]);
}

int calc(int l, int r, int ql, int qr, int x) {
    if(l == ql && r == qr) {
        return seg[x];
    }
    int mid = (l+r)/2;
    if(qr <= mid) {
        return calc(l,mid,ql,qr,x*2);
    }
    else if(ql > mid) {
        return calc(mid+1,r,ql,qr,x*2+1);
    }
    else {
        return min(calc(l,mid,ql,mid,x*2),calc(mid+1,r,mid+1,qr,x*2+1));
    }
}

int dude(int x) {
    int l = 0,r = wut.size()-1;
    while(l < r) {
        int mid = (l+r+1)/2;
        if(wut[mid].first <= x) {
            l = mid;
        }
        else {
            r = mid-1;
        }
    }
    return l;
}

double friendDrink(int Ma, int Mb, int La, int Ra) {
    int l = dude(La-1)+1,r = dude(Ra);
    if(l > r) {
        return 0;
    }
    double z = calc(1,n,l,r,1);
    return (double)Mb/z;
}

void init(const std::vector<int>& a, const std::vector<int>& b) {
    n = a.size();
    for(int i = 0; i < n; i++) {
        wut.push_back({a[i],b[i]});
    }
    sort(wut.begin(),wut.end());
    build(1,n,1);
}
