#include "soft_drinks.h"
#include <bits/stdc++.h>
using namespace std;

vector<int> a(0);
vector<int> b(0);
int n;

double calc(int a, int b, int c, int d) {
    double ans = LLONG_MAX;
    if(c > 0) {
        ans = min(ans,(double)a/(double)c);
    }
    if(d > 0) {
        ans = min(ans,(double)b/(double)d);
    }
    return ans;
}

double friendDrink(int Ma, int Mb, int La, int Ra) {
    double ans = 0;
    pair<double,double> x = {-1,-1},y = {-1,-1};
    if(a[0] >= La && a[0] <= Ra) {
        ans = max(ans,calc(Ma,Mb,a[0],b[0]));
        x = {a[0],b[0]};
    }
    if(n > 1 && a[1] >= La && a[1] <= Ra) {
        ans = max(ans,calc(Ma,Mb,a[1],b[1]));
        y = {a[1],b[1]};
    }
    if(x.first != -1 && y.first != -1) {
        if(x.first/x.second < y.first/y.second) {
            swap(x,y);
        }
        double z = (double)Ma/(double)Mb;
        if(x.first/x.second <= z && x.first/x.second >= z) {
            double k = (z*y.second-y.first)/(x.first-z*x.second-y.first+z*y.second);
            double br = k*(x.first+x.second)+(1-k)*(y.first+y.second);
            ans = max(ans,((double)(Ma+Mb))/br);
        }
    }
    return ans;
}

void init(const std::vector<int>& A, const std::vector<int>& B) {
    n = a.size();
    a = A;
    b = B;
}
