#include "soft_drinks.h"
#include <bits/stdc++.h>
using namespace std;

vector<int> a(0);
vector<int> b(0);
int n;

long long s(pair<long long,long long> x, pair<long long,long long> y) {
    return (x.first+y.first)*(y.second-x.second);
}

long long yay(pair<long long,long long> a, pair<long long,long long> b, pair<long long,long long> c) {
    return s(a,b)+s(b,c)+s(c,a);
}

double calc(int a, int b, int c, int d) {
    double ans = LLONG_MAX;
    if(c > 0) {
        ans = min(ans,(double)a/(double)c);
    }
    if(d > 0) {
        ans = min(ans,(double)b/(double)d);
    }
    return ans;
}

double apple(int Ma, int Mb, pair<double,double> x, pair<double,double> y) {
    double ans = 0;
    if(x.first != -1 && y.first != -1) {
        if(x.first/x.second > y.first/y.second) {
            swap(x,y);
        }
        double z = (double)Ma/(double)Mb;
        if(x.first/x.second <= z && y.first/y.second >= z) {
            double k = (z*y.second-y.first)/(x.first-z*x.second-y.first+z*y.second);
            double br = k*(x.first+x.second)+(1-k)*(y.first+y.second);
            ans = max(ans,((double)(Ma+Mb))/br);
        }
    }
    return ans;
}

double friendDrink(int Ma, int Mb, int La, int Ra) {
    vector<pair<int,int>> wut(0);
    double ans = 0;
    for(int i = 0; i < n; i++) {
        if(a[i] >= La && a[i] <= Ra) {
            ans = max(ans,calc(Ma,Mb,a[i],b[i]));
            wut.push_back({a[i],b[i]});
        }
    }
    sort(wut.begin(),wut.end());
    vector<pair<double,double>> wow(0);
    int sm = INT_MAX;
    for(int i = 0; i < wut.size(); i++) {
        if(wut[i].second < sm) {
            sm = wut[i].second;
            while(wow.size() >= 2) {
                pair<double,double> a = wow[wow.size()-2];
                pair<double,double> b = wow[wow.size()-1];
                if(yay(a,b,wut[i]) >= 0LL) {
                    wow.pop_back();
                }
                else {
                    break;
                }
            }
            wow.push_back(wut[i]);
        }
    }
    if(wow.size() >= 2) {
        for(int i = 0; i < wow.size(); i++) {
            for(int j = i+1; j < wow.size(); j++) {
                ans = max(ans,apple(Ma,Mb,wow[i],wow[j]));
            }
        }
    }
    return ans;
}

void init(const std::vector<int>& A, const std::vector<int>& B) {
    n = A.size();
    a = A;
    b = B;
}
