#include "cycles.h"
#include <bits/stdc++.h>

using namespace std;

bool filled[1005];

void proceed(int n, int which)
{
    //cout << "here " << which << endl;

    int other = (which == 0 ? 1 : 0);

    performSwap(which, other);
    int c = performSwap(which, other);

    int pos1 = -1, pos2 = -1;

    vector<int> posses;

    for (int i = which + 1; i < n; ++i)
    {
        if (!filled[i]) posses.push_back(i);
    }

    random_shuffle(posses.begin(), posses.end());

    for (int i = 0; i < posses.size(); ++i)
    {
        int p = posses[i];

        int curr = performSwap(p, which);
        if (curr > c)
        {
            if (pos1 == -1) pos1 = p;
            else pos2 = p;
        }

        performSwap(p, which);
    }

    //cout << which << " :: " << pos1 << " " << pos2 << endl;

    int pos = -1;

    if (pos1 == -1 && pos2 == -1)
    {
        pos = which;
        filled[pos] = true;
    }
    else if (pos2 == -1)
    {
        pos = pos1;
        filled[pos] = true;
        performSwap(which, pos);
    }
    else
    {
        performSwap(which, pos1);
        int curr1 = performSwap(pos1, pos2);

        //cout << "return 1" << endl;

        performSwap(pos1, pos2);
        performSwap(which, pos1);

        performSwap(which, pos2);
        int curr2 = performSwap(pos2, pos1);

        //cout << "return 2" << endl;

        performSwap(pos2, pos1);
        performSwap(which, pos2);

        //cout << curr1 << " " << curr2 << endl;

        if (curr1 > curr2)
        {
            //cout << "HERE" << endl;
            performSwap(which, pos1);
            performSwap(pos1, pos2);
            filled[which] = true;
            filled[pos1] = true;
        }
        else
        {
            performSwap(which, pos2);
            performSwap(pos2, pos1);
            filled[which] = true;
            filled[pos2] = true;
        }
    }
}

void sortPermutation(int n)
{
    int c;

    for (int i = 0; i < n; ++i)
    {
        filled[i] = false;
    }

    for (int i = 0; i < n; ++i)
    {
        if (filled[i] == false)
        {
            proceed(n, i);
            //cout << "---------------------------------" << endl;
        }
    }
}
