#include <bits/stdc++.h>

using namespace std;

const int maxn = 2e5 + 5;

int n, k;
vector<pair<int, int>> g[maxn];

pair<long long, int> longest;
int root;

int cnt = 0;

void dfs(int node, int par, int w)
{
    if (longest.first < w)
    {
        cnt = 1;
        longest = {w, node};
    }
    else if (longest.first == w)
    {
        ++cnt;
    }

    for (auto [to, add] : g[node])
    {
        if (to != par) dfs(to, node, w + add);
    }
}

int cntBad = 0;

void dfs2(int node, int par, int w)
{
    if (w == longest.first)
    {
        if (par == root) ++cntBad;
    }

    for (auto [to, add] : g[node])
    {
        if (to != par) dfs(to, node, w + add);
    }
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> k;

    for (int i = 1; i < n; ++i)
    {
        int x, y, w;
        cin >> x >> y >> w;

        g[x].push_back({y, w});
        g[y].push_back({x, w});
    }

    longest = {0, -1};
    dfs(1, -1, 0);

    int node = longest.second;
    longest = {0, -1};
    dfs(node, -1, 0);

    root = node;
    dfs2(root, -1, 0);

    if (cntBad >= 2) cout << longest.first << endl;
    else if (cntBad == 1 && cnt == 1) cout << longest.first - 1 << endl;
    else cout << longest.first - 1 << endl;

    return 0;
}
