#include <bits/stdc++.h>

using namespace std;

const int maxn = 2e5 + 5;

int n, k;
vector<pair<int, int>> g[maxn];

pair<int, int> longest;
int root;

int cnt = 0;
int parent[maxn];

void dfs(int node, int par, int w)
{
    parent[node] = par;

    if (longest.first < w)
    {
        longest = {w, node};
    }

    for (auto [to, add] : g[node])
    {
        if (to != par) dfs(to, node, w + add);
    }
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> k;

    for (int i = 1; i < n; ++i)
    {
        int x, y, w;
        cin >> x >> y >> w;

        g[x].push_back({y, w});
        g[y].push_back({x, w});
    }

    longest = {0, -1};
    dfs(1, -1, 0);

    int node = longest.second;
    longest = {0, -1};
    dfs(node, -1, 0);

    int curr = longest.second;

    while (true)
    {
        if (parent[curr] == node)
        {
            break;
        }

        curr = parent[curr];
    }

    for (auto& [to, add] : g[node])
    {
        if (to == curr)
        {
            --add;
            break;
        }
    }

    longest = {0, -1};
    dfs(1, -1, 0);

    node = longest.second;
    longest = {0, -1};
    dfs(node, -1, 0);

    cout << longest.first << endl;

    return 0;
}
