#include<bits/stdc++.h>
#define endl "\n"
using namespace std;
vector<pair<int,int> > g[200010];
int depth[200010];
int maxDepth[200010];
int P[200010];
void dfs(int u,int par){
    maxDepth[u] = 0;
    P[u]=par;
    for(auto p: g[u]){
        int v = p.first;
        if(v==par) continue;
        int w = p.second;
        depth[v] = depth[u]+w;
        dfs(v,u);
        maxDepth[u] = max(maxDepth[u],maxDepth[v]+w);
    }
}
vector<pair<int,int> > pathUV;
bool dfs2(int u,int par,int en){
    if(u==en) return true;
    for(auto p: g[u]){
        int v = p.first;
        if(v==par) continue;
        int w = p.second;
        if(dfs2(v,u,en)){
            pathUV.push_back({v,w});
            return true;
        }
    }
    return false;
}
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n,k;
    cin>>n>>k;
    for(int i=0;i<n-1;i++){
        int u,v,w;
        cin>>u>>v>>w;
        u--;
        v--;
        g[u].push_back({v,w});
        g[v].push_back({u,w});
    }
    dfs(0,-1);
    int U,V,X = 0;
    for(int i=0;i<n;i++){
        if(X<depth[i]){
            X = depth[i];
            U = i;
        }
        depth[i] = 0;
    }
    dfs(U,-1);
    X = 0;
    for(int i=0;i<n;i++){
        if(X<depth[i]){
            X = depth[i];
            V = i;
        }
        depth[i] = 0;
    }
    dfs2(U,-1,V);
    /*for(auto p: pathUV){
        cout<<p.first<<" "<<p.second<<endl;
    }*/
    int sum = 0,idx = 0;
    while(sum<X/2){
        sum+=pathUV[idx++].second;
    }
    if(max(sum,X-sum)>max(sum-pathUV[idx-1].second,X-sum+pathUV[idx-1].second)){
        idx--;
        sum-=pathUV[idx].second;
    }
    int center = pathUV[idx].first;
    //cout<<center<<" ";
    dfs(center,-1);
    priority_queue<pair<pair<int,int>,int> > pq;
    for(auto p: g[center]){
        int v = p.first;
        int w = p.second;
        pq.push({{maxDepth[v]+w,w},v});
    }
    while(true){
        auto pp = pq.top();
        pq.pop();
        int delta = min(k,min(max(1,pp.first.first-pq.top().first.first),pp.first.second));
        pp.first.first-=delta;
        pp.first.second-=delta;
        k-=delta;
        if(k==0) break;
        if(pp.first.second==0){
            for(auto p: g[pp.second]){
                int v = p.first;
                if(v==P[pp.second]) continue;
                int w = p.second;
                pq.push({{maxDepth[v]+w,w},v});
            }
        }
        else pq.push(pp);
    }
    int ans = pq.top().first.first;
    pq.pop();
    ans += pq.top().first.first;
    cout<<ans;
    return 0;
}
