#include<bits/stdc++.h>
#include "soft_drinks.h"
using namespace std;

vector<int> A, B;
void init(const std::vector<int>& _A, const std::vector<int>& _B) {
    A = _A;
    B = _B;
}
double friendDrink(const int Ma, const int Mb, const int La, const int Ra) {
    if(A[0] > Ra || A[0] < La) {
        return min(Ma/(double)A[1], Ma/(double)B[1]);
    }
    if(A[1] > Ra || A[1] < La) {
        return min(Ma/(double)A[0], Ma/(double)B[0]);
    }

    double r = 0.5;
    double margin = 0.25;
    double v = min(Ma/((double)A[0] * r + (double)A[1] * (1-r)), Mb/((double)B[0] * r + (double)B[1] * (1-r)));
    while(margin > 0.000001) {
        r+= margin;
        double new_v = min(Ma/((double)A[0] * r + (double)A[1] * (1-r)), Mb/((double)B[0] * r + (double)B[1] * (1-r)));
        if(new_v < v) {
            r -= margin * 2;
        } else {
            v = new_v;
        }
        margin /= 2;
    }
    return v;
}