#include <iostream>
#include <vector>
#include <cassert>
#include <algorithm>
#include "cycles.h"


void sortPermutation(int N) {
	int val = performSwap(0, 1);
	val = performSwap(0, 1);
	bool nevinen[1069];

	for (int i = 0; i < 1069; i++) nevinen[i] = false;

	for (int i = 0; i < (N-1); i++) {
		if (performSwap(i, i+1) == val) {
			nevinen[i] = true;
			nevinen[i+1] = true;
		}
	}
	
	std::vector <int> inds;
	for (int i = 0; i < N; i++) {
		if (!nevinen[i]) inds.push_back(i);
	}
	
	performSwap(inds[0], inds[1]);
}