#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 200008
using namespace std;

int ans = 0;
int sum;
vector<int >edges[MAXN];
map<pair<int,int>, int> h;
void dfs(int s, int p)
{
    //cerr << s << " " << sum << endl;
    if ( sum > ans ) ans = sum;
    for (auto next : edges[s])
    {
        if ( next != p )
        {
            sum += h[ {s,next} ];
            dfs(next, s);
            sum -= h[ {s,next} ];
        }
    }
}
int main()
{

    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, k;
    cin >> n >> k;

    for (int j=0; j<n-1; j++)
    {
        int b, e, w;
        cin >> b >> e >> w;
        edges[b].push_back(e);
        edges[e].push_back(b);

        h[ {b, e} ] = w;
        h[ {e, b} ] = w;
    }
    for (int i=1; i<=n; i++)
    {
        sum = 0;
        dfs(i, -1);
    }
    int res = ans;
    while (k--)
    {
        bool zn = false;
        for ( int s1=1; s1<=n; s1++)
        {
            for ( int s2=1; s2<=n; s2++)
            {
                if ( h[ {s1,s2}] == 0 ) continue;
                h[ {s1,s2}] = 0;
                h[ {s2,s1}]  =0;
                ans = 0;
                for (int i=1; i<=n; i++)
                {
                    sum = 0;
                    dfs(i, -1);
                }

                if ( ans < res )
                {
                    res = ans;
                    zn = true;
                    break;
                }

                h[ {s1,s2}] = 1;
                h[ {s2,s1}] =1;
            }
        }

        if ( !zn )
        {
            //cerr << "no zn" << endl;
            bool us = false;
            for ( int s1=1; s1<=n; s1++)
            {
                for ( int s2=1; s2<=n; s2++)
                {
                    if ( h[ {s1,s2}] == 0 ) continue;
                  
                    h[ {s1,s2}] = 0;
                    h[ {s2,s1}]  =0;
                    ans = 0;
                    us = true;
                    for (int i=1; i<=n; i++)
                    {
                        sum = 0;
                        dfs(i, -1);
                    }


                   // res = ans;

                    break;

                }
                if ( us ) break;
            }
        }
    }

    cout << res << endl;
}
/**
3 2
1 2 1
2 3 1
-----
0
==============
5 2
1 2 1
2 3 1
2 4 1
4 5 1
-----------
2
*/
