#include "soft_drinks.h"
#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

const int MAXN = 1e5+5;

struct drink
{
    long long a,b;
};

int n;
drink d[MAXN];
double eps = 0.0000001;


int bin_s(int x, int type)
{
    int l = 1, r = n;
    int mid;
    while(l <= r)
    {
        mid = (l+r)/2;
        if(type == 1)
        {
            if(x <= d[mid].a) r = mid-1;
            else l = mid+1;
        }
        else
        {
            if(d[mid].a <= x) l = mid+1;
            else r = mid-1;
        }
    }
    if(type == 1) return l;
    else return r;
}

/*long long tree[4*MAXN];
int ql,qr;

void make_tree(int v, int l, int r)
{
    if(l == r)
    {
        tree[v] = d[r].b;
        return;
    }
    int mid = (l+r)/2;
    make_tree(v*2+0,l,mid+0);
    make_tree(v*2+1,mid+1,r);
    tree[v] = min(tree[v*2+0],tree[v*2+1]);
}

long long query(int v, int l, int r)
{
    if(r < ql || qr < l || l > r) return 1e9;
    if(ql <= l && r <= qr) return tree[v];
    int mid = (l+r)/2;
    return min(query(v*2+0,l,mid+0), query(v*2+1,mid+1,r));
}*/

bool check(double v, int li, int ri, double Ma, double Mb)
{
    if(li+1 == ri)
    {
        if(d[li].a <= d[ri].a && d[li].b <= d[ri].b) ri--;
        else if(d[li].a >= d[ri].a && d[li].b >= d[ri].b) li++;
    }

    if(li == ri) return (v*d[ri].a <= Ma && v*d[ri].b <= Mb);


    int i1 = li;
    int i2 = ri;


    pair<double,double> inv1,inv2;
    inv1 = inv2 = {-2e9,2e9};
    double chis1,chis2,znam1,znam2;

    chis1 = Ma - v*(double)d[i2].a;
    chis2 = Mb - v*(double)d[i2].b;

    znam1 = d[i1].a - d[i2].a;
    znam2 = d[i1].b - d[i2].b;

    if(znam1 == 0 && chis1 < 0) return false;
    if(znam2 == 0 && chis2 < 0) return false;
    if(znam1 == 0) inv1 = {-2e9,2e9};
    if(znam2 == 0) inv2 = {-2e9,2e9};

    if(znam1 != 0)
    {
        if(znam1 > 0) inv1 = {-2e9,chis1/znam1};
        else inv1 = {chis1/znam1,2e9};
    }
    if(znam2 != 0)
    {
        if(znam2 > 0) inv2 = {-2e9,chis2/znam2};
        else inv2 = {chis2/znam2,2e9};
    }

    double iL = max(inv1.first,inv2.first);
    double iR = min(inv1.second,inv2.second);
    return iL <= iR;
}

double friendDrink(int Ma, int Mb, int La, int Ra)
{
    int li = bin_s(La,1);
    int ri = bin_s(Ra,-1);
    //cout << "++++++++"  << li << " " << ri << endl;
    if(li > ri) return (double)0;

    //cout << "+++++" << li << " " << ri << endl;
    double l = 0, r = (double)2e9;
    double mid;
    while(l <= r)
    {
        mid = (l+r)/(double)2;
        if(check(mid,li,ri,Ma,Mb)) l = mid+eps;
        else r = mid-eps;
    }
    return r;
}


bool cmpd(drink p1, drink p2)
{
    if(p1.a == p2.a) return p1.b < p2.b;
    return p1.a < p2.a;
}

void init(const std::vector<int>& A, const std::vector<int>& B)
{
    n = A.size();
    for(int i = 1; i <= n; i++) d[i] = {A[i-1],B[i-1]};
    sort(d+1,d+n+1,cmpd);

    //for(int i = 1; i <= n; i++) cout << d[i].a << " " << d[i].b << endl;
    //cout << "make tree" << endl;
    //make_tree(1,1,n);
}
