#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

const int MAXN = 2e5+5;

struct edge
{
    int ver,num;
};

int n,k,sp[MAXN];
vector<edge>g[MAXN];

void read()
{
    cin >> n >> k;
    int x,y,d;

    int sum = 0;
    for(int i = 1; i < n; i++)
    {
        cin >> x >> y >> d;
        g[x].push_back({y,i});
        g[y].push_back({x,i});
        sp[i] = d;
        sum += d;
    }
    k = min(k,sum);
}


pair<int, long long> fapp;

void dfs_far(int beg, int par, long long cost)
{
    if(cost > fapp.second) fapp = {beg,cost};

    for(edge nb : g[beg])
    {
        if(nb.ver != par) dfs_far(nb.ver,beg,cost + sp[nb.num]);
    }
}

int par[MAXN],nue[MAXN];

void dfs_get(int beg, int p, long long cost)
{
    if(cost > fapp.second) fapp = {beg,cost};

    for(edge nb : g[beg])
    {
        if(nb.ver != par[beg])
        {
            par[nb.ver] = beg;
            nue[nb.ver] = nb.num;
            dfs_get(nb.ver,beg,cost + sp[nb.num]);
        }
    }
}

void solve()
{
    for(int i = 1; i <= k; i++)
    {
        fapp = {1,0};
        dfs_far(1,1,0);

        par[fapp.first] = fapp.first;
        dfs_get(fapp.first,fapp.first,0);
        vector<int>v;
        int x = fapp.first;
        while(par[x] != x) v.push_back(nue[x]);

        pair<int,long long> ans = {-1,fapp.second};
        for(int z = 0; z < v.size(); z++)
        {
            if(sp[v[z]] == 0) continue;
            sp[v[z]]--;
            fapp = {1,0};
            dfs_far(1,1,0);
            dfs_far(fapp.first,fapp.second,0);
            if(fapp.second < ans.second) ans = {z,fapp.second};
            sp[v[z]]++;
        }

        if(ans.first == -1) break;
        sp[v[ans.first]]--;
    }
    fapp = {1,0};
    dfs_far(1,1,0);
    dfs_far(fapp.first,fapp.second,0);
    cout << fapp.second << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    solve();
    return 0;
}
