#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

const int MAXN = 2e5+5;

struct edge
{
    int ver,num;
};

int n,k,sp[MAXN];
vector<edge>g[MAXN];

void read()
{
    cin >> n >> k;
    int x,y,d;

    int sum = 0;
    for(int i = 1; i < n; i++)
    {
        cin >> x >> y >> d;
        g[x].push_back({y,i});
        g[y].push_back({x,i});
        sp[i] = d;
        sum += d;
    }
    k = min(k,sum);
}


pair<int, long long> fapp;

void dfs_far(int beg, int par, long long cost)
{
    if(cost > fapp.second) fapp = {beg,cost};

    for(edge nb : g[beg])
    {
        if(nb.ver != par) dfs_far(nb.ver,beg,cost + sp[nb.num]);
    }
}

int par[MAXN],nue[MAXN];

void dfs_get(int beg, int p, long long cost)
{
    if(cost > fapp.second) fapp = {beg,cost};

    for(edge nb : g[beg])
    {
        if(nb.ver != par[beg])
        {
            par[nb.ver] = beg;
            nue[nb.ver] = nb.num;
            dfs_get(nb.ver,beg,cost + sp[nb.num]);
        }
    }
}

void solve()
{
    //cout << k << endl;
    for(int i = 1; i <= k; i++)
    {
        /*cout << "edges in sp:   ";
        for(int i = 1; i <  n; i++)
        {
            cout << sp[i] << " ";
        }
        cout << endl;*/
        fapp = {1,0};
        dfs_far(1,1,0);
        //cout << fapp.first << " " << fapp.second << endl;

        par[fapp.first] = fapp.first;
        fapp.second = 0;
        dfs_get(fapp.first,fapp.first,0);

        //cout << fapp.first << " " << fapp.second << endl;
        //for(int i = 1; i <= n; i++) cout << par[i] << " ";

        //cout << endl;
        vector<int>v;
        int x = fapp.first;
        while(par[x] != x)
        {
            v.push_back(nue[x]);
            x = par[x];
        }



        int sum = 0;
        for(int z = 0; z < v.size(); z++) sum += sp[v[z]];
        sum = sum/2 + sum%2;
        int pomsum = sum;
        int m1 = 0, m2 = 0;
        for(int z = 0; z < v.size(); z++)
        {
            sum -= sp[v[z]];
            if(sum <= 0)
            {
                m1 = z;
                break;
            }
        }
        sum = pomsum;
        for(int z = v.size()-1; z >= 0; z--)
        {
            sum -= sp[v[z]];
            if(sum <= 0)
            {
                m2 = z;
                break;
            }
        }


        pair<int,long long> ans = {-1,fapp.second};
        int br = 0;
        if(true)
        {
            int z = m1;
            if(sp[v[z]])
            {
                sp[v[z]]--;
                fapp = {1,0};
                dfs_far(1,1,0);
                fapp.second = 0;
                dfs_far(fapp.first,fapp.first,0);
                if(ans.first == -1 || fapp.second < ans.second)
                {
                    br = 1;
                    ans = {z,fapp.second};
                }
                else if(fapp.second ==  ans.second) br++;
                sp[v[z]]++;
            }
        }
        if(true)
        {
            int z = m2;
            if(sp[v[z]])
            {
                sp[v[z]]--;
                fapp = {1,0};
                dfs_far(1,1,0);
                fapp.second = 0;
                dfs_far(fapp.first,fapp.first,0);
                if(ans.first == -1 || fapp.second < ans.second)
                {
                    br = 1;
                    ans = {z,fapp.second};
                }
                else if(fapp.second ==  ans.second) br++;
                sp[v[z]]++;
            }

        }
        for(int z = m1+1; z < min(m1+3,(int)v.size()); z++)
        {
            if(sp[v[z]] == 0) continue;
            sp[v[z]]--;
            fapp = {1,0};
            dfs_far(1,1,0);
            fapp.second = 0;
            dfs_far(fapp.first,fapp.first,0);
            if(ans.first == -1 || fapp.second < ans.second)
            {
                br = 1;
                ans = {z,fapp.second};
            }
            else if(fapp.second ==  ans.second) br++;
            sp[v[z]]++;
        }
        for(int z = m2-1; z >= max(m2-3,0); z--)
        {
            if(sp[v[z]] == 0) continue;
            sp[v[z]]--;
            fapp = {1,0};
            dfs_far(1,1,0);
            fapp.second = 0;
            dfs_far(fapp.first,fapp.first,0);
            if(ans.first == -1 || fapp.second < ans.second)
            {
                br = 1;
                ans = {z,fapp.second};
            }
            else if(fapp.second ==  ans.second) br++;
            sp[v[z]]++;
        }


        if(ans.first != -1)
        {
            br = min(sp[v[ans.first]],br);
            sp[v[ans.first]] -= br;
            k += br-1;
        }

        v.clear();
    }
    fapp = {1,0};
    dfs_far(1,1,0);
    fapp.second = 0;
    dfs_far(fapp.first,fapp.first,0);
    cout << fapp.second << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    solve();
    return 0;
}
