/**
    az sum silata
    retro mashinata
*/

#include <iostream>
#include <vector>

#define maxn 500005
#define maxlog 20
#define control std::cout << "passed" << "\n";
#define PB push_back
#define X first
#define Y second


typedef long long ll;
typedef std::pair <ll , ll> pii;

std::vector <pii> v[maxn];

ll max_dist , max_node;
ll n , k;

int par[maxn];

void dfs(ll node , ll par , ll dist)
{
    if(max_dist < dist)
    {
        max_node = node;
        max_dist = dist;
    }

    for(auto& e : v[node])
    {
        if(e.X == par)
            continue;

        dfs(e.X , node , dist + e.Y);
    }
}

void read()
{
    std::cin >> n >> k;

    if(n == 1)
    {
        std::cout << 0 << "\n";
        exit(0);
    }

    for(ll i = 0; i < n - 1; i++)
    {
        ll x , y , w;
        std::cin >> x >> y >> w;

        v[x].PB({y , w});
        v[y].PB({x , w});
    }

    max_dist = max_node = 0;

    dfs(1 , 0 , 0);

    //std::cout << max_node << "\n";

    ll root = max_node;
    max_dist = max_node = 0;

    dfs(root , 0 , 0);

    std::cout << std::max(max_dist - k , 0LL) << "\n";
}



int main()
{
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    read();


    return 0;
}
