/**
    az sum silata
    retro mashinata
*/

#include <iostream>
#include <vector>

#define maxn 200005
#define maxlog 20
#define control std::cout << "passed" << "\n";
#define PB push_back
#define X first
#define Y second


typedef std::pair <int , int> pii;

std::vector <pii> v[maxn];

int max_dist , max_node;
int n , k;

int br;

void dfs(int node , int par , int dist)
{
    if(max_dist < dist)
    {
        max_node = node;
        max_dist = dist;
        br = 1;
    }

    if(max_dist == dist)
        br++;

    for(auto& e : v[node])
    {
        if(e.X == par)
            continue;

        dfs(e.X , node , dist + e.Y);
    }
}

void read()
{
    std::cin >> n >> k;

    for(int i = 0; i < n - 1; i++)
    {
        int x , y , w;
        std::cin >> x >> y >> w;

        v[x].PB({y , w});
        v[y].PB({x , w});
    }

    max_dist = max_node = 0;

    dfs(1 , 0 , 0);
    
    int cc = 0;
    if(br > 1 && k > 0)
        cc = 1;
    
    //std::cout << max_node << "\n";

    int root = max_node;
    max_dist = max_node = 0;

    dfs(root , 0 , 0);

    std::cout << max_dist - cc << "\n";
}



int main()
{
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    read();


    return 0;
}