/**
    az sum silata
    retro mashinata
*/

#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>

#define maxn 200005
#define maxlog 20
#define control std::cout << "passed" << "\n";
#define PB push_back
#define X first
#define Y second


typedef long long ll;
typedef std::pair <ll , ll> pii;

std::vector <pii> v[maxn];

ll max_dist , max_node;
ll n , k;

int par[maxn];
int depth[maxn];

void dfs(ll node , ll pp , ll dist , bool lamp)
{
    if(lamp == true)
    {
        par[node] = pp;
    }

    if(max_dist < dist)
    {
        max_node = node;
        max_dist = dist;
    }

    for(auto& e : v[node])
    {
        if(e.X == pp)
            continue;
        if(lamp == true)
            depth[e.X] = depth[node] + 1;
        dfs(e.X , node , dist + e.Y , lamp);
    }
}

std::unordered_map <int , bool> used[maxn];

ll maxdd , maxno;
bool used2[maxn];

std::vector <int> way;

void dfs2(int node , int par , ll dd)
{
    way.PB(node);
    used2[node] = true;
    if(dd > maxdd)
    {
        maxdd = dd;
        maxno = node;
    }

    for(auto& e : v[node])
    {
        if(used[e.X][node] == true || used2[e.X] == true)
            continue;
        if(e.X == par)
            continue;

        dfs2(e.X , node , dd + e.Y);
    }
}


void read()
{
    std::cin >> n >> k;

    if(n == 1)
    {
        std::cout << 0 << "\n";
        exit(0);
    }

    for(ll i = 0; i < n - 1; i++)
    {
        ll x , y , w;
        std::cin >> x >> y >> w;

        v[x].PB({y , w});
        v[y].PB({x , w});
    }

    max_dist = max_node = 0;

    dfs(1 , 0 , 0 , 1);

    //std::cout << max_node << "\n";

    int a = max_node;
    max_dist = max_node = 0;

    dfs(a , 0 , 0 , 0);
    int b = max_node;

    if(depth[b] > depth[a])
        std::swap(a , b);

    while(depth[a] > depth[b])
    {
        used[a][par[a]] = true;
        used[par[a]][a] = true;

        a = par[a];
    }

    while(a != b)
    {
        used[a][par[a]] = true;
        used[par[a]][a] = true;

        a = par[a];

        used[b][par[b]] = true;
        used[par[b]][b] = true;

        b = par[b];
    }

    ll maxx = 0;

    for(int i = 1; i <= n; i++)
    {
        if(used2[i] == true)
            continue;

        maxdd = maxno = 0;
        way.clear();
        dfs2(i , 0 , 0);

        int help = maxno;
        maxdd = maxno = 0;

        for(auto& e : way)
            used2[e] = false;
        way.clear();

        dfs2(help , 0 , 0);

        maxx = std::max(maxx , maxdd);
    }

    if(maxx == max_dist)
    {
        //std::cout << 1 / 0 << "\n";
        std::cout << max_dist << "\n";
        return;
    }

    std::cout << std::max(max_dist - k , 0LL) << "\n";
}



int main()
{
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    read();


    return 0;
}
