#include <bits/stdc++.h>
#include "cycles.h"

#ifdef __LOCAL__
#include "Lgrader.cpp"
#endif // __LOCAL__

using namespace std;

bool isOnPlace[1005];

int FindSwapIndex(int N, int &currPerm)
{
    stack <pair <int, int>> perfromedSwaps;

    int start = 0, swappedIndex = -1;
    for (int i = 0; i < N-1; i++)
    {
        if (isOnPlace[i] == false)
        {
            start = i;
            break;
        }
    }

    int currIndex = start;
    for (int i = start+1; i < N; i++)
    {
        if (isOnPlace[i])
            continue;

        int newPerm = performSwap(currIndex, i);
        perfromedSwaps.emplace(currIndex, i);

        currIndex = i;

        if (newPerm >= currPerm)
        {
            swappedIndex = currIndex;
            break;
        }

        currPerm = newPerm;
    }

    while (!perfromedSwaps.empty())
    {
        int a = perfromedSwaps.top().first;
        int b = perfromedSwaps.top().second;
        perfromedSwaps.pop();
        currPerm = performSwap(a, b);
    }

    return swappedIndex;
}
void PutInPlace(int N, int &currPerm, int swappedIndex)
{
    for (int i = 0; i < N; i++)
    {
        if (isOnPlace[i])
            continue;

        int nextPerm = performSwap(i, swappedIndex);
        if (nextPerm > currPerm)
        {
            isOnPlace[i] = true;
            currPerm = nextPerm;
            return;
        }

        performSwap(i, swappedIndex);
    }
}
void sortPermutation(int N)
{
    int currPerm = max(performSwap(0, 1), performSwap(0, 1));

    while (currPerm != N)
    {
        int swappedIndex = FindSwapIndex(N, currPerm);
        PutInPlace(N, currPerm, swappedIndex);
    }

}

/*

3
2 0 1
*/
