#include <bits/stdc++.h>
#include "cycles.h"

#ifdef __LOCAL__
#include "Lgrader.cpp"
#endif // __LOCAL__

using namespace std;

bool isOnPlace[1005];

int FindSwapIndex(int N, int &currPerm)
{
    stack <pair <int, int>> perfromedSwaps;

    int start = 0, swappedIndex = -1;
    for (int i = 0; i < N-1; i++)
    {
        if (isOnPlace[i] == false)
        {
            start = i;
            break;
        }
    }

    int currIndex = start;
    for (int i = start+1; i < N; i++)
    {
        if (isOnPlace[i])
            continue;

        int newPerm = performSwap(currIndex, i);
        perfromedSwaps.emplace(currIndex, i);

        if (newPerm == N)
            return -1;

        currIndex = i;

        if (newPerm >= currPerm)
        {
            swappedIndex = currIndex;
            break;
        }

        currPerm = newPerm;
    }

    while (!perfromedSwaps.empty())
    {
        int a = perfromedSwaps.top().first;
        int b = perfromedSwaps.top().second;
        perfromedSwaps.pop();
        currPerm = performSwap(a, b);
    }

    return swappedIndex;
}
void PutInPlace(int N, int &currPerm, int swappedIndex)
{
    if (swappedIndex == -1)
        return;

    int br = 0, ind[2];
    for (int i = 0; i < N; i++)
    {
        if (isOnPlace[i]|| i == swappedIndex)
            continue;

        int nextPerm = performSwap(i, swappedIndex);

        if (nextPerm > currPerm)
        {
            ind[br++] = i;
        }
        performSwap(i, swappedIndex);
    }

    if (br == 0)
        return;

    if (br == 1)
    {
        isOnPlace[ind[0]] = 1;
        performSwap(swappedIndex, ind[0]);
        return;
    }


    currPerm = performSwap(ind[0], swappedIndex);
    int k = performSwap(swappedIndex, ind[1]);
    isOnPlace[ind[0]] = isOnPlace[ind[1]] = isOnPlace[swappedIndex] = 1;

    if (k > currPerm)
    {
        currPerm = k;
        return;
    }

    performSwap(swappedIndex, ind[1]);
    currPerm = performSwap(ind[0], ind[1]);
}
void sortPermutation(int N)
{
    performSwap(0, 1);
    int currPerm = performSwap(0, 1);

    while (currPerm != N)
    {
        int swappedIndex = FindSwapIndex(N, currPerm);
        PutInPlace(N, currPerm, swappedIndex);
    }

}

/*

3
2 1 0

3
1 0 2

3
1 2 0
*/
