#include<iostream>
#include<vector>
using namespace std;
const int MAX_N=1e5+5;
int dp[2005][2005];
int diam;
vector<int>g[MAX_N];
int n,k;
void dfs(int u,int par)
{
    for(int v:g[u])
    {
        if(v==par)continue;

        dfs(v,u);
    }

    for(int minmaxdist=0;minmaxdist<=min(n,diam);minmaxdist++)
    {
        dp[u][minmaxdist]=0;

        for(int v:g[u])
        {
            if(v==par)continue;

            if(minmaxdist==0)
            {
                dp[u][0]+=1+dp[v][0];

                continue;
            }

            dp[u][minmaxdist]+=min(0+dp[v][min(minmaxdist-1,diam-minmaxdist-1)],1+dp[v][min(minmaxdist,diam-minmaxdist)]);
        }

        if(minmaxdist>0)dp[u][minmaxdist]=min(dp[u][minmaxdist],dp[u][minmaxdist-1]);
    }
}
bool check()
{
    dfs(1,0);
    if(dp[1][diam]<=k)return 1;
    return 0;
}
int main ()
{
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n>>k;
    for(int i=1;i<n;i++)
    {
        int a,b,c;
        cin>>a>>b>>c;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    int l=0,r=n-1;
    int ans=n-1;
    while(l<=r)
    {
        int mid=(l+r)/2;
        diam=mid;
        if(check())
        {
            ans=mid;
            r=mid-1;
        }
        else l=mid+1;
    }
    cout<<ans<<"\n";

    return 0;
}
