#include <bits/stdc++.h>
#define endl '\n'
#define pb push_back
using namespace std;
const int maxn = 2e5 + 10;
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

int n, k;
vector < pair < int, int > > g[maxn];
map < pair < int, int >, int > mp;
void read()
{
    cin >> n >> k;
    for (int i = 1; i < n; ++ i)
    {
        int u, v, w;
        cin >> u >> v >> w;
        g[u].pb(make_pair(v, w));
        g[v].pb(make_pair(u, w));
    }

}

int dist0[maxn];
int maxdist0, maxv0 = 0;
int mindist, minv;
int wfrom, wto;
void dfs0(int beg, int from)
{
    if(dist0[beg] > maxdist0)
    {
        maxdist0 = dist0[beg];
        maxv0 = beg;
    }
    for (auto &[nb, cost]: g[beg])
    {
        if(nb == from)continue;
        dist0[nb] = dist0[beg] + cost - mp[make_pair(nb, beg)];

        dfs0(nb, beg);
    }
}

int root, dist[maxn];
void dfs(int beg, int from)
{
    for (auto &[nb, cost]: g[beg])
    {
        if(nb == from)continue;
        dist[nb] = dist[beg] + cost - mp[make_pair(nb, beg)];
        if(dist[nb] && !dist[beg])
        {
            if(dist[nb] < mindist)
            {
                mindist = dist[nb];
                minv = nb;
                wfrom = beg;
                wto = nb;
            }
        }
        dfs(nb, beg);
    }
}
int main()
{
    speed();

    read();
    while(k --)
    {
       // cout << "run 1" << endl;
        for (int i = 0; i <= n; ++ i)
        {
            dist0[i] = 0;
            dist[i] = 0;
        }
        maxdist0 = 0;
        maxv0 = 0;
        dfs0(1, -1);

        root = maxv0;
        //cout << "root " << root << endl;
        mindist = 1e9;
        minv = 0;
        dfs(root, -1);
       // cout << wfrom << " " << wto << endl;
        mp[make_pair(wfrom, wto)] ++;
        mp[make_pair(wto, wfrom)] ++;

    }
    for (int i = 0; i <= n; ++ i)
        {
            dist0[i] = 0;
            dist[i] = 0;
        }
        maxdist0 = 0;
        maxv0 = 0;
        dfs0(1, -1);
        root = maxv0;

        dfs(root, -1);
        int diam = 0;
        for (int i = 1; i <= n; ++ i)
            diam = max(diam, dist[i]);
        cout << diam << endl;
    return 0;
}
/***
8 3
1 2 1
2 5 1
2 3 1
3 6 1
6 7 1
3 4 1
4 8 1
*/
