#include <bits/stdc++.h>
#define endl '\n'
#define pb push_back
using namespace std;
const int maxn = 205;
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

int n, k;
vector < pair < int, int > > g[maxn];
map < pair < int, int >, int > mp;
void read()
{
    cin >> n >> k;
    for (int i = 1; i < n; ++ i)
    {
        int u, v, w;
        cin >> u >> v >> w;
        g[u].pb(make_pair(v, w));
        g[v].pb(make_pair(u, w));
    }

}

int dist0[maxn];
int del[maxn];
int maxdist0, maxv0 = 0;
int mindist, minv;
int wfrom, wto;
void dfs0(int beg, int from)
{
    if(dist0[beg] > maxdist0)
    {
        maxdist0 = dist0[beg];
        maxv0 = beg;
    }
    for (auto &[nb, cost]: g[beg])
    {
        if(nb == from)continue;
        if(del[nb])continue;
        dist0[nb] = dist0[beg] + cost - mp[make_pair(nb, beg)];

        dfs0(nb, beg);
    }
}

int root, dist[maxn];
int maxdist, maxv, par[maxn];
void dfs(int beg, int from)
{
    par[beg] = from;
    if(dist[beg] > maxdist)
    {
        maxdist = dist[beg];
        maxv = beg;

    }
    for (auto &[nb, cost]: g[beg])
    {
        if(nb == from)continue;
        if(del[nb])continue;
        dist[nb] = dist[beg] + cost - mp[make_pair(nb, beg)];

        dfs(nb, beg);
    }
}
int root2, dist2[maxn];
void dfs2(int beg, int from)
{

    for (auto &[nb, cost]: g[beg])
    {
        if(nb == from)continue;
        if(del[nb])continue;
        dist2[nb] = dist2[beg] + cost - mp[make_pair(nb, beg)];

        dfs2(nb, beg);
    }
}
int main()
{
    speed();

    read();
    k = min(k, n-1);
    int start = 0;
    while(k)
    {

        for (int i = 0; i <= n; ++ i)
        {
            if(!del[i])start = i;
            dist0[i] = 0;
            dist[i] = 0;
            dist2[i] = 0;
        }
        maxdist0 = 0;
        maxv0 = 0;
        dfs0(start, -1);

        root = maxv0;

        maxdist = 0;
        maxv = 0;

        dfs(root, -1);
        int diam = maxdist;

        root2 = maxv;
        dfs2(root2, -1);
       // cout << "curr solving " << root << " " << root2 << endl;
        int just1 = 1;
        for (int i = 1; i <= n; ++ i)
        {

            if(del[i])continue;
            //cout << i << " " << dist[i] << " " << dist2[i] << endl;
            if(dist[i] == maxdist && dist2[i] == maxdist )
                just1 = 0;
        }
        if(just1)
        {
            del[root] = 1;
           // cout << root << endl;
            k --;
        }
        else if(k > 1)
        {
            k -= 2;
            //cout << root << " " << root2 << endl;
            del[root] = 1;
            del[root2] = 1;
        }
    }
    int diam = 0;
   for (int i = 0; i <= n; ++ i)
        {
            if(!del[i])start = i;
            dist0[i] = 0;
            dist[i] = 0;
            dist2[i] = 0;
        }
        maxdist0 = 0;
        maxv0 = 0;
        dfs0(start, -1);
        root = maxv0;
        maxdist = 0;
        maxv = 0;
        dfs(root, -1);
        diam = maxdist;

        cout << diam << endl;
    return 0;
}
/***
8 3
1 2 1
2 5 1
2 3 1
3 6 1
6 7 1
3 4 1
4 8 1

9 3
1 2 1
2 9 1
2 3 1
3 7 1
7 8 1
3 4 1
4 6 1
4 5 1

8 4
1 2 1
2 3 1
3 4 1
3 7 1
7 8 1
4 6 1
4 5 1
*/
