#include<bits/stdc++.h>
#define MAXN 2010
using namespace std;
bool cost[MAXN][MAXN];
vector<int> edges[MAXN];
vector<pair<int,int>> order;
int d=0;
int dfs(int curr, int parent)
{
    int mx1=0,mx2=0;
    for(int i=0;i<edges[curr].size();i++)
    {
        int now=edges[curr][i],w=cost[curr][now];
        if(now==parent)continue;
        int res=dfs(now,curr)+w;
        if(res>=mx1){mx2=mx1;mx1=res;}
        else if(res>=mx2){mx2=res;}
    }
    d=max(d,mx1+mx2);
    return mx1;
}
int main()
{
    int n,k;
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin>>n>>k;
    for(int i=1;i<n;i++)
    {
        int u,v,x;
        cin>>u>>v>>x;
        if(u>v)swap(u,v);
        edges[u].push_back(v);
        edges[v].push_back(u);
        cost[u][v]=1;
        cost[v][u]=1;
        order.push_back({u,v});
    }
    if(k>=n-1){cout<<"0\n";return 0;}
    sort(order.begin(),order.end());
    int ans=9999999;
    for(int i=0;i+k<order.size();i++)
    {
        for(int j=0;j<=i+k;j++)
        {
            int u=order[i].first,v=order[i].second;
            cost[u][v]=0;cost[v][u]=0;
        }
        d=0;
        dfs(1,0);
        ans=min(ans,d);
        for(int j=0;j<=i+k;j++)
        {
            int u=order[i].first,v=order[i].second;
            cost[u][v]=1;cost[v][u]=1;
        }
    }
    cout<<ans<<"\n";
}