#include<bits/stdc++.h>

using namespace std;
long long n,k;
vector<pair<long long,long long> > v[200001];
void read()
{
    cin>>n>>k;
    for(long long i=1;i<n;i++)
    {
        long long x,y,z;
        cin>>x>>y>>z;
        v[x].push_back({y,z});
        v[y].push_back({x,z});
    }
}

long long d[200001];
long long v1,v2;
void dfs1(long long i,long long p)
{

    for(long long j=0;j<v[i].size();j++)
    {
        long long nb=v[i][j].first;
        if(nb==p)continue;
        d[nb]=d[i]+v[i][j].second;
        if(d[nb]>d[v1])v1=nb;
        dfs1(nb,i);
    }
}

long long pr[200001];
void dfs2(long long i,long long p)
{
    //cout<<i<<" "<<d[i]<<endl;
    for(long long j=0;j<v[i].size();j++)
    {
        long long nb=v[i][j].first;
        if(nb==p)continue;
        //cout<<i<<" "<<nb<<" * "<<v[i][j].second<<endl;
        d[nb]=d[i]+v[i][j].second;
        pr[nb]=i;
        if(d[nb]>d[v2])v2=nb;
        dfs2(nb,i);
    }
}


long long diam()
{
    d[1]=0;
    v1=1;
    dfs1(1,0);

    v2=v1;
    d[v2]=0;
    dfs2(v2,0);
    //cout<<v2<<" -> "<<d[v2]<<endl;
    return d[v2];
}

vector<int> all;
int c[200001];
int r1,r2;
void dfs3(int i,int p)
{
    int maxx=0;
    for(int j=0;j<v[i].size();j++)
    {
        int nb=v[i][j].first;
        if(nb==p)continue;

        dfs3(nb,i);
        c[i]+=c[nb];
        maxx=max(maxx,c[nb]);
    }

    if(c[i]==all.size()&&maxx!=all.size())
    {
        r1=i;
        r2=p;
    }
}
void solve()
{
    for(int i=1;i<=n;i++)
        if(d[i]==d[v2])c[i]=1,all.push_back(i);
        else c[i]=0;
    dfs3(v1,0);
    for(int i=0;i<v[r1].size();i++)
        if(v[r1][i].first==r2)v[r1][i].second--;
    for(int i=0;i<v[r2].size();i++)
        if(v[r2][i].first==r1)v[r2][i].second--;
    cout<<diam()<<endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    read();
    if(n==1)
    {
        cout<<0<<endl;
        return 0;
    }

    if(k==1)
    {
        diam();
        solve();
    }
    else cout<<diam()<<endl;
    return 0;
}
/*
5 0
1 2 5
2 3 4
2 4 3
4 5 2

4 1
1 2 1
2 3 0
2 4 1

5 1
2 5 1
5 3 1
3 4 1
3 1 1

*/
