#include<iostream>
#include <vector>
#include <queue>
#include <algorithm>
using namespace std;

struct edge{
    int u, w;
    edge(){}
    edge(int _u, int _w){
        u = _u;
        w = _w;
    }
};

bool cmp(edge e1, edge e2){
    return e1.w > e2.w;
}

int n, k;
vector<edge> graph[200001];
int diameter = 0;
vector<int> pref;

vector<int> used;

void read(){
    cin >> n >> k;
    used.resize(n, 0);
    pref.resize(n+1, 0);
    pref[0]=0;
    pref[1] = 0;

    for(int i = 0; i < n-1; i++){
        int u, v, w;
        cin >> u >> v >> w;
        graph[u].push_back(edge(v, w));
        pref[v] = pref[u] + w;
        //graph[v].push_back(edge(u, w));
    }
}

void get_diameter(int s){
    int max_sum = 0;
   for(int i = 1; i <= n; i++){
        if(pref[i] > max_sum){
            max_sum = pref[i];
        }
   }
   cout << max_sum << endl;
}

int main(){
    read();
    get_diameter(1);
    return 0;
}
