#include<iostream>
#include <vector>
#include <queue>
#include <algorithm>
using namespace std;

struct edge{
    int u, w;
    edge(){}
    edge(int _u, int _w){
        u = _u;
        w = _w;
    }
};

struct edge1{
    int v, u, w;
    edge1(){}
    edge1(int _v, int _u, int _w){
        v = _v;
        u = _u;
        w = _w;
    }
};

bool cmp(edge1 e1, edge1 e2){
    return e1.v > e2.v;
}

int n, k;
vector<edge> graph[200001];
vector<edge1> temp;
int diameter = 0;
vector<int> pref;

vector<int> used;

void read(){
    cin >> n >> k;
    used.resize(n, 0);
    pref.resize(n+1, 0);
    pref[0]=0;
    pref[1] = 0;

    for(int i = 0; i < n-1; i++){
        int u, v, w;
        cin >> u >> v >> w;
        graph[u].push_back(edge(v, w));
        temp.push_back(edge1(u, v, w));
        //graph[v].push_back(edge(u, w));
    }

    sort(temp.begin(), temp.end(), cmp);
    for(int i = 0; i < temp.size(); i++){
        pref[temp[i].v] = pref[temp[i].u] + temp[i].w;
    }
}

void get_diameter(){
    int max_sum = 0;
   for(int i = 1; i <= n; i++){
        if(pref[i] > max_sum){
            max_sum = pref[i];
        }
   }
   cout << max_sum << endl;
}

int main(){
    read();
    get_diameter();
    return 0;
}
