#include "soft_drinks.h"

std::vector<int> arr1, arr2;
void init(const std::vector<int> &a, const std::vector<int> &b) {
  arr1 = a, arr2 = b;
}

double friendDrink(int ma, int mb, int la, int ra) {
  if (arr1.size() == 1) {
    int sugar = arr1.front(), acid = arr2.front();
    if (sugar > ra || sugar < la)
      return 0;
    double maxsugar = (double)ma / sugar;
    double maxacid = (double)mb / acid;
    return std::min(maxsugar, maxacid);
  } else if (arr1.size() == 2) {
    int s1 = arr1.front(), s2 = arr1.back(), a1 = arr2.front(),
        a2 = arr2.back();
    if ((s1 > ra || s1 < la) && (s2 > ra || s2 < la))
      return 0;
    else if (s1 > ra || s1 < la) {
      double maxsugar = (double)ma / s2;
      double maxacid = (double)mb / a2;
      return std::min(maxsugar, maxacid);
    } else if (s2 > ra || s2 < la) {
      double maxsugar = (double)ma / s1;
      double maxacid = (double)mb / a1;
      return std::min(maxsugar, maxacid);
    }

    double ms1 = (double)ma / s1, ma1 = (double)mb / a1;
    double ms2 = (double)ma / s2, ma2 = (double)mb / a2;
    return std::max(std::min(ms1, ma1), std::min(ms2, ma2));
  }
}