#include "soft_drinks.h"
#include <iostream>

int sz;
double eps = 1e-6;
std::vector<int> arr1, arr2;
void init(const std::vector<int> &a, const std::vector<int> &b) {
  arr1 = a, arr2 = b;
  sz = a.size();
}

double helper(int ma, int mb, int la, int ra) {
  double ans = 0;
  std::pair<double, double> p;
  for (int i = 0; i < sz; i++) {
    double sugar = arr1[i], acid = arr2[i];
    if (sugar > ra || sugar < la)
      continue;
    if (sugar == 0)
      sugar = 1e9;
    if (acid == 0)
      acid = 1e9;
    if (ans < std::min((double)ma / sugar, (double)mb / acid))
      p = {(double)ma / sugar, (double)mb / acid},
      ans = std::max(p.first, p.second);
  }
  if (ma - p.first <= eps && mb - p.second <= eps)
    return ans;

  if (ma - p.first > eps) {
    int idx = -1;
    double curr = 1e9;
    for (int i = 0; i < sz; i++)
      if (curr > arr1[i] && arr2[i] == 0)
        curr = arr1[i], idx = i;
    if (idx != -1 && curr < 1e9 && curr != 0)
      return ans + ((double)ma - p.first) / curr;
  }
  if (ma - p.second > eps) {
    int idx = -1;
    double curr = 1e9;
    for (int i = 0; i < sz; i++)
      if (curr > arr2[i] && arr1[i] == 0)
        curr = arr2[i], idx = i;
    if (idx != -1 && curr < 1e9 && curr != 0)
      return ans + ((double)mb - p.second) / curr;
  }
  return ans;
}
double friendDrink(int ma, int mb, int la, int ra) {
  double ans = helper(ma, mb, la, ra);
  return ans;
}