#include <bits/stdc++.h>
using namespace std;
#define endl '\n'

const int maxn = 1 + 2e5, INF = 1e9;
int depth[maxn], ans = 0, node;
vector<pair<int, int>> edges[maxn];
bool visited[maxn];
int par[maxn];

void dfs(int u) {
  visited[u] = true;
  if (depth[u] > ans)
    ans = depth[u], node = u;

  for (auto &e : edges[u]) {
    int next = e.first, w = e.second;
    if (!visited[next]) {
      depth[next] = depth[u] + w;
      dfs(next);
    }
  }
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);

  int n, k;
  cin >> n >> k;
  if (k >= 2) {
    cout << 0 << endl;
    return 0;
  }

  for (int i = 1; i < n; i++) {
    int u, v, w;
    cin >> u >> v >> w;
    edges[u].push_back({v, w});
    edges[v].push_back({u, w});
  }
  dfs(1);
  fill_n(visited, maxn, false);
  depth[node] = 0, ans = 0;
  dfs(node);
  cout << ans - k << endl;
}