#include<bits/stdc++.h>
#define MAXN 100007
using namespace std;

struct drink{
    long double a,b;

    inline friend bool operator < (drink fr,drink sc){
        if(fr.a!=sc.a)return fr.a < sc.a;
        return fr.b<sc.b;
    }
}s[MAXN];

int n;

void init(const vector<int>& A, const vector<int>& B){
    n=int(A.size());


    for(int i=1;i<=n;i++){
        s[i]={A[i-1],B[i-1]};

        if(s[i].a==0 and s[i].b==0){
            s[i].a=-1; s[i].b=1;
        }
    }

    sort(s+1,s+n+1);
}

long double calc(long double x,long double y,drink t){
    if(t.a==0)return y/t.b;
    if(t.b==0)return x/t.a;
    return min(x/t.a,y/t.b);
}

long double bro(drink s,drink t,long double x,long double y,long double c){
    return c + calc(x-s.a*c,y-s.b*c,t);
}

const long double eps=0.0000005;

long double solve(drink s,drink t,long double x,long double y){
    long double l=0,r=calc(x,y,s);

    for(int i=1;i<=120;i++){
        long double mid=(l+r)/2.0;

        if(bro(s,t,x,y,mid) > bro(s,t,x,y,mid+eps)){
            r=mid;
        }else{
            l=mid;
        }
    }

    return bro(s,t,x,y,r);
}

double friendDrink(int Ma, int Mb, int La, int Ra){
    vector<drink> d;
    drink t={Ma,Mb};

    for(int i=1;i<=n;i++){
        if(s[i].a<La or s[i].a>Ra)continue;

        if(!d.empty() and d.back().b<=s[i].b)continue;
        d.push_back(s[i]);
    }

    if(d.empty())return 0.0;

    long double ans=0.0;

    for(int i=0;i<d.size();i++){
        long double last=0.0;

        for(int f=i;f<d.size();f++){
            long double curr=solve(d[i],d[f],Ma,Mb);
            ans=max(ans,curr);

            if(curr<last-eps)break;
            last=curr;
        }
    }

    return ans;
}

/*int main(){

    init({4, 2, 6, 3}, {0, 8, 4, 6});
    cout<<friendDrink(8, 2, 4, 6)<<":\n";
    cout<<friendDrink(8, 2, 3, 6)<<":\n";
    cout<<friendDrink(0, 10, 0, 10)<<":\n";

    return 0;
}*/