#include<bits/stdc++.h>
#define MAXN 200007
using namespace std;

int n,k,a,b,c,deg[MAXN];
vector<int> v[MAXN];
vector< pair<int,int> > w[MAXN];
queue<int> q;

int center,diameter,x,y,parent[MAXN];
int cost[MAXN];

void dfs(int x,int p,int d){
    if(d>diameter){
        diameter=d;
        y=x;
    }

    for(auto nxt:w[x]){
        if(nxt.first==p)continue;
        dfs(nxt.first,x,d+nxt.second);
    }
}

int main(){

    cin>>n>>k;

    if(k>=n-1){
        cout<<0<<"\n";
        return 0;
    }
    k=n-1-k;

    for(int i=1;i<=n-1;i++){
        cin>>a>>b>>c;
        v[a].push_back(b);
        v[b].push_back(a);

        deg[a]++;
        deg[b]++;
    }

    for(int i=1;i<=n;i++){
        if(deg[i]==1)q.push(i);
    }

    while(!q.empty()){
        int curr=q.front();
        q.pop();


        if(k>=1)cost[curr]=1;
        k--;

        for(int f:v[curr]){
            if(cost[f]==0)parent[curr]=f;
        }

        for(int f:v[curr]){
            deg[f]--;
            if(deg[f]==1)q.push(f);
        }
    }

    for(int i=1;i<=n;i++){
        if(parent[i]==0)continue;

        w[i].push_back({parent[i],cost[i]});
        w[parent[i]].push_back({i,cost[i]});
    }

    dfs(1,0,0);
    x=y;
    dfs(x,0,0);

    cout<<diameter<<"\n";

    return 0;
}