#include<bits/stdc++.h>
using namespace std;
const int maxn=2e5+10;
struct node{
    int to,t;
    node(int _to, int _t)
    {
        to=_to;
        t=_t;
    }
};
vector<node> v[maxn];
vector<pair<int,int>> g[maxn];
int to_root[maxn];
int ans=2e9;
bool cmp(pair<int, int> a, pair<int,int> b)
{
    return a.first>b.first;
}
int dfs(int vr, int p, int sum)
{
    // cout<<vr<<endl;
    to_root[vr]=sum;
    for(int i=0;i<v[vr].size();i++)
    {
        if(v[vr][i].to!=p)
        {
            g[vr].push_back({dfs(v[vr][i].to,vr,sum+v[vr][i].t)+v[vr][i].t,v[vr][i].to});
        }
    }
    sort(g[vr].begin(),g[vr].end(),cmp);
    return g[vr].size()? g[vr][0].first:0;
}
void dfs2(int vr, int p, int sum)
{
    if(vr!=0)
    {

    }
    for(int i=0;i<v[vr].size();i++)
    {
        if(v[vr][i].to!=p)
        {
            dfs(v[vr][i].to,vr,sum);
        }
    }
}
int parent[300];
int weight[300][300];
int dist[300];
int n;
int bre;
void bfs(int vr)
{
    // cout<<"--"<<vr<<endl;
    queue<pair<int,int>> qu;
    while(bre)
    {
        qu.push({vr,0});
        parent[vr]=-1;
        dist[vr]=0;
        while(!qu.empty())
        {
            // cout<<vr<<endl;
            vr=qu.front().first;
            int level = qu.front().second;
            qu.pop();
            for(int i=0;i<v[vr].size();i++)
            {
                if(parent[vr]==v[vr][i].to)continue;
                dist[v[vr][i].to]=dist[vr]+weight[v[vr][i].to][vr];
                parent[v[vr][i].to]=vr;
                qu.push({v[vr][i].to,level+1});
            }
        }
        int maxdist=0;
        for(int i=1;i<=n;i++)
        {
            if(dist[i]>maxdist){maxdist=dist[i];vr=i;}
        }
        vector<int> path;
        while(parent[vr]==-1)
        {
            path.push_back(vr);
            vr=parent[vr];
        }
        for(int i=path.size()-1;i>0;i--)
        {
            if(weight[i-1][i-2]!=0)
            {
                weight[i-1][i-2]=0;
                weight[i-2][i-1]=0;
                break;
            }
        }
        bre--;
    }
    while(!qu.empty())
    {
        // cout<<vr<<endl;
        vr=qu.front().first;
        int level = qu.front().second;
        qu.pop();
        for(int i=0;i<v[vr].size();i++)
        {
            if(parent[vr]==v[vr][i].to)continue;
            dist[v[vr][i].to]=dist[vr]+weight[v[vr][i].to][vr];
            parent[v[vr][i].to]=vr;
            qu.push({v[vr][i].to,level+1});
        }
    }
    int maxdist=0;
    for(int i=1;i<=n;i++)
    {
        if(dist[i]>maxdist){maxdist=dist[i];vr=i;}
    }
    ans=min(ans,maxdist);
}
int main ()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    int k;
    cin>>n>>k;
    for(int i=0;i<n-1;i++)
    {  
        int a,b,t;
        cin>>a>>b>>t;
        v[a].push_back({b,t});
        v[b].push_back({a,t});
    }
    for(int i=1;i<=n;i++)
    {
        if(v[i].size()!=1)continue;
        for(int i=1;i<=n;i++)
        {
            for(int j=0;j<v[i].size();i++)
            {
                weight[v[i][j].to][i]=1;
                weight[i][v[i][j].to]=1;
            }
        }
        bre=n-k-1;
        bfs(i);
    }
    cout<<ans<<endl;
}
/*
5 2
1 2 5
2 3 4
2 4 3
4 5 2
*/