#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
const int MAXN=2e5+4;
ll n,k,value[MAXN];
bool visited[MAXN];
vector<ll> put;
vector<pair<ll,ll>> adj[MAXN];
ll current_ans=0;
void chisti(){
  for(int i=1;i<=n;i++){
    value[i]=0;
    visited[i]=false;
  }
}
void bfs(ll x){
  queue<ll> q;
  q.push(x);
  value[x]=0;
  while(!q.empty()){
    ll node=q.front();
    q.pop();
    for(int i=0;i<adj[node].size();i++){
      ll vr=adj[node][i].first,w=adj[node][i].second;
      if(value[vr]==0&&vr!=x){
        value[vr]=value[node]+w;
        q.push(vr);
      }
    }
  }
  return;
}
void dfs(int node){
  put.push_back(node);
  visited[node]=true;
  for(int i=0;i<adj[node].size();i++){
      int vr=adj[node][i].first;
      if(!visited[vr]){
          visited[vr]=true;
          dfs(vr);
          put.push_back(node);
      }
  }
}
int br[MAXN];
vector<int> diam;
void find_put(int r){
  for(int i=1;i<=n;i++){
    br[i]=0;
  }
  diam.clear();
  for(int i=0;i<put.size();i++){
    int curr=put[i];
    if(curr==r){
      diam.push_back(r);
      return;
    }
    br[curr]++;
    if(br[curr]>1){
      br[curr]--;
      int krai=diam.size()-1;
      while(diam[krai]!=curr&&krai>=0){
        br[diam[krai]]--;
        diam.pop_back();
        krai--;
      }
    }else{
      diam.push_back(curr);
    }
  }
}
void nameri(){
  current_ans=0;
  chisti();
  bfs(1);
  int l,r;
  int idx=1;
  for(int i=2;i<=n;i++){
    if(value[i]>value[idx]){
      swap(idx,i);
    }
  }
  l=idx;
  chisti();
  bfs(idx);
  idx=1;
  for(int i=2;i<=n;i++){
    if(value[i]>value[idx]){
      swap(idx,i);
    }
  }
  r=idx;
  put.clear();
  diam.clear();
  current_ans=max(value[l],value[r]);
  chisti();
  dfs(l);
  find_put(r);
}
void namali(int a,int b){
  if(k==0){
    return;
  }
  k--;
  for(int i=0;i<adj[a].size();i++){
    if(adj[a][i].first==b&&adj[a][i].second!=0){
      adj[a][i].second--;
    }
  }
  for(int i=0;i<adj[b].size();i++){
    if(adj[b][i].first==a&&adj[b][i].second!=0){
      adj[b][i].second--;
    }
  }
}
void uvelichi(int a,int b){
  if(k==-1){
    return;
  }
  k++;
  for(int i=0;i<adj[a].size();i++){
    if(adj[a][i].first==b&&adj[a][i].second==0){
      adj[a][i].second++;
    }
  }
  for(int i=0;i<adj[b].size();i++){
    if(adj[b][i].first==a&&adj[b][i].second==0){
      adj[b][i].second++;
    }
  }
}
vector<pair<ll,ll>> edges;
int main(){
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  cin>>n>>k;
  ll ans=1000000;
  for(int i=1;i<n;i++){
    int u,v,w;
    cin>>u>>v>>w;
    adj[u].push_back({v,w});
    adj[v].push_back({u,w});
  }
  nameri();
  ans=current_ans;
  for(int i=0;i<40005;i++){
    for(int j=0;j<diam.size()-1;j++){
        namali(diam[j],diam[j+1]);
        nameri();
        if(current_ans<ans){
          ans=current_ans;
        }else{
          uvelichi(diam[j],diam[j+1]);
          nameri();
        }
        if(k==0){
          break;
        }
    }
    if(k==0){
      break;
    }
  }
  if(k>=n){
    cout<<0;
  }else{
  cout<<ans;
  }
  return 0;
}
