#include <iostream>
#include <vector>
#include <cassert>
#include <algorithm>
#include "cycles.h"

#include <bits/stdc++.h>
using namespace std;

template< class T, class T2 > inline bool chkmin( T& a, const T2& b ){ return a > b ? a = b, 1 : 0; };
template< class T, class T2 > inline bool chkmax( T& a, const T2& b ){ return a < b ? a = b, 1 : 0; };

#ifndef LOCAL
#define cerr if(false) cerr
#endif

#define out(x) #x << " = " << x << "  "
#define endl "\n"

typedef long long ll;
typedef long double ld;

const int MAX_N = 1e6;

/*
mt19337 gen( 420 );
int randNum( int lb, int ub ){
	std::uniform_int_distribution< int > dist( lb, ub );
	return dist( gen );
}
*/
inline int randNum( int ub ){
	return rand() % ub;
}

std::map< std::pair< int, int >, int > mm;
std::pair< int, bool > ask( int a, int b ){
	if( a > b ) std::swap( a, b );
	if( mm.find({ a, b }) == mm.end() ){
		return { mm[{ a, b }] = performSwap( a, b ), 1 };
	}

	return { mm[{ a, b }], 0 };
}

void sortPermutation(int N){
	srand( 420 );
	while( true ){
		int a = randNum( N-1 );
		int b = randNum( N-1 );
		while( b == a ) b = randNum( N );

		auto curr = ask( a, b );
		cerr << out( a ) << out( b ) << out( curr.first ) << out( curr.second )  << endl;

		if( curr.first == N ) return;

		if( curr.second ) performSwap( a, b );
	}
}