#include <iostream>
#include <vector>
#include <cassert>
#include <algorithm>
#include "cycles.h"

#include <bits/stdc++.h>
using namespace std;

template< class T, class T2 > inline bool chkmin( T& a, const T2& b ){ return a > b ? a = b, 1 : 0; };
template< class T, class T2 > inline bool chkmax( T& a, const T2& b ){ return a < b ? a = b, 1 : 0; };

#ifndef LOCAL
#define cerr if(false) cerr
#endif

#define out(x) #x << " = " << x << "  "
#define endl "\n"

typedef long long ll;
typedef long double ld;

const int MAX_N = 1e6;

void sortPermutation(int n){
	performSwap( 0, 1 );
	int prev = performSwap( 0, 1 );
	for( int i=0 ; i < n ; i += 2 ){
		int curr = performSwap( i, i+1 );
		if( curr < prev ) curr = performSwap( i, i+1 );
		prev = curr;
	}
/*
	srand( 420 );
	while( true ){
		int a = randNum( N-1 );
		int b = randNum( N-1 );
		while( b == a ) b = randNum( N );

		auto curr = ask( a, b );
		cerr << out( a ) << out( b ) << out( curr.first ) << out( curr.second )  << endl;

		if( curr.first == N ) return;

		if( curr.second ) performSwap( a, b );
	}
*/
}