#include <iostream>
#include <vector>
#include <cassert>
#include <algorithm>
#include "cycles.h"

#include <bits/stdc++.h>
using namespace std;

template< class T, class T2 > inline bool chkmin( T& a, const T2& b ){ return a > b ? a = b, 1 : 0; };
template< class T, class T2 > inline bool chkmax( T& a, const T2& b ){ return a < b ? a = b, 1 : 0; };

#ifndef LOCAL
#define cerr if(false) cerr
#endif

#define out(x) #x << " = " << x << "  "
#define endl "\n"

typedef long long ll;
typedef long double ld;

const int MAX_N = 1e6;


void sortPermutation(int n){
	int A, B;
	A = B = -1;
	performSwap( 0, 1 );
	int prev = performSwap( 0, 1 );
	for( int i=0 ; i < n-1 ; i++ ){
		int curr = performSwap( i, i+1 );
		cerr << out( i ) << out( i+1 ) << out( curr ) << out( prev ) << endl;
		if( curr > prev ){
			A = i+1;
			break;
		}
		prev = curr;
	}
	
	cerr << out( A ) << endl;
	for( int i=A-1 ; i >= 0 ; i --){
		cerr << out( i ) << out( i+1 ) << endl;
		performSwap( i, i+1 );
	}
	
	for( int i=0 ; i < n ; i++ ){
		if( A == i ) continue;
		int curr = performSwap( A, i );
		if( curr == n ) return;
		performSwap( A, i );
	}
}
