#include <bits/stdc++.h>
using namespace std;

template< class T, class T2 > inline bool chkmin( T& a, const T2& b ){ return a > b ? a = b, 1 : 0; };
template< class T, class T2 > inline bool chkmax( T& a, const T2& b ){ return a < b ? a = b, 1 : 0; };

#ifndef LOCAL
#define cerr if(false) cerr
#endif

#define out(x) #x << " = " << x << "  "
#define endl "\n"

typedef long long ll;
typedef long double ld;

const int MAX_N = 1e6;

std::vector< std::pair< int, int > > v[MAX_N];

bool viz[MAX_N];
ll dist[MAX_N];

int main(){
#ifndef LOCAL
		std::ios_base::sync_with_stdio( false); cin.tie( NULL ); cout.tie( NULL );
#endif

	int n, k;
	std::cin >> n >> k;
	for( int i=0 ; i < n-1 ; i++ ){
		ll a, b, c;
		std::cin >> a >> b >> c;
		a--; b--;
		v[a].push_back({ b, c });
		v[b].push_back({ a, c });
	}

	for( int i=0 ; i < n ; i++ ){
		dist[i] = 0;
		viz[i] = false;
	}

	std::queue< int > q;
	q.push( 0 );
	ll mx = -1;
	int A = -1;
	while( !q.empty() ){
		auto curr = q.front(); q.pop();
		viz[ curr ] = true;
		if( chkmax( mx, dist[ curr ] ) ) A = curr;
		for( auto j : v[curr] ){
			if( viz[j.first] ) continue;
			dist[j.first] = dist[ curr ] + j.second;
			q.push( j.first );
		}
	}

	cerr << out( A ) << endl;
	for( int i=0 ; i < n ; i++ ){
		dist[i] = 0;
		viz[i] = false;
	}
	q.push( A );
	mx = -1;
	int B = -1;
	while( !q.empty() ){
		auto curr = q.front(); q.pop();
		viz[ curr ] = true;
		if( chkmax( mx, dist[ curr ] ) ) B = curr;
		for( auto j : v[curr] ){
			if( viz[j.first] ) continue;
			dist[j.first] = dist[ curr ] + j.second;
			q.push( j.first );
		}
	}

	cerr << out( B ) << endl;
	cerr << out( dist[ B ] );

	std::cout << dist[B] << endl;
	return 0;
}
