#include<bits/stdc++.h>

#define MAXN 200002

using namespace std;

int n, k, dist[MAXN], from;
bool vis[MAXN], sec = false;

vector<pair<int, int> > M[MAXN];

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin>>n>>k;
    for(int i = 0; i < n - 1; i ++)
    {
        int u, v, w;
        cin>>u>>v>>w;
        M[u].push_back({v, w});
        M[v].push_back({u, w});
    }
}
long long bfs(int v)
{
    long long maxDist = 0, maxV = v;
    memset(vis, 0, sizeof vis);
    fill_n(dist, n + 1, 1e9);
    queue<int> q;
    q.push(v);
    dist[v] = 0;
    while(q.size())
    {
        int tp = q.front();
        q.pop();
        if(vis[tp]) continue;
        vis[tp] = 1;
        for(int i = 0; i < M[tp].size(); i ++)
        {
            pair<int, int> edge = M[tp][i];
            q.push(edge.first);
            dist[edge.first] = min(dist[edge.first], dist[tp] + edge.second);
            if(dist[edge.first] > maxDist && dist[edge.first] != 1e9)
            {
                maxDist = dist[edge.first];
                maxV = edge.first;
                from = i;
            }
        }
    }
    return maxV;
}
long long findDiameter()
{
    int to = bfs(1);
    int d = bfs(to);
    if(k)
    {
        M[d][from].second -= k;
        int u = M[d][from].first;
        for(int i = 0; i < M[u].size(); i ++)
        {
            if(M[u][i].first == d) M[u][i].second -= k;
        }
    }
    to = bfs(1);
    //cout<<dist[to]<<endl;
    d = bfs(to);
    //cout<<dist[d]<<endl;
    return dist[d];
}
int main()
{
    read();
    long long d = findDiameter();
    cout<<d<<endl;
    return 0;
}
/*
5 1
1 2 5
2 3 1
2 4 3
4 5 2
*/
