#include<bits/stdc++.h>

#define MAXN 200002
#define int long long

using namespace std;

int n, k, dist[MAXN], from, dp[MAXN], nxt[MAXN], should[MAXN];
bool vis[MAXN], sec = false, flag, onPath[MAXN];

vector<pair<int, int> > M[MAXN];

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin>>n>>k;
    for(int i = 0; i < n - 1; i ++)
    {
        int u, v, w;
        cin>>u>>v>>w;
        M[u].push_back({v, w});
        M[v].push_back({u, w});
    }
}
long long bfs(int v)
{
    long long maxDist = 0, maxV = v;
    memset(vis, 0, sizeof vis);
    fill_n(dist, n + 1, 1e9);
    queue<int> q;
    q.push(v);
    dist[v] = 0;
    while(q.size())
    {
        int tp = q.front();
        q.pop();
        if(vis[tp]) continue;
        vis[tp] = 1;
        for(int i = 0; i < M[tp].size(); i ++)
        {
            pair<int, int> edge = M[tp][i];
            q.push(edge.first);
            dist[edge.first] = min(dist[edge.first], dist[tp] + edge.second);
            if(dist[edge.first] > maxDist && dist[edge.first] != 1e9)
            {
                maxDist = dist[edge.first];
                maxV = edge.first;
                from = i;
            }
        }
    }
    return maxV;
}
long long dfs(int v, int p, int d)
{
    if(v == d)
    {
        onPath[v] = true;
        flag = true;
        nxt[v] = -1;
        return should[v] = 0;
    }
    for(int i = 0; i < M[v].size(); i ++)
    {
        pair<int, int> to = M[v][i];
        if(to.first != p)
        {
            int cur = dfs(to.first, v, d);
            if(flag)
            {
                nxt[v] = to.first;
                onPath[v] = true;
                return should[v] = to.second + cur;
            }
        }
    }
    return 0;
}
long long calc(int v, int p)
{
    for(auto to : M[v])
    {
        if(to.first != p)
        {
            long long cur = calc(to.first, v) + to.second;
            //cout<<v<<" "<<onPath[v]<<endl;
            if(cur == should[v] && to.first != nxt[v] && onPath[v]) sec = true;
            dp[v] += cur;
        }
    }
    return dp[v];
}
long long findDiameter()
{
    int to = bfs(1);
    int d = bfs(to);
    dfs(to, -1, d);
    calc(to, -1);
    return dist[d];
}
signed main()
{
    read();
    long long d = findDiameter();
    if(!sec) cout<<d - k<<endl;
    else cout<<d<<endl;
    return 0;
}
/*
5 1
1 2 5
2 3 5
2 4 3
4 5 2
*/
