///izlagate se s tezi bezalkoholni napitki
#include <bits/stdc++.h>
using namespace std;

struct point
{
    long long x, y;
    point() {}
    point(long long _x, long long _y)
    {
        x=_x;
        y=_y;
    }
};

bool cmp_x(point p, point q)
{
    return (p.x<q.x || (p.x==q.x && p.y<q.y));
}

long long det_val(point a, point b, point c)
{
    return a.x*b.y+b.x*c.y+c.x*a.y-b.y*c.x-a.y*b.x-c.y*a.x;
}

const int MAXN=100005;

int n;
point P[MAXN];
vector<point> cvhull;

bool cmp_nakl(point p, point q)
{
    if(det_val(P[0], p, q)!=0) return det_val(P[0], p, q)>0;
    return p.x+p.y<q.x+q.y;
}

void init(const std::vector<int>& A, const std::vector<int>& B)
{
    n=A.size();
    for(int i=0; i<n; i++) P[i]=point(A[i], B[i]);
    sort(P, P+n, cmp_x);
    sort(P+1, P+n, cmp_nakl);
    cvhull.push_back(P[0]);
    cvhull.push_back(P[1]);
    for(int i=2; i<n; i++)
    {
        while(cvhull.size()>=2 && det_val(cvhull[cvhull.size()-2], cvhull[cvhull.size()-1], P[i])<=0) cvhull.resize(cvhull.size()-1);
        cvhull.push_back(P[i]);
    }
    for(int i=1; i<n; i++)
    {
        if(P[i].y>P[i-1].y)
        {
            cvhull.resize(i);
            break;
        }
    }
    ///for(int i=0; i<cvhull.size(); i++) cout<<P[i].x<<" "<<P[i].y<<endl;
}

double friendDrink(int Ma, int Mb, int La, int Ra)
{
    return 0;
}
