#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN=500005;

struct edge
{
    int v;
    long long dist;
    edge() {}
    edge(int _v, long long _dist)
    {
        v=_v;
        dist=_dist;
    }
};

long long n, k;
vector<edge> gr[MAXN];
int par[MAXN];
bool used[MAXN];
vector<int> toposort;

void construct_tree(int v)
{
    used[v]=1;
    int brs=gr[v].size();
    for(int i=0; i<brs; i++)
    {
        int nv=gr[v][i].v;
        if(used[nv]) continue;
        par[nv]=v;
        construct_tree(nv);
    }
    toposort.push_back(v);
}

long long akk_dl=0;
long long Ld[MAXN];

void dfs(int v, long long ogr)
{
    int brs=gr[v].size();
    for(int i=0; i<brs; i++)
    {
        int nv=gr[v][i].v;
        if(par[nv]!=v) continue;
        long long td=gr[v][i].dist+Ld[nv];
        if(Ld[v]+td>ogr)
        {
            akk_dl+=Ld[v]+td-ogr;
            if(Ld[v]>(ogr+1)/2) Ld[v]=max(ogr-td, (ogr+1)/2);
        }
        else Ld[v]=max(td, Ld[v]);
    }
}

bool poss(long long Lpath)
{
    akk_dl=0;
    for(int i=0; i<=n; i++) Ld[i]=0;
    for(int i=0; i<n; i++) dfs(toposort[i], Lpath);
    return (akk_dl<=k);
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>k;
    for(int i=0; i<n-1; i++)
    {
        long long u, v, ds;
        cin>>u>>v>>ds;
        gr[u].push_back(edge(v, ds));
        gr[v].push_back(edge(u, ds));
    }
    par[1]=1;
    construct_tree(1);
    long long le=-1, ri=2e9;
    while(ri-le>1)
    {
        long long mid=(le+ri)/2;
        if(poss(mid)) ri=mid;
        else le=mid;
    }
    cout<<ri<<endl;
    return 0;
}
/**
5 2
1 2 1
2 3 1
2 4 1
4 5 1
*/
