#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const int MAXN = 2e5 + 10;

int n, k;
vector < pair < int, int > > adj[MAXN];
void input()
{
    cin >> n >> k;
    for (int i = 1; i < n; i ++)
    {
        int v, u, w;
        cin >> v >> u >> w;
        adj[v].push_back({u, w});
        adj[u].push_back({v, w});
    }
}


int dist[MAXN];
void dfs(int v, int p)
{
    for (pair < int, int > cur : adj[v])
    {
        if (cur.first == p)
            continue;
        dist[cur.first] = dist[v] + cur.second;
        dfs(cur.first, v);
    }
}

void solve()
{
    input();
    dfs(1, -1);
    int a = 1;
    for (int i = 1; i <= n; i ++)
        if (dist[i] > dist[a])
            a = i;
            dist[a] = 0;
    dfs(a, -1);
    int ans = 0;
    for (int i = 1; i <= n; i ++)
        ans = max(ans, dist[i]);
    cout << ans << endl;
}

int main()
{
    speed();
    solve();
    return 0;
}
