#include "soft_drinks.h"
#include<bits/stdc++.h>
#define fi first
#define se second

using namespace std;

const int MAXN=1e5+5;
const double INFD=2000000005;

int n;
pair<int,int> p[MAXN];

double dvd(double a,double b)
{
    if(b==0) return INFD;
    return (double)a/b;
}

int bsLA(int x)
{
    int l=1,r=n;
    while(l<r)
    {
        int mid=(l+r)/2;
        if(p[mid].fi<x) l=mid+1;
        else r=mid;
    }
    if(p[l].fi<x) return n+1;
    return l;
}
int bsRA(int x)
{
    int l=1,r=n;
    while(l<r)
    {
        int mid=(l+r+1)/2;
        if(p[mid].fi>x) r=mid-1;
        else l=mid;
    }
    if(p[l].fi>x) return 0;
    return l;
}

double calc(pair<int,int> p1,pair<int,int> p2,int A,int B)
{
    double t=min(dvd(A,p1.fi), dvd(B,p1.se));
    double x=min(max((double)0, dvd(1LL*p2.fi*B-1LL*p2.se*A, 1LL*p1.se*p2.fi-1LL*p2.se*p1.fi)), t);
    double y=(double)(A-x*p1.fi)/p2.fi;
    return x+y;
}

void init(const std::vector<int>& A, const std::vector<int>& B)
{
    n=A.size();
    for(int i=0;i<n;i++)
    {
        p[i+1]={A[i],B[i]};
    }
    sort(p+1,p+n+1);
}

vector<pair<int,int> > v;
double friendDrink(int Ma, int Mb, int La, int Ra)
{
    int l=bsLA(La);
    int r=bsRA(Ra);
//cout<<l<<" , "<<r<<endl;
    v.clear();
    for(int i=l;i<=r;i++)
    {
        if(1<=i && i<=n) 
        {
            if(v.empty()) v.push_back(p[i]);
            else if(p[i].se<v.back().se) v.push_back(p[i]);
        }
    }

    if(v.empty()) return 0;
    if(v.size()==1)
    {
        return min(dvd(Ma,v[0].fi), dvd(Mb,v[0].se));
    }
    //for(int i=0;i<v.size();i++) cout<<v[i].fi<<" "<<v[i].se<<" | "; cout<<endl;
    double vol=calc(v[0], v[1], Ma, Mb);
    //cout<<vol<<endl;
    for(int i=2;i<v.size();i++)
    {
        vol=calc({dvd(Ma,vol), dvd(Mb,vol)}, v[i], Ma, Mb);
    }

    return vol;
}