#include "soft_drinks.h"
#include<bits/stdc++.h>
#define fi first
#define se second

using namespace std;

const int MAXN=1e5+5;
const double INFD=2e9+5;

int n;
pair<int,int> p1[MAXN];
pair<int,int> p[MAXN];
double rp[MAXN];

double dvd(int a,int b)
{
    if(b==0) return INFD;
    return (double)a/b;
}

int bsLA(int x)
{
    int l=1,r=n;
    while(l<r)
    {
        int mid=(l+r)/2;
        if(p1[mid].fi<x) l=mid+1;
        else r=mid;
    }
    if(p1[l].fi<x) return n+1;
    return l;
}
int bsRA(int x)
{
    int l=1,r=n;
    while(l<r)
    {
        int mid=(l+r+1)/2;
        if(p1[mid].fi>x) r=mid-1;
        else l=mid;
    }
    if(p1[l].fi>x) return 0;
    return l;
}

double calc(pair<int,int> p1,pair<int,int> p2,int A,int B)
{
    /*double rel=dvd(B,A);
    double rel1=dvd(p1.se,p1.fi);
    double rel2=dvd(p2.se,p2.fi);
    if(rel1<rel2) swap(p1,p2);
    if(rel2>rel)
    {
        return dvd(B,p2.se);
    }
    if(rel>rel1)
    {
        return dvd(A,p1.fi);
    }*/
    double t=min(dvd(A,p1.fi), dvd(B,p1.se));
    double x=min(max((double)0, dvd(1LL*p2.fi*B-1LL*p2.se*A, 1LL*p1.se*p2.fi-1LL*p2.se*p1.fi)), t);
    double y=(double)(A-x*p1.fi)/p2.fi;
    return x+y;
}

void init(const std::vector<int>& A, const std::vector<int>& B)
{
    n=A.size();
    for(int i=0;i<n;i++)
    {
        p1[i+1]={A[i],B[i]};
    }
    sort(p1+1,p1+n+1);
    /*int ind=1;
    p[ind]=p1[1];
    for(int i=2;i<=n;i++)
    {
        if(p1[i].se>=p[ind].se) continue;
        else p[++ind]=p1[i];
    }
    n=ind;

    for(int i=1;i<=n;i++)
    {
        rp[i]=dvd(p[i].fi,p[i].se);
    }*/
}

vector<pair<int,int> > v;
double friendDrink(int Ma, int Mb, int La, int Ra)
{
    double rel=dvd(Ma,Mb);

    int l=bsLA(La);
    int r=bsRA(Ra);
//cout<<l<<" , "<<r<<endl;

    int ind=l;
    p[ind]=p1[l];
    for(int i=l+1;i<=r;i++)
    {
        if(p1[i].se>=p[ind].se) continue;
        else p[++ind]=p1[i];
    }
    r=ind;
    for(int i=l;i<=r;i++)
    {
        rp[i]=dvd(p[i].fi,p[i].se);
    }

    if(l>r) return 0;
    if(l==r)
    {
        return min(dvd(Ma,p[l].fi), dvd(Mb,p[l].se));
    }

    int le=l, ri=r;
    while(le<ri)
    {
        int mid=(le+ri+1)/2;
        if(rp[mid]<rel) le=mid;
        else ri=mid-1;
    }
    if(rp[le]>=rel || le==r)
    {
        return min(dvd(Ma,p[le].fi), dvd(Mb,p[le].se));
    }

    ind=le;
    int nxt=ind+1;
    return calc(p[ind], p[ind+1], Ma, Mb);
}