#include<bits/stdc++.h>
#define endl '\n'
#define fi first
#define se second

using namespace std;

const int MAXN=2e5+5;

int n,k;
vector<int> adj[MAXN];
vector<pair<int,int> > adj2[MAXN];
int par[MAXN];
vector<int> leaves;
vector<int> newLf;
pair<int,int> maxd[MAXN];
int ans=0;
set<pair<int,int> > mark;

void dfs(int v)
{
    for(auto u: adj[v])
    {
        if(u==par[v]) continue;
        par[u]=v;
        dfs(u);
    }
    if(adj[v].size()==1) leaves.push_back(v);
}

void add(int v,int p)
{
    mark.insert({min(v,p), max(v,p)});
    if(newLf.empty()) newLf.push_back(p);
    else if(newLf.back()!=p) newLf.push_back(p);
}

void dfs2(int v,int pr)
{
    maxd[v]={0,0};
    for(auto [u,w]: adj2[v])
    {
        if(u==pr) continue;
        dfs2(u,v);
        if(mark.find({min(v,u), max(v,u)})!=mark.end()) w=1;
        int cur=maxd[u].fi+w;
        if(cur>maxd[v].fi)
        {
            maxd[v].se=maxd[v].fi;
            maxd[v].fi=cur;
        }
        else if(cur>maxd[v].se) maxd[v].se=cur;
    }
    if(pr==-1)
    {
        if(adj2[v].size()>=2) ans=max(ans, maxd[v].fi+maxd[v].se);
    }
    else
    {
        if(adj2[v].size()>=3) ans=max(ans, maxd[v].fi+maxd[v].se);
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin>>n>>k;
    for(int i=1;i<n;i++)
    {
        int u,v,w;
        cin>>u>>v>>w;
        adj[u].push_back(v);
        adj[v].push_back(u);
        adj2[u].push_back({v,0});
        adj2[v].push_back({u,0});
    }

    for(int i=1;i<=n;i++) sort(adj[i].begin(), adj[i].end());

    int root=1;
    par[root]=-1;
    dfs(root);

    while(k>0)
    {
        for(int i=0;i<leaves.size();i++)
        {
            if(k==0) break;
            add(leaves[i], par[leaves[i]]);
            k--;
        }
        if(k==0) break;
        leaves=newLf;
        newLf.clear();
    }

    dfs2(1,-1);

    cout<<ans<<endl;

    return 0;
}