#include<bits/stdc++.h>
#define endl '\n'
#define fi first
#define se second

using namespace std;

const int MAXN=2e5+5;

int n,k;
vector<int> adj[MAXN];
int par[MAXN];
vector<pair<int,int> > adj2[MAXN];
int h[MAXN];
unordered_set<long long> mark;
pair<int,int> maxd[MAXN];
int ans=0;

long long num(int u,int v)
{
    return 1LL*(n+1)*min(u,v)+max(u,v);
}

void dfs(int v)
{
    h[v]=0;
    for(auto u: adj[v])
    {
        if(u==par[v]) continue;
        par[u]=v;
        dfs(u);
        h[v]=max(h[v], h[u]+1);
    }
}

void dfs2(int v,int pr)
{
    maxd[v]={0,0};
    for(auto [u,w]: adj2[v])
    {
        if(u==pr) continue;
        dfs2(u,v);
        if(mark.find(num(u,v))!=mark.end()) w=1;
        //if(w==0) cout<<"aaaa "<<u<<" "<<v<<endl;
        int cur=maxd[u].fi+w;
        if(cur>maxd[v].fi)
        {
            maxd[v].se=maxd[v].fi;
            maxd[v].fi=cur;
        }
        else if(cur>maxd[v].se) maxd[v].se=cur;
    }
    //cout<<v<<" "<<maxd[v].fi<<" "<<maxd[v].se<<endl;
    ans=max(ans, maxd[v].fi);
    if(pr==-1)
    {
        if(adj2[v].size()>=2) ans=max(ans, maxd[v].fi+maxd[v].se);
    }
    else
    {
        if(adj2[v].size()>=3) ans=max(ans, maxd[v].fi+maxd[v].se);
    }
}

bool cmp(int x,int y)
{
    return h[x]<h[y];
}
bool cmpDg(int x,int y)
{
    return adj[x].size()>adj[y].size();
}

std::chrono::time_point<std::chrono::steady_clock> st=std::chrono::steady_clock::now();
const double TIME_LIMIT=0.42;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin>>n>>k;
    for(int i=1;i<n;i++)
    {
        int u,v,w;
        cin>>u>>v>>w;
        adj[u].push_back(v);
        adj[v].push_back(u);
        adj2[u].push_back({v,0});
        adj2[v].push_back({u,0});
    }

    if(k>=n-1)
    {
        cout<<0<<endl;
        return 0;
    }
    k=n-1-k;

    vector<int> dg;
    for(int i=1;i<=n;i++) dg.push_back(i);
    sort(dg.begin(), dg.end(), cmpDg);
    int Ans=2e9+5;
    int c=n/2;
    //if(n>2000) c=5; // 2 - 10
    //if(n>5000) c=20000;
    for(int i=0;i<c;i++)
    {
        if(n>2000)
        {
            auto en=std::chrono::steady_clock::now();
            std::chrono::duration<double> diff = en-st;
            if(diff.count()>TIME_LIMIT) break;
        }
        ans=0;
        mark.clear();
        int root=dg[i];
        par[root]=-1;
        dfs(root);

        vector<int> perm;
        for(int j=1;j<=n;j++) perm.push_back(j);
        sort(perm.begin(), perm.end(), cmp);

        //cout<<root<<endl;
        //for(int j=0;j<n;j++) cout<<perm[j]<<" "; cout<<endl;
        for(int j=0;j<k;j++)
        {
            mark.insert(num(perm[j], par[perm[j]]));
            //cout<<perm[j]<<" "<<par[perm[j]]<<" ; ";
        }//cout<<endl;

        dfs2(root,-1);
        Ans=min(Ans,ans);
    }

    cout<<Ans<<endl;
    
    return 0;
}