#include<bits/stdc++.h>
#define lli long long
#define endl "\n"
#include "soft_drinks.h"
using namespace std;
const lli MAXN=100005, INF=999999999999999;
const double eps=0.0000001;
lli sug[MAXN], kis[MAXN], N;
double calc_q(lli Ma, lli Mb, lli ind){
    double ans=0;
    if(sug[ind]==0) ans=(Mb/(kis[ind]*1.0));
    else if(kis[ind]==0) ans=(Ma/(sug[ind]*1.0));
    else ans=max(Ma/(sug[ind]*1.0), Mb/(kis[ind]*1.0));
    return ans;
}
double calc(double v, lli Ma, lli Mb){
    double t1=INF;
    if(sug[1]!=0)t1=(Ma-v*(sug[0]+sug[1]))/sug[1];
    double t2=INF;
    if(kis[1]!=0)t2=(Mb-v*(kis[0]+kis[1]))/kis[1];
    double ans=min(t1, t2);
    ans+=2*v;
    return ans;
}
double tsearch(lli Ma, lli Mb){
    double l=0, r=calc_q(Ma, Mb, 0);
    while(r-l>eps){
        //cout<<l<<" "<<r<<endl;
        double mid1=l+((r-l)/3.0), mid2=l+(2*(r-l)/3.0);
        if(calc(mid1, Ma, Mb)>calc(mid2, Ma, Mb)){
            r=mid2;
        }else l=mid1;
    }
    return l;
}
void init(const std::vector<int>& A, const std::vector<int>& B){
    N=A.size();
    for(lli i=0; i<N; i++){
        sug[i]=A[i];
        kis[i]=B[i];
    }
    return;
}
double friendDrink(int Ma, int Mb, int La, int Ra){
    if(N==1){
        if(La<=sug[0] and sug[0]<=Ra){
            double q=calc_q(Ma, Mb, 0);
            return q;
        }
        return 0;
    }
    if(!(La<=sug[0] and sug[0]<=Ra) and !(La<=sug[1] and sug[1]<=Ra)){
        return 0;
    }
    if(!(La<=sug[0] and sug[0]<=Ra)){
        double q=calc_q(Ma, Mb, 1);
        //cout<<"1 "<<q<<endl;
        return q;
    }
    if(!(La<=sug[1] and sug[1]<=Ra)){
        double q=calc_q(Ma, Mb, 0);
        //cout<<"2 "<<q<<endl;
        return q;
    }
    return tsearch(Ma, Mb);
}
