#include <bits/stdc++.h>
#define all(a) a.begin(), a.end()

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<double, double> pdd;

vector<pii> arr;
void init(const std::vector<int>& A, const std::vector<int>& B) {
    for (int i = 0; i < A.size(); i++)
        arr.push_back(pii(A[i], B[i]));
    sort(all(arr));
    vector<pii> narr = {arr[0]};
    for (int i = 1; i < arr.size(); i++) {
        if (narr.back().second <= arr[i].second)
            continue;
        if (arr[i].first == arr[i - 1].first)
            continue;
        narr.push_back(arr[i]);
    }
    arr = narr;
}
double friendDrink(const int Ma, const int Mb, const int La, const int Ra) {
    if (Ra < arr[0].first || La > arr.back().first)
        return 0;
    pii D1 = *lower_bound(all(arr), pii(La, -1));
    pii D2 = *prev(lower_bound(all(arr), pii(Ra + 1, -1)));

    pdd d1(D1.first, D1.second);
    pdd d2(D2.first, D2.second);
    double ma = Ma, mb = Mb;

    if (d1 == d2)
    {
        if (d1.first == 0)
            return mb / d2.second;
        if (d1.second == 0)
            return ma / d1.first;
        return min(ma / d1.first, mb / d1.second);
    }

    if (d1.first == 0 and d2.second == 0)
        return mb / d1.second + ma / d2.first;

    
    if (d1.first == 0) {
        swap(d1.first, d1.second);
        swap(d2.first, d2.second);
        swap(ma, mb);
        swap(d1, d2);
    }
    
    double ini = ma / d1.first;
    if (ini * d1.second <= mb)
        return ini;
    
    double x, y;
    y = ((d1.second / d1.first) * ma - mb) / (d1.second * (d2.first / d1.first) - d2.second);
    x = (ma - y * d2.first) / d1.first;

    return x + y;
}
