#include <bits/stdc++.h>
#define all(a) a.begin(), a.end()

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<double, double> pdd;

vector<pii> arr;
void init(const std::vector<int>& A, const std::vector<int>& B) {
    for (int i = 0; i < A.size(); i++)
        arr.push_back(pii(A[i], B[i]));
    sort(all(arr));
}

double do_pair(int Ma, int Mb, int La, int Ra, pii D1, pii D2) {
    if (D1 > D2)
        swap(D1, D2);
    if (D1.second < D2.second)
        D2 = D1;

    pdd d1(D1.first, D1.second);
    pdd d2(D2.first, D2.second);
    double ma = Ma, mb = Mb;

    if (d1 == d2)
    {
        if (d1.first == 0)
            return mb / d2.second;
        if (d1.second == 0)
            return ma / d1.first;
        return min(ma / d1.first, mb / d1.second);
    }

    if (d1.first == 0 and d2.second == 0)
        return mb / d1.second + ma / d2.first;
    
    if (d1.first == 0) {
        swap(d1.first, d1.second);
        swap(d2.first, d2.second);
        swap(ma, mb);
        swap(d1, d2);
    }
    
    double ini = ma / d1.first;
    if (ini * d1.second <= mb)
        return ini;
    ini = mb / d2.second;
    if (ini * d2.first <= ma)
        return ini;
    
    double x, y;
    y = ((d1.second / d1.first) * ma - mb) / (d1.second * (d2.first / d1.first) - d2.second);
    x = (ma - y * d2.first) / d1.first;

    return x + y;
}

double friendDrink(const int Ma, const int Mb, const int La, const int Ra) {
    double out = 0;
    vector<pii> possible;
    for (int i = 0; i < arr.size(); i++) {
        if (arr[i].first >= La and arr[i].first <= Ra)
            possible.push_back(arr[i]);
    }
    if (possible.empty())
        return 0;
    vector<pii> narr = {possible[0]};
    for (int i = 1; i < possible.size(); i++) {
        if (narr.back().second <= possible[i].second)
            continue;
        narr.push_back(possible[i]);
    }
    out = max(do_pair(Ma, Mb, La, Ra, narr.front(), narr.back()), do_pair(Ma, Mb, La, Ra, narr.back(), narr.front()));
    return out;
}
