#include <bits/stdc++.h>
#define all(a) a.begin(), a.end()

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pii;
typedef array<ll, 3> tupl;

vector<vector<pii> > graph;
vector<ll> dpth;
vector<tupl> best_two;

tupl insert(tupl me, int guy) {
    if (dpth[me[0]] <= dpth[guy]) {
        me[2] = me[1];
        me[1] = me[0];
        me[0] = guy;
    } else if (dpth[me[1]] <= dpth[guy]) {
        me[2] = me [1];
        me[1] = guy;
    } else if (dpth[me[2]] < dpth[guy])
        me[2] = guy;
    return me;
}

ll get_reduced(tupl me) {
    me[0]--;
    ll out = 0;
    for (int i = 0; i < 3; i++)
        for (int j = i + 1; j < 3; j++)
            out = max(out, me[i] + me[j]);
    return out;
}

int k;
vector<ll> ans, par, vis;
ll get(int curr, int p = -1) {
    ll out = 0;
    par[curr] = p;
    best_two[curr][0] = curr;
    for (auto [f, w] : graph[curr]) {
        if (f == p)
            continue;
        dpth[f] = dpth[curr] + w;
        out = max(out, get(f, curr));
        best_two[curr] = insert(best_two[curr], best_two[f][0]);
    }
    ans[curr] = dpth[best_two[curr][0]] + dpth[best_two[curr][1]] - dpth[curr] * 2;
    return max(out, ans[curr]);
}

vector<int> col;
ll try_dec(int curr, int p = -1) {
    for (auto [f, w] : graph[curr]) {
        if (f == p)
            continue;
        col[curr] += try_dec(f, curr);
    }
    return col[curr];
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n;
    cin >> n >> k;

    graph = vector<vector<pii> >(n + 1);
    dpth = par = vis = ans = vector<ll>(n + 1);
    col = vector<int> (n + 1);
    best_two = vector<tupl>(n + 1, tupl({0, 0, 0}));
    for (int i = 1; i < n; i++) {
        int f, t, w;
        cin >> f >> t >> w;
        graph[f].emplace_back(t, w);
        graph[t].emplace_back(f, w);
    }

    if (n == 1) {
        cout << "0\n";
        return 0;
    } else if (n == 2) {
        cout << max(0LL, graph[1][0].second - k) << "\n";
        return 0;
    }

    int rt = 0;
    vector<int> lifs;
    for (int i = 1; i <= n; i++)
    {
        if (graph[i].size() > 1)
            rt = i;
        else
            lifs.push_back(i);
    }

    ll out = get(rt);

    if (k == 0)
    {
        cout << out << "\n";
        return 0;
    }
    
    bool can = true;
    vector<int> cnt; int dang = 0;
    // see if anyone has 3
    for (int i = 1; i <= n; i++) {
        if (ans[i] != out)
            continue;
        if (dpth[best_two[i][0]] == dpth[best_two[i][2]])
            can = false;
        col[i] -= 2;
        col[best_two[i][0]]++;
        col[best_two[i][1]]++;
        dang++;
    }
    if (!can) {
        cout << out << "\n";
        return 0;
    }
    try_dec(rt);
    bool found = false;
    for (int i = 1; i <= n; i++)
        if (col[i] == dang)
            found = true;
    if (found)
        out--;
    cout << out << "\n";
}