#include <bits/stdc++.h>
#include "soft_drinks.h"

using namespace std;

double eps = 0.000000001d;
double inf = 1e9;

struct vc
{
    double x, y;
};

double solo(vc A, double Ma, double Mb)
{
    double ct = 1e9;
    if (A.x != 0)
        ct = min(ct, (double)Ma / (double)A.x);
    if (A.y != 0)
        ct = min(ct, (double)Mb / (double)A.y);
    return ct;
}

double ff(vc A, vc B, double Ma, double Mb, double tr)
{
    Ma -= A.x * tr;
    Mb -= A.y * tr;
    if (Ma < 0 or Mb < 0)
        return 0;
    return tr + solo(B, Ma, Mb);
}

double duo(vc A, vc B, double Ma, double Mb)
{
    double st = 0, pas = 1 << 20;
    while (pas > eps)
    {
        double tr = st + pas;
        if (ff(A, B, Ma, Mb, tr) != 0 and ff(A, B, Ma, Mb, tr) < ff(A, B, Ma, Mb, tr + eps * 10.0d))
            st += pas;
        pas /= 2.0d;
    }
    return ff(A, B, Ma, Mb, st);
}

pair<vc, vc> redu(vc A, vc B, vc C, double Ma, double Mb)
{
    if (A.x > B.x)
        swap(A, B);
    if (A.x > C.x)
        swap(A, C);
    if (C.x > B.x)
        swap(B, C);
    double ct = duo(A, B, C.x, C.y);
    if (ct > 1.0d)
        return {A, B};
    else
    {
        double ct1 = duo(A, C, Ma, Mb), ct2 = duo(B, C, Ma, Mb);
        if (ct1 > ct2)
            return {A, C};
        else
            return {B, C};
    }
}

int n;
vc a[100005];

void init(const vector<int> & A, const vector<int>& B)
{
    n = A.size();
    for (int i = 1; i <= n; i++)
        a[i].x = A[i - 1], a[i].y = B[i - 1];
}

double friendDrink(int Ma, int Mb, int La, int Ra)
{
    vector<vc> v;
    for (int i = 1; i <= n; i++)
        if (a[i].x >= La and a[i].x <= Ra)
            v.push_back(a[i]);
    double ans = 0;
    if (v.empty())
        return 0;
    if (v.size() == 1)
        return solo(v[0], Ma, Mb);
    pair<vc, vc> pp = {v[0], v[1]};
    for (int i = 2; i < v.size(); i++)
        pp = redu(pp.first, pp.second, v[i], Ma, Mb);
    ans = max(duo(pp.first, pp.second, Ma, Mb), max(solo(pp.first, Ma, Mb), solo(pp.second, Ma, Mb)));
    return ans;
}
