#include <bits/stdc++.h>

using namespace std;

int inf = 2e9;

int n, k;
vector<pair<int, int>> g[200005];

vector<int> bfs(int orig)
{
    vector<int> d(n + 1);
    for (int i = 1; i <= n; i++)
        d[i] = inf;
    d[orig] = 0;
    queue<int> q;
    q.push(orig);
    while (!q.empty())
    {
        int nod = q.front();
        q.pop();
        for (auto vecin : g[nod])
        {
            if (d[vecin.first] == inf)
            {
                d[vecin.first] = d[nod] + vecin.second;
                q.push(vecin.first);
            }
        }
    }
    return d;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >> n >> k;
    for (int i = 1; i < n; i++)
    {
        int x, y, z;
        cin >> x >> y >> z;
        g[x].push_back({y, z});
        g[y].push_back({x, z});
    }
    vector<int> d = bfs(1);
    int mx = 0, cn = 1;
    for (int i = 2; i <= n; i++)
        if (d[i] > mx)
            mx = d[i], cn = i;
    d = bfs(cn);
    mx = 0;
    for (int i = 1; i <= n; i++)
        mx = max(mx, d[i]);
    cout << mx;
    return 0;
}
