#include <bits/stdc++.h>

using namespace std;

#define int long long

int inf = 2e9;

int n, k;
vector<pair<int, int>> g[200005];

vector<int> bfs(int orig)
{
    vector<int> d(n + 1);
    for (int i = 1; i <= n; i++)
        d[i] = inf;
    d[orig] = 0;
    queue<int> q;
    q.push(orig);
    while (!q.empty())
    {
        int nod = q.front();
        q.pop();
        for (auto vecin : g[nod])
        {
            if (d[vecin.first] == inf)
            {
                d[vecin.first] = d[nod] + vecin.second;
                q.push(vecin.first);
            }
        }
    }
    return d;
}

int diametru;
int dp[2005][2005], d[2005][2005], sz[2005];

void root(int nod, int tata)
{
    sz[nod] = 1;
    vector<int> sons;
    for (auto vecin : g[nod])
        if (vecin.first != tata)
            sons.push_back(vecin.first);
    for (auto it : sons)
        root(it, nod), sz[nod] += sz[it];
    if (sons.empty())
    {
        dp[nod][0] = 1;
        for (int i = 1; i <= n; i++)
            dp[nod][i] = 0;
    }
    else
    {
        for (int i = 0; i <= sons.size(); i++)
            for (int j = 0; j <= n; j++)
                d[i][j] = 0;
        int mr = 0;
        for (int i = 1; i <= sons.size(); i++)///sons[i - 1]!!
        {
            mr += sz[sons[i - 1]];
            for (int j = 0; j <= mr; j++)
            {
                d[i][j] = inf;
                for (int q = 0; q <= j and q <= sz[sons[i - 1]]; q++)
                {
                    int x1 = dp[sons[i - 1]][q];
                    int x2 = d[i - 1][j - q];
                    int rz;
                    if (x1 == inf or x2 == inf or x1 + x2 > diametru)
                        rz = inf;
                    else
                        rz = max(x1, x2);
                    d[i][j] = min(d[i][j], rz);
                }
            }
            for (int j = mr + 1; j <= n; j++)
                d[i][j] = 0;
        }
        for (int i = 0; i <= n; i++)
        {
            int mn = inf;
            for (int j = i; j >= 0 and j >= i - 5; j--)
                mn = min(mn, d[sons.size()][j] + 1 - min(1ll, i - j));
            dp[nod][i] = mn;
        }
    }
    //cout << nod << ' ' << dp[nod][0] << ' ' << dp[nod][1] << ' ' << dp[nod][2] << endl;
}

bool pot(int diam)
{
    diametru = diam;
    memset(dp, 0, sizeof(dp));
    memset(d, 0, sizeof(d));
    root(1, 0);
    if (dp[1][k] >= diametru + 2)
        return false;
    return true;
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >> n >> k;
    for (int i = 1; i < n; i++)
    {
        int x, y, z;
        cin >> x >> y >> z;
        g[x].push_back({y, z});
        g[y].push_back({x, z});
    }
    if (k >= n - 1)
    {
        cout << 0;
        return 0;
    }
    int st = 0, pas = 1 << 11;
    while (pas != 0)
    {
        if (st + pas < n and !pot(st + pas))
            st += pas;
        pas /= 2;
    }
    cout << st + 1;
    //bool pp = pot(5);
    //cout << (int)pp;
    return 0;
}

/*
14 2
1 2 1
1 3 1
1 4 1
2 12 1
12 13 1
13 14 1
3 8 1
3 9 1
9 10 1
9 11 1
4 5 1
4 6 1
4 7 1
*/
