#include <bits/stdc++.h>

using namespace std;

#define int long long

int inf = 2e9;

int n, k;
vector<pair<int, int>> g[200005];

vector<int> bfs(int orig)
{
    vector<int> d(n + 1);
    for (int i = 1; i <= n; i++)
        d[i] = inf;
    d[orig] = 0;
    queue<int> q;
    q.push(orig);
    while (!q.empty())
    {
        int nod = q.front();
        q.pop();
        for (auto vecin : g[nod])
        {
            if (d[vecin.first] == inf)
            {
                d[vecin.first] = d[nod] + vecin.second;
                q.push(vecin.first);
            }
        }
    }
    return d;
}

int diametru;
pair<int, int> dp[200005];
int cst[200005];

void root(int nod, int tata)
{
    vector<int> sons;
    for (auto vecin : g[nod])
    {
        if (vecin.first != tata)
            sons.push_back(vecin.first), cst[vecin.first] = vecin.second;
    }
    for (auto fiu : sons)
        root(fiu, nod);
    if (sons.empty())
    {
        dp[nod] = {0, cst[nod]};
        if (cst[nod] > diametru)
            dp[nod].second = diametru, dp[nod].first = cst[nod] - diametru;
    }
    else if (sons.size() == 1)
    {
        int x = sons[0];
        dp[nod].first = dp[x].first, dp[nod].second = dp[x].second + cst[nod];
        if (dp[nod].second > diametru)
            dp[nod].first += dp[nod].second - diametru, dp[nod].second = diametru;
    }
    else
    {
        /*vector<int> bgr, ltl;
        for (auto it : sons)
            dp[nod].first += dp[it].first;
        for (auto it : sons)
        {
            if (dp[it].second > diametru / 2)
                bgr.push_back(dp[it].second);
            else
                ltl.push_back(dp[it].second);
        }
        if (bgr.empty())
        {
            int mxm = 0;
            for (auto it : ltl)
                mxm = max(mxm, it);
            dp[nod].second = mxm + cst[nod];
            if (dp[nod].second > diametru)
            {
                dp[nod].first += dp[nod].second - diametru;
                dp[nod].second = diametru;
            }
        }
        else if (bgr.size() == 1)
        {
            int mxm = 0;
            for (auto it : ltl)
                mxm = max(mxm, it);
            if (bgr[0] > diametru - mxm)
            {
                dp[nod].first += bgr[0] - (diametru - mxm);
                bgr[0] = diametru - mxm;
            }
            dp[nod].second = bgr[0] + cst[nod];
            if (dp[nod].second > diametru)
            {
                dp[nod].first += dp[nod].second - diametru;
                dp[nod].second = diametru;
            }
        }
        else
        {
            int trg = diametru / 2;
            if (trg + trg + 1 <= diametru)
            {
                for (auto it : bgr)
                    dp[nod].first += it - trg;
                dp[nod].first--;
                dp[nod].second = trg + 1 + cst[nod];
                if (dp[nod].second > diametru)
                {
                    dp[nod].first += dp[nod].second - diametru;
                    dp[nod].second = diametru;
                }
            }
            else
            {
                for (auto it : bgr)
                    dp[nod].first += it - trg;
                dp[nod].second = trg + cst[nod];
                if (dp[nod].second > diametru)
                {
                    dp[nod].first += dp[nod].second - diametru;
                    dp[nod].second = diametru;
                }
            }
        }*/
        priority_queue<int> haha;
        for (auto it : sons)
            haha.push(dp[it].second), dp[nod].first += dp[it].first;
        while (true)
        {
            int x1 = haha.top();
            haha.pop();
            int x2 = haha.top();
            if (x1 + x2 <= diametru)
            {
                haha.push(x1);
                break;
            }
            else
            {
                haha.push(x1 - 1);
                dp[nod].first++;
            }
        }
        int ct = haha.top() + cst[nod];
        dp[nod].second = ct;
        if (ct > diametru)
            dp[nod].first += ct - diametru, dp[nod].second = diametru;
    }
    //cout << nod << ' ' << dp[nod].first << ' ' << dp[nod].second << endl;
}

bool pot(int diam)
{
    cst[1] = 0;
    memset(cst, 0, sizeof(cst));
    memset(dp, 0, sizeof(dp));
    diametru = diam;
    root(1, 0);
    if (dp[1].first > k)
    {
        //cout << "nnn " << diam << endl;
        return false;
    }
    //cout << "yyy" << diam << endl;
    return true;
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >> n >> k;
    for (int i = 1; i < n; i++)
    {
        int x, y, z;
        cin >> x >> y >> z;
        g[x].push_back({y, z});
        g[y].push_back({x, z});
    }
    int st = 0, pas = 1 << 30;
    while (pas != 0)
    {
        if (!pot(st + pas))
            st += pas;
        pas /= 2;
    }
    cout << st + 1;
    return 0;
}

/*
14 2
1 2 1
1 3 1
1 4 1
2 12 1
12 13 1
13 14 1
3 8 1
3 9 1
9 10 1
9 11 1
4 5 1
4 6 1
4 7 1
*/
