#include <bits/stdc++.h>
using namespace std;
#define pii pair<int, int>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
#define ordered_set tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update>
mt19937 rnd( chrono::steady_clock::now().time_since_epoch().count() );
using ll = long long;
const int NMAX = 2e5;

struct Edge{
  int a;
  int b;
  int w;
};
Edge list_edges[NMAX+1];

vector <pii> edges[NMAX+1];
int n;
int dep[NMAX+1];

void dfs( int node, int par = -1 ) {
  for( auto vec: edges[node] ) {
    if( vec.first != par ) {
      dep[vec.first] = dep[node] + vec.second;
      dfs( vec.first, node );
    }
  }
}
int diam() {
  int i, x, a, b, w;
  for( i = 1; i <= n; i++ )
    edges[i].clear();
  for( auto edg: list_edges ) {
    a = edg.a;
    b = edg.b;
    w = edg.w;
    edges[a].push_back( { b, w } );
    edges[b].push_back( { a, w } );
  }
  dfs( 1 );
  int maxi = 0;
  for( i = 1; i <= n; i++ ) {
    if( dep[i] > maxi ) {
      maxi = dep[i];
      x = i;
    }
  }
  for( i = 1; i <= n; i++ )
    dep[i] = 0;
  dfs( x );
  maxi = 0;
  for( i = 1; i <= n; i++ )
    maxi = max( maxi, dep[i] );
  return maxi;
}
void solve() {
  int k, i, a, b, w;
  cin >> n >> k;
  for( i = 0; i < n - 1; i++ ) {
    cin >> a >> b >> w;
    list_edges[i] = Edge{ a, b, w };
  }
  if( k == 0 )
    cout << diam();
}
int main() {
  ios_base::sync_with_stdio( false );
  cin.tie( NULL );
  cout.tie( NULL );
  int t = 1;
  // cin >> t;
  while( t-- ) {
    solve();
  }
}

