#include "soft_drinks.h"
#include<iostream>
using namespace std;
//#define int long long
typedef long double ld;

const int INF = 1e9;


int n,minb;
vector<int32_t> inita,initb;
void init(const std::vector<int32_t>& A, const std::vector<int32_t>& B)
{
    n = A.size();
    inita = A;
    initb = B;
}
vector<double> a,b;

double calc(int id, double Ma, double Mb)
{
    return min(Ma / (double)inita[id], Mb / (double)initb[id]);
}
double in2(int i, int j, double Ma, double Mb, double ci)
{
    return ci + calc(j, (double)Ma - ci*inita[i], (double)Mb - ci*initb[i]);
}

double friendDrink(const int32_t Ma, const int32_t Mb, const int32_t La, const int32_t Ra)
{
    a.resize(n+2);
    b.resize(n+2);
    vector<int> ids;
    for(int i=0;i<n;i++)
        if(La <= inita[i] && inita[i] <= Ra)
        {
            ids.push_back(i);
            a[i] = (double)Ma / (double)inita[i];
            b[i] = (double)Mb / (double)initb[i];
        }
    double rez=0;
    for(int i:ids)
    {
        rez = max(rez, min(a[i], b[i]));
       // if(a[i] > b[i])
          //  continue;
        for(int j:ids)
        {
            if(i==j)
                continue;
            //if(a[j] < b[j])
             //   continue;

            rez = max(rez, in2(i,j,Ma,Mb,min(a[i],b[i])));
            double st=0,dr=min(a[i],b[i]);
            for(int it=0;it<100;it++)
            {
                double mij1 = (st+dr)/3;
                double mij2 = mij1 + (st+dr)/3;
                double v1 = in2(i,j,Ma,Mb,mij1), v2 = in2(i,j,Ma,Mb,mij2);
                rez = max(rez, max(v1,v2));
                if(v1 > v2)
                {
                    dr = mij2;
                }
                else
                {
                    st = mij1;
                }
            }
        }
    }
    return rez;
}
/**


4 3
4 0
2 8
6 4
3 6
8 2 4 6
8 2 3 6
0 10 0 10

correct:
2
2.08333
0

*/
