#include "cycles.h"
#include<iostream>
#include<cassert>
#include<algorithm>
#include<random>
using namespace std;
int old;
vector<int> perm;
int sw(int x, int y)
{
    x = perm[x];
    y = perm[y];

    int cur = performSwap(x,y);
    int dif = cur - old;
    old = cur;
    return dif;
}
void sortPermutation(int n)
{
    if(n==1)
        return;
    perm.resize(n);
    for(int i=0;i<n;i++)
        perm[i] = i;
    random_shuffle(perm.begin(),perm.end());

    sw(0,1);
    sw(0,1);
    while(old < n)
    {
        int ult=0;
        for(int i=1;i<n;i++)
        {
            if(sw(ult,i) == +1)
            {
                for(int j=i;j>=ult+1;j--)
                    sw(ult,j);
                bool gasit=0;
                for(int j=0;j<n;j++)
                {
                    if(i==j)
                        continue;
                    int x = sw(i,j);
                    if(x == +1)
                    {
                        gasit=1;
                        break;
                    }
                    sw(i,j);
                }
                assert(gasit);
                ult = i;
            }
        }
    }
}
/**

7
0 1 5 3 4 2 6

7
3 1 4 6 0 2 5


dam random shuffle
stim ca lungimea maxima unui ciclu o sa fie mica
vreau sa fac O(maxlun * n)

daca dam swap(1,i) pana cand la un moment dat ne da +1 la nr cyc
sa zicem ca primu pas la care ne da +1 este x
stim ca x este in ciclu cu cineva dintre 1..x-1
incercam sa vedem daca e cu fiecare
daca gasim ca e in ciclu cu y, spargem ciclu asta in 2

acum o sa avem ca tot prefixu e in cicluri diferite


*/
