#include<bits/stdc++.h>
using namespace std;

int n,k;
vector<pair<int,int>> con[200005];
int dist1[200005],dist2[200005],prec[200005];
void dfs(int nod, int par, int dist[])
{
    for(auto [adj,w]:con[nod])
    {
        if(adj==par)
            continue;
        dist[adj] = dist[nod] + w;
        prec[adj] = nod;
                dfs(adj,nod,dist);
    }
}
int get_furthest(int src, int dist[])
{
    dist[src]=0;
    dfs(src,0,dist);
    int care=1;
    for(int i=1;i<=n;i++)
        if(dist[i] > dist[care])
            care = i;
    return care;
}
bool isdiam[200005];
int injos[200005];
void dfs2(int nod, int par)
{
    injos[nod]=0;
    for(auto [adj,w]:con[nod])
    {
        if(adj==par || isdiam[adj])
            continue;
        dfs2(adj,nod);
        injos[nod] = max(injos[nod], injos[adj] + w);
    }
}

signed main()
{
    ios_base::sync_with_stdio(0);cin.tie(0);
    cin>>n>>k;
    int u,v,w;
    for(int i=1;i<n;i++)
    {
        cin>>u>>v>>w;
        con[u].push_back({v,w});
        con[v].push_back({u,w});
    }
    int cap1 = get_furthest(1,dist2);
    int cap2 = get_furthest(cap1,dist1);
    get_furthest(cap2,dist2);

    int cur = cap1;
    vector<int> diam;
    while(cur != cap2)
    {
        diam.push_back(cur);
        cur = prec[cur];
    }
    diam.push_back(cur);

    for(int x:diam)
        isdiam[x]=1;
    for(int x:diam)
        dfs2(x,-1);


        int cnt=0;
    for(int i=1;i+1<diam.size();i++)
    {
        if(max(diam.size()-i-1,i) + injos[diam[i]] >= dist2[cap1])
            cnt++;
    }
    if(cnt<=1)
        cout<<dist2[cap1]-1;
    else
        cout<<dist2[cap1];
    return 0;
}
