#include <iostream>
#include <algorithm>
#include <vector>
#include "soft_drinks.h"

using namespace std;

vector<pair<int, int>> c;

int compare(pair<int, int> a, pair<int, int> b){
    if(a.first==b.first)
        return a.second>b.second;
    return a.first>b.first;
}

void init(const std::vector<int>& A, const std::vector<int>& B){
    for(int i=0;i<A.size();i++)
        c.push_back({std::max(A[i], B[i]), A[i]});
    sort(c.begin(), c.end(), compare);
}

double friendDrink(int Ma, int Mb, int La, int Ra){
    for(int i=0;i<c.size();i++){
        if(c[i].second>La&&c[i].second<Ra){
            return (double)Ma/c[i].first;
        }
    }
}
