#include <iostream>
#include <algorithm>
#include <vector>

#define nMax 20000

using namespace std;


struct nod{
    int mark;
    vector<int> kids;
};

int n, k, x, y, z, curMark, curNod, curRoot;
long dist[nMax][nMax];
nod tree[nMax];
vector<int>a;

void dfs(long long sum){
    tree[curNod].mark=curMark;
    for(auto i : tree[curNod].kids){
        if(tree[i].mark!=curMark){
            sum+=dist[curNod][i];
            if(!dist[curRoot][curNod]){
                dist[curRoot][curNod]=dist[curNod][curRoot]=sum;
                a.push_back(sum);
            }
            int aux=curNod;
            curNod=i;
            dfs(sum);
            curNod=aux;
            sum-=dist[curNod][i];
        }
    }
}

int main()
{
    cin>>n>>k;
    for(int i=1;i<n;i++){
        cin>>x>>y>>z;
        dist[x][y]=dist[y][x]=z;
        tree[x].kids.push_back(y);
        tree[y].kids.push_back(x);
    }

    for(int i=1;i<=n;i++){
        curMark++;
        curRoot=i;
        curNod=i;
        dfs(0);
    }

    sort(a.begin(), a.end());

    if(k==0)
        cout<<a.back();

    if(k==1)
        cout<<a.back()-1;

    return 0;
}
