#include "soft_drinks.h"
#include <bits/stdc++.h>

using namespace std;

const int NMAX=1e5+5;
int n, va[NMAX], vb[NMAX];

void init(const std::vector<int>& A, const std::vector<int>& B)
{
    n=A.size();
    for(int i=0;i<n;i++)
        va[i]=A[i];
    for(int i=0;i<n;i++)
        vb[i]=B[i];
}

double friendDrink(int Ma, int Mb, int La, int Ra)
{
    double ans=0, mina=1e10, minb=1e10;
    if(La<=va[0] && va[0]<=Ra)
    {
        if(va[0]!=0)
            mina=min(mina, (double)Ma/va[0]);
        if(vb[0]!=0)
            minb=min(minb, (double)Mb/vb[0]);
    }
    if(La<=va[1] && va[1]<=Ra)
    {
        if(va[1]!=0)
            mina=min(mina, (double)Ma/va[1]);
        if(vb[1]!=0)
            minb=min(minb, (double)Mb/vb[1]);
    }
    ans=max(mina, minb);
    if((La<=min(va[0], va[1]) && max(va[0], va[1])<=Ra) && va[0]*vb[1]!=va[1]*vb[0])
    {
        double cx=(double)(vb[1]*Ma-va[1]*Mb)/(va[0]*vb[1]-va[1]*vb[0]);
        double cy=(double)(va[0]*Mb-vb[0]*Ma)/(va[0]*vb[1]-va[1]*vb[0]);
        if(cx>=0 && cy>=0)
            ans=max(ans, cx+cy);
    }
    return ans;
}