#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <vector>
#include <algorithm>
#define MAXN 2004
#define INFI 100000
using namespace std;

struct NOD{
  int neigh,cost;
};

int suma[MAXN][MAXN];
vector <NOD> graf[MAXN];

int n,k;

int ma;

bool cmp(NOD a,NOD b){
  if(a.cost==b.cost){
    return a.neigh<b.neigh;
  }
  return a.cost>b.cost;
}

void DFS(int node,int fath){
  int i,j,aux;

  for(i=1;i<MAXN;i++){
    suma[node][i]=0;
  }
  suma[node][0]=0;

  for(NOD neigh : graf[node]){
    if(neigh.neigh!=fath){
      DFS(neigh.neigh,node);
      for(i=MAXN-1;i>=0;i--){
        aux=MAXN;
        if(i>0){
          aux=suma[neigh.neigh][i-1];
        }
        if(suma[neigh.neigh][i]<=-INFI){
          suma[neigh.neigh][i]=aux;
        }else{
          suma[neigh.neigh][i]=min(aux,suma[neigh.neigh][i]+1);
        }
        suma[node][i]+=suma[neigh.neigh][i];
      }
    }
  }

  for(NOD neigh : graf[node]){
    int mi=MAXN;
    for(j=0;j<MAXN;j++){
      for(i=0;i<MAXN;i++){
        if(suma[node][j]-suma[neigh.neigh][j]+suma[neigh.neigh][i]<=k){
          mi=min(mi,i+j);
        }
      }
    }
    if(mi!=MAXN){
      ma=max(mi,ma);
    }
  }
}

int main(){
  int i,j,x,y,c,mi;


  scanf("%d%d",&n,&k);
  for(i=0;i<n-1;i++){
    scanf("%d%d%d",&x,&y,&c);
    graf[x].push_back({y,c});
    graf[y].push_back({x,c});
  }

  if(k>=n-1){
    k=k/0;
  }

  DFS(1,-1);

  printf("%d\n",ma);

  return 0;
}
