#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <vector>
#include <algorithm>
#define MAXN 2004
#define INFI 100000
using namespace std;

struct NOD{
  int neigh,cost;
};

int suma[MAXN][MAXN];
vector <NOD> graf[MAXN];

int n,k;

int ma;

bool cmp(NOD a,NOD b){
  if(a.cost==b.cost){
    return a.neigh<b.neigh;
  }
  return a.cost>b.cost;
}

int DFS3(int node,int fath,int adan,int initial){
  int s,ma,i;

  ma=adan;
  for(NOD neigh : graf[node]){
    if(fath!=neigh.neigh){
      ma=max(ma,DFS3(neigh.neigh,node,adan+1,initial));
    }
  }

  suma[initial][ma-adan]++;
  return ma;
}

void DFS(int node,int fath){
  int i,j,aux;

  for(i=1;i<MAXN;i++){
    suma[node][i]=0;
  }
  suma[node][0]=0;

  for(NOD neigh : graf[node]){
    if(neigh.neigh!=fath){
      DFS(neigh.neigh,node);

      DFS3(neigh.neigh,node,1,neigh.neigh);

      for(i=MAXN-2;i>=0;i--){
        suma[neigh.neigh][i]+=suma[neigh.neigh][i+1];
        suma[node][i]+=suma[neigh.neigh][i];
      }
      /*if(node==0){
        printf("^^^ %d ^^^\n",neigh.neigh);
        for(NOD neigh : graf[node]){
          printf("%d : ",neigh.neigh);
          for(i=0;i<10;i++){
            printf("%2d ",suma[neigh.neigh][i]);
          }
          printf("\n");
        }
        printf("---------------\n");
      }*/
    }
  }

  for(NOD neigh : graf[node]){
    int mi=MAXN;
    for(j=0;j<MAXN;j++){
      for(i=0;i<MAXN;i++){
        if(suma[node][j]-suma[neigh.neigh][j]+suma[neigh.neigh][i]<=k){
          mi=min(mi,i+j);
        }
      }
    }
    if(mi!=MAXN){
      ma=max(mi,ma);
    }
  }
}

int ma2,poz2;

void DFS2(int node,int fath,int cost){

  if(cost>ma2){
    ma2=cost;
    poz2=node;
  }

  for(NOD neigh : graf[node]){
    if(neigh.neigh!=fath){
      DFS2(neigh.neigh,node,cost+neigh.cost);
    }
  }
}


int main(){
  int i,j,x,y,c,mi;


  scanf("%d%d",&n,&k);
  for(i=0;i<n-1;i++){
    scanf("%d%d%d",&x,&y,&c);
    graf[x].push_back({y,c});
    graf[y].push_back({x,c});
  }

  if(k>=n-1){
    printf("0\n");
    return 0;
  }

  ma2=0;
  poz2=-1;

  DFS2(1,-1,0);

  ma2=0;
  DFS2(poz2,-1,0);

  DFS(1,-1);

  //ma=min(ma,ma2);

  printf("%d\n",ma);

  return 0;
}
