#include <bits/stdc++.h>

using namespace std;

const int NMAX = 1e5;

vector <pair<int, int>> edges[NMAX + 1];
int depth[NMAX + 1];
int n;

void dfs( int node, int p = 0, int d = 0 ) {
    depth[node] = d;
    for ( auto e : edges[node] ) {
        if ( e.first != p ) {
            dfs( e.first, node, d + e.second );
        }
    }
}
int maxDepthNode() {
    int maxD = 1;
    for ( int i = 1; i <= n; i ++ ) {
        if ( depth[maxD] < depth[i] ) maxD = i;
    }
    return maxD;
}
int calcDiameter() {
    dfs( 1 );
    dfs( maxDepthNode() );
    return depth[maxDepthNode()];
}
int main() {
    int k;
    cin >> n >> k;
    for ( int i = 1, a, b, c; i < n; i ++ ) {
        cin >> a >> b >> c;
        edges[a].push_back( {b, c} );
        edges[b].push_back( {a, c} );
    }
    if ( k == 0 ) {
        cout << calcDiameter() << '\n';
    }
    return 0;
}
