#include "soft_drinks.h"
const int nmax = 1e5 + 5;
const int inf = 3e9;

struct ceva{
    int sugar, acid;
}v[nmax];

int n;

void init(const std::vector<int>& A, const std::vector<int>& B)
{
    n = A.size();
    for(int i = 0; i < n; i ++) v[i + 1].sugar = A[i];
    for(int i = 0; i < n; i ++) v[i + 1].acid = B[i];
}

double friendDrink(int Ma, int Mb, int La, int Ra)
{
    double maxi = 0;
    for(int i = 1; i <= n; i ++)
        if(v[i].sugar >= La && v[i].sugar <= Ra)
            maxi = std::max(maxi, std::min((double)Ma / v[i].sugar, (double)Mb / v[i].acid));

    return maxi;
}