#include <iostream>
#include <vector>

using namespace std;

const long long nmax = 2e5 + 5;

struct idk{
    long long v1, n1, v2, n2;
} sub[nmax];

struct ceva{
    long long vec, cost;
};

long long n, k, s, fr[nmax], dad[nmax], lant[nmax];
vector<ceva> v[nmax];

void dfs(long long nod)
{
    fr[nod] = 1;
    for(auto [x, c] : v[nod])
    {
        if(fr[x]){dad[nod] = x; continue;}

        dfs(x);

        lant[nod] = max(lant[nod], lant[x] + c);
        if(sub[nod].v1 <= lant[x])
        {
            sub[nod].v2 = sub[nod].v1;
            sub[nod].n2 = sub[nod].n1;
            sub[nod].v1 = lant[x];
            sub[nod].n1 = c;
        }

        else if(sub[nod].v2 <= lant[x])
             sub[nod].v2 = lant[x], sub[nod].n2 = c;

    }
}

int main()
{
    cin >> n >> k;
    for(long long i = 1; i < n; i ++)
    {
        long long x, y, w;
        cin >> x >> y >> w;
        v[x].push_back({y, w});
        v[y].push_back({x, w});

        s += w;
    }

    if(s <= k){
        cout << 0;
        return 0;
    }

    dfs(1);

    long long maxi = 0;
    for(long long i = 1; i <= n; i ++)
    {
        long long sum = sub[i].v1 + sub[i].v2 + sub[i].n1 + sub[i].n2;
        maxi = max(maxi, sum);
    }

    cout << maxi - k;
    return 0;
}
