#include <iostream>
#include <climits>
#include <vector>

using namespace std;

const int nmax = 2e5 + 5;

struct altceva{
    int x, y, w;
};

struct idk{
    int v1, v2;
} sub[nmax];

struct ceva{
    int vec, cost;
};

int n, k, s, fr[nmax], dad[nmax], lant[nmax];
vector<ceva> v[nmax];
vector<altceva> e;

bool cmp(ceva x, ceva y){
    return x.vec < y.vec;
}

void dfs(int nod)
{
    fr[nod] = 1;
    for(auto [x, c] : v[nod])
    {
        if(fr[x]){dad[nod] = x; continue;}

        dfs(x);

        lant[nod] = max(lant[nod], lant[x] + c);

        if(sub[nod].v1 <= lant[x] + c){
            sub[nod].v2 = sub[nod].v1;
            sub[nod].v1 = lant[x] + c;
        }

        else if(sub[nod].v2 < lant[x] + c)
             sub[nod].v2 = lant[x] + c;

    }
}

int main()
{
    cin >> n >> k;
    for(int i = 1; i < n; i ++)
    {
        int x, y, w;
        cin >> x >> y >> w;
        e.push_back({x, y, w});
        v[x].push_back({y, w});
        v[y].push_back({x, w});

        s += w;
    }

    if(s <= k){
        cout << 0;
        return 0;
    }

    dfs(1); int mini = 0;
    for(int i = 1; i <= n; i ++)
        mini = max(mini, sub[i].v1 + sub[i].v2);

    for(; k >= 1; k --)
    {
        int a1, a2;
        for(int x = 1; x <= n; x ++)
            for(auto [y, c] : v[x])
            {
                if(!c) continue;

                for(int i = 1; i <= n; i ++) sub[i] = {0, 0}, lant[i] = fr[i] =  0;

                int p, p2;
                for(int i = 0; i < v[x].size(); i ++)
                    if(v[x][i].vec == y){
                        p = i; break;
                    }

                for(int i = 0; i < v[y].size(); i ++)
                    if(v[y][i].vec == x){
                        p2 = i; break;
                    }

                v[x][p].cost --; v[y][p2].cost --;

                dfs(1);

                v[x][p].cost ++; v[y][p2].cost ++;

                int maxi = 0;
                for(int i = 1; i <= n; i ++)
                    maxi = max(maxi, sub[i].v1 + sub[i].v2);

                if(maxi < mini)
                    mini = maxi, a1 = x, a2 = y;
            }

        int p, p2;
        for(int i = 0; i < v[a1].size(); i ++)
            if(v[a1][i].vec == a2){
                p = i; break;
            }

        for(int i = 0; i < v[a2].size(); i ++)
            if(v[a2][i].vec == a1){
                p2 = i; break;
            }

        v[a1][p].cost --; v[a2][p2].cost --;
    }

    cout << mini;
    return 0;
}
