#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <stack>
#include <queue>
#include <map>
#include <algorithm>
#include <string>
#include <climits>
#include <cassert>
//#include <random>

//#include <bits/stdc++.h>

using namespace std;

#define DEBUG 1
#if DEBUG
    #define DEBUG_LOG_ONLY if(DEBUG)
    #define DEBUG_PAUSE_SYSTEM system("pause");
    #define DEBUG_CLEAR system("cls");
    #define DEBUG_PRINT_VAR_BOLD(name, var) cout << "log /> " << name << " " << var << "\n";
#endif // DEBUG


using namespace std;

struct Muchie {
    int nod, vec, lung;

    Muchie() {}
    Muchie(int _nod, int _vec, int _lung): nod(_nod), vec(_vec), lung(_lung) {}
};
vector<Muchie> gr[102];
int n, k, i, j;

struct Lant {
    int nod, lung;
};
static inline Lant Dfs(int nod, int tata = -1, int lungCur = 0) {
    Lant cur = {nod, lungCur};
    for(Muchie urm : gr[nod]) {
        if(urm.vec != tata) {
            Lant cont = Dfs(urm.vec, nod, lungCur + urm.lung);

            if(cont.lung > cur.lung) cur = cont;
        }
    }
    return cur;
}

static inline Lant CalcDiam() {
    Lant l = Dfs(1);
    return Dfs(l.nod);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n >> k;
    for(i = 1; i < n; i++) {
        Muchie cur;
        cin >> cur.nod >> cur.vec >> cur.lung;
        gr[cur.nod].push_back(cur);
        gr[cur.vec].push_back(Muchie(cur.vec, cur.nod, cur.lung));
    }

    if(k == 0) cout << CalcDiam().lung;

    return 0;
}
