#include "cycles.h"

#include <cstdlib>
#include <ctime>

void sortPermutation(int N) {
    srand(time(0));
    int cnt = 1e7;

    int cycles = performSwap(0, 1);
    --cnt;

    while (cnt && cycles < N) {
        int i = rand() % N, j = rand() % N;
        cycles = performSwap(i, j);
        --cnt;
    }
}
