#include "cycles.h"

#include <bits/stdc++.h>

using namespace std;

int getCycleCount() {
    performSwap(0, 1);
    return performSwap(0, 1);
}

void solveTransposition(int N) {
    performSwap(0, 1);

    int cnt = performSwap(0, 1);
    int pos = -1;

    for (int i = 1; i < N; ++i) {
        int c = performSwap(i - 1, i);
        if (c < cnt) cnt = c;
        else {
            pos = i;
            break;
        }
    }

    for (int i = pos; i > 0; --i)
        cnt = performSwap(i - 1, i);

    for (int i = 0; i < pos; ++i) {
        int c = performSwap(i, pos);
        if (c > cnt) return;
        performSwap(i, pos);
    }
}

void sortPermutation(int N) {
    while (getCycleCount() < N) {
        solveTransposition(N);
    }
}
