#include "bits/stdc++.h"
#include "soft_drinks.h"

using namespace std;

#define for0(i, n) for (ll i = 0; i < n; ++i)
#define pb push_back
#define con continue
#define ret return
#define be(x) x.begin()

typedef long long ll;
typedef vector<ll> vll;
typedef pair<ll, ll> pll;
typedef vector<pll> vpll;



const long double eps = 1e-9;

int n;
vector<int> a, b;

void init(const std::vector<int> &A, const std::vector<int> &B) {
    a = A, b = B;
    n = a.size();
}

bool check(long double m, vector<int> a1, vector<int> b1, int ma, int mb) {
    if (a1.size() == 0) ret 0;
    if (a1.size() == 1) ret (a1[0] * m <= ma && b1[0] * m <= mb);
    if (a1[0] > a1[1]) swap(a1[0], a1[1]), swap(b1[0], b1[1]);
    if (b1[0] <= b1[1]) ret (a1[0] * m <= ma && b1[0] * m <= mb);
    if (a1[0] * m > ma) ret 0;
    long double ost = ma - a1[0] * m;
    long double m2 = min(m, ost / (a1[1] - a1[0])), m1 = m - m2;
    ret (a1[0] * m1 + a1[1] * m2 <= ma && b1[0] * m1 + b1[1] * m2 <= mb);
}

double friendDrink(const int Ma, const int Mb, const int La, const int Ra) {
    cout.precision(6);
    cout << fixed;
    vector<int> a1, b1;
    for (int i = 0; i < n; i++) {
        if (a[i] >= La && a[i] <= Ra) a1.push_back(a[i]), b1.push_back(b[i]);
    }
    long double l = 0, r = 2e9 + 5;
    while (r - l > eps) {
        long double m = (r + l) / 2;
        if (check(m, a1, b1, Ma, Mb)) {
            l = m;
        } else {
            r = m;
        }
    }
    ret l;
}