#include "bits/stdc++.h"

using namespace std;

#define for0(i, n) for (ll i = 0; i < n; ++i)
#define pb push_back
#define con continue
#define ret return
#define be(x) x.begin()

typedef long long ll;
typedef vector<ll> vll;
typedef pair<ll, ll> pll;
typedef vector<pll> vpll;


const ll N = 2e5 + 5;

ll n, k;
vpll g[N];
ll mx[N], s[N];

void dfs(ll v, ll p, ll d) {
    s[v] = 0;
    mx[v] = 0;
    for (auto [x, w]: g[v]) {
        if (x == p) con;
        dfs(x, v, d);
        mx[x] += w;
        s[v] += s[x];
        while (mx[x] + mx[v] > d) {
            if (mx[v] < mx[x]) swap(mx[x], mx[v]);
            ll nd = min((mx[x] + mx[v]) - d, mx[v] - d / 2);
            mx[v] -= nd;
            s[v] += nd;
        }
        mx[v] = max(mx[v], mx[x]);
    }
}

signed main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    cin >> n >> k;
    for0(i, n - 1) {
        ll u, v, w;
        cin >> u >> v >> w;
        u--;
        v--;
        g[u].pb({v, w});
        g[v].pb({u, w});
    }
    ll l = -1, r = 1e6 + 5;
    while (l + 1 < r) {
        ll m = (l + r) / 2;
        dfs(0, 0, m);
        (s[0] <= k ? r : l) = m;
    }
    cout << r;
}