#include "cycles.h"
#include <bits/stdc++.h>

using namespace std;
using ll = long long;

mt19937 rnd(228);

void sortPermutation(int n) {
    // 1: make a cycle
    int C = performSwap(0, 1);
    for (int i = 1; i < n; ++i) {
        int NC = performSwap(i, i - 1);
        if (NC > C) {
            C = performSwap(i, i - 1);
        } else {
            C = NC;
        }
    }

    auto solve = [&](auto self, vector<int> a) {
        if (a.size() == 1) {
            return;
        }
        int x = rnd() % a.size(), y = x;
        while (y == x) {
            y = rnd() % a.size();
        }
        C = performSwap(a[x], a[y]);
        vector<int> tox, toy;
        for (int t : a) {
            if (t == a[x] || t == a[y]) {
                (t == a[x] ? tox : toy).push_back(t);
                continue;
            }
            int NC = performSwap(a[x], t);
            if (NC > C) {
                tox.push_back(t);
                performSwap(a[x], t);
            } else {
                toy.push_back(t);
                performSwap(a[x], t);
            }
        }
        self(self, tox);
        self(self, toy);
    };
    vector<int> ord(n);
    iota(ord.begin(), ord.end(), 0);
    solve(solve, ord);
}