#include<bits/stdc++.h>
using namespace std;

int diameter(int n, vector<tuple<int, int, int>> e) {
	vector<vector<pair<int, int>>> g(n);
	for (auto [u, v, w] : e) {
		g[u].emplace_back(v, w);
		g[v].emplace_back(u, w);
	}
	auto mxd = [&](auto mxd, int u, int p) -> pair<int, int> {
		pair<int, int> ret = {0, u};
		for (auto [to, w] : g[u]) {
			if (to != p) {
				auto ss = mxd(mxd, to, u);
				ss.first += w;
				ret = max(ret, ss);
			}
		}
		return ret;
	};
	auto [d1, st] = mxd(mxd, 0, -1);
	auto [d2, fi] = mxd(mxd, st, -1);
	return d2;
}

int main() {
	cin.tie(nullptr)->sync_with_stdio(false);

	int n, k;
	cin >> n >> k;
	vector<tuple<int, int, int>> e(n - 1);
	for (auto& [u, v, w] : e) {
		cin >> u >> v >> w;
		--u, --v;
	}
	cout << diameter(n, e) << '\n';
}