#include<iostream>
#include<vector>
#include<string>
#include<set>
#include<map>
#include<queue>
#include<deque>
#include<stack>
#include<cmath>
#include<algorithm>
#include<iomanip>
#include<cstdio>
#include<bitset>
#include<random>
#include<ctime>
#include<unordered_map>
#include<unordered_set>

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;
using ll = long long;
using ld = long double;
using uint = unsigned int;
using ull = unsigned long long;

const int N = 1e5 + 2, inf = 1e9 + 100;
const ll llinf = 1e18 + 1000;

int n;
struct st {
    ll a, b;
};
bool cmp(st a, st b) {
    return a.a < b.a;
}
st a[N];
struct segtree {
    int t[N * 2];
    segtree() {}
    void build() {
        for (int i = 0; i < n; ++i) t[i + n] = max(a[i].a, a[i].b);
        for (int i = n - 1; i; --i) t[i] = min(t[i * 2], t[i * 2 + 1]);
    }
    int get(int l, int r) {
        l += n, r += n;
        int ans = inf;
        while (l < r) {
            if (l & 1) ans = min(ans, t[l++]);
            if (r & 1) ans = min(ans, t[--r]);
            l >>= 1, r >>= 1;
        }
        return ans;
    }
};
segtree t;
void init(const vector<int>& a1, const vector<int>& b1) {
    n = a1.size();
    for (int i = 0; i < n; ++i) {
        a[i].a = a1[i];
        a[i].b = b1[i];
    }
    sort(a, a + n, cmp);
    t.build();
}
ld get2(ll ma, ll mb, int i, int j) {
    ld k = (ld)a[j].b - ld(a[j].a * a[i].b) / a[i].a;
    ld s = (ld)mb - (ld)(a[i].b * ma) / a[i].a;
    ld k2 = s / k;
    ld k1 = ld(ma - k2 * a[j].a) / a[i].a;
    if (k1 < 0 || k2 < 0) return 0;
    return k1 + k2;
}
ld get1(ll ma, ll mb, int i) {
    return min((ld)ma / a[i].a, (ld)mb / a[i].b);
}
double friendDrink(int ma, int mb, int la, int ra) {
    /*int l = -1, r = n;
    while (r - l > 1) {
        int m = (l + r) >> 1;
        if (a[m].a < la) l = m;
        else
            r = m;
    }
    int lg = r;
    l = -1, r = n;
    while (r - l > 1) {
        int m = (l + r) >> 1;
        if (a[m].a > ra) r = m;
        else
            l = m;
    }
    int rg = l;
    int mn = t.get(lg, rg + 1);
    if (mn == inf) return 0;
    return (ld)ma / mn;*/
    if (la > 0 || ra < 0) return 0;
    return (ld)mb / t.get(0, n);
}

//void solve() {
//    init({ 1, 2, 3, 4, 5 }, { 5, 4, 3, 2, 1 });
//    cout << friendDrink(1000, 1000, 5, 4) << '\n';
//}
//
//signed main() {
//    ios_base::sync_with_stdio(0);
//    cin.tie(0);
//    int tt = 1;
//    //cin >> tt;
//    while (tt--) {
//        solve();
//        cout << endl;
//    }
//    return 0;
//}