#include<iostream>
#include<vector>
#include<string>
#include<set>
#include<map>
#include<queue>
#include<deque>
#include<stack>
#include<cmath>
#include<algorithm>
#include<iomanip>
#include<cstdio>
#include<bitset>
#include<random>
#include<ctime>
#include<unordered_map>
#include<unordered_set>

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;
using ll = long long;
using ld = long double;
using uint = unsigned int;
using ull = unsigned long long;

const int N = 2e5 + 2, inf = 1e9 + 100;
const ll llinf = 1e18 + 1000;

int n, k, a[N], cnt = 0;
vector<pair<int, int>> g[N];
vector<int> b;
void dfs1(int v, int p) {
    b.push_back(v);
    for (int i = 0; i < g[v].size(); ++i) {
        int to = g[v][i].first;
        if (to == p) {
            swap(g[v][i], g[v].back());
            g[v].pop_back();
            --i;
            continue;
        }
        dfs1(to, v);
    }
}

void solve() {
    cin >> n >> k;
    for (int i = 0; i + 1 < n; ++i) {
        int x, y, w;
        cin >> x >> y >> w;
        --x, --y;
        g[x].push_back({ y, w });
        g[y].push_back({ x, w });
    }
    dfs1(0, -1);
    reverse(all(b));
    int l = -1, r = inf * 2;
    while (l + 1 < r) {
        int m = (l + r) >> 1;
        cnt = 0;
        for (auto v : b) {
            int mx = 0, mx2 = 0;
            for (auto i : g[v]) {
                int to = i.first, w = i.second;
                int val = a[to] + w;
                if (val >= mx) {
                    mx2 = mx;
                    mx = val;
                }
                else if (val > mx2) mx2 = val;
            }
            if (mx2 + mx2 <= m) {
                if (mx + mx2 > m) {
                    cnt += mx + mx2 - m;
                    mx -= (mx + mx2 - m);
                }
            }
            else {
                mx = m / 2, mx2 = m / 2;
                mx += m % 2;
                bool f = false;
                for (auto i : g[v]) {
                    int to = i.first, w = i.second;
                    int val = a[to] + w;
                    if (val >= mx && !f) cnt += val - mx, f = true;
                    else if (val >= mx2) cnt += val - mx2;
                }
            }
            a[v] = mx;
        }
        if (cnt <= k) r = m;
        else
            l = m;
    }
    cout << r;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
        cout << endl;
    }
    return 0;
}