// ConsoleApplication1.cpp : This file contains the 'main' function. Program execution begins and ends there.
//
#pragma GCC optimize("O3")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include "soft_drinks.h"

using namespace std;
using ll = long long;
using ld = long double;

//int main()
//{
//    ios_base::sync_with_stdio(false);
//    cin.tie(NULL);
//}

vector <int> a, b;
vector <pair<int, int>> lst;

ld mb, ma=1e20;

void init(const std::vector<int>& A, const std::vector<int>& B)
{
	if (A.size() > 5000)
		exit(-1);
	a = A;
	b = B;
	//mb = *min_element(B.begin(), B.end());
	mb = 1e20;
	int n = A.size();
	for (size_t i = 0; i < n; i++)
	{
		lst.emplace_back(A[i], B[i]);
		if (A[i] == 0)
			mb = min(mb,(ld)B[i]);
		if (B[i] == 0)
			ma = min(ma, (ld)A[i]);
	}
	sort(lst.begin(), lst.end());
}

ld EPS = 1e-8;

ld GetBestB(double A, int la, int ra)
{
	ld res = 1e20;
	int n = a.size();
	for (size_t i = 0; i < n; i++)
		if (a[i] <= A + EPS && la <= a[i] && a[i] <= ra)
			res = min(res, (ld)b[i]);
	for (size_t i = 0; i < n; i++)
	{
		if (la > a[i] || a[i] > ra)
			continue;
		for (size_t j = 0; j < n; j++)
		{
			if (la > a[j] || a[j] >= ra)
				continue;
			if (a[i] <= A + EPS && A - EPS <= a[j])
			{
				ld x, y;
				if (abs(a[i] - A) < EPS)
					x = 1.0, y = 0.0;
				else if (abs(a[j] - A) < EPS)
					x = 0.0, y = 1.0;
				else
					y = (A - a[i]) / (ld)(a[j] - a[i]), x = 1.0 - y;
				res = min(res, x * b[i] + y * b[j]);
			}
		}
	}
	return res;
}

ld result(ld Ma, ld Mb, ld A, ld B)
{
	if (abs(A) < EPS || abs(Ma) < 0.5)
	{
		return Mb / B;
	}
	if (abs(B) < EPS || abs(Mb) < 0.5)
	{
		return Ma / A;
	}
	return min(Ma / A, Mb / B);
}

double friendDrink(const int Ma, const int Mb, const int La, const int Ra)
{
	if (Ma == 0)
	{
		if (La > 0)
			return 0;
		return Mb / mb;
	}
	if (Mb == 0)
	{
		ld ma = 1e20;
		for (auto& i : lst)
		{
			if (La <= i.first && i.first <= Ra && ma < i.first && i.second == 0)
			{
				ma = i.first;
			}
		}
		return Ma / ma;
	}
	ld coef = (ld)Mb / (ld)Ma;
	vector <pair<ld, ld>> cur;
	for (auto& i : lst)
	{
		if (La <= i.first && i.first <= Ra)
		{
			cur.emplace_back(i.first, i.second / coef);
		}
	}
	if (cur.empty())
		return 0;
	pair<ld, ld> base = *min_element(cur.begin(), cur.end(), [](pair<ld, ld> a, pair<ld, ld> b)
		{
			return max(a.first, a.second) < max(b.first, b.second);
		});
	if (base.first < base.second)
	{
		swap(base.first, base.second);
		for (auto& i : cur)
		{
			swap(i.first, i.second);
		}
	}
	ld V = Ma / base.first;
	ld ans = V;
	for (auto& i : cur)
	{
		if (i.first < i.second && i.first < base.first)
		{
			ld S = i.first / i.second;
			ld MA = Ma * ((ld)1 - S);
			ld x = MA / (base.first - base.second * S);
			ans = max(ans, x + (Ma - x * base.second) / i.second);
		}
	}
	return ans;
	/*if (La > 0)
		return 0;
	return (double)Mb / (double)mb;*/
	//double ans = 0;
	//ld ql = 0, qr = (ld)3 * max(Ma, Mb) + 10;
	//for (size_t i = 0; i < 100; i++)
	////while (qr - ql > EPS)
	//{
	//	ld qm = (ql + qr) / 2.0;
	//	ld res = Mb / max(GetBestB(Ma / qm, La, Ra), EPS);
	//	if (res - qm > -EPS)
	//		ql = qm;
	//	else
	//		qr = qm;
	//}
	//ans = result(Ma, Mb, Ma / ql, GetBestB(Ma / ql, La, Ra));
	//return ans;
	///return ans;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
