#define _CRT_SECURE_NO_WARNINGS
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using ll = long long;
using ld = long double;

const int MAXN = 2e5 + 10;
vector <pair<int, int>> g[MAXN];
ll res[MAXN];
int st[MAXN][3], st_end = 0, pos[MAXN], pos_end = 0;
ll ans = 0, D = 0, D2 = 0;

void dfs_pos(int v, int p)
{
    for (auto& i : g[v])
    {
        if (i.first == p)
        {
            swap(i, g[v].back());
            g[v].pop_back();
            break;
        }
    }
    for (auto& i : g[v])
    {
        dfs_pos(i.first, v);
    }
    pos[pos_end] = v;
    ++pos_end;
}

ll dfs(int v, int p)
{
    //vector <int> cur;
    ll mx = 0, our = -1;
    bool dbl = false;
    for (auto& [i, w] : g[v])
    {
        if (i == p)
            continue;
        ll x = dfs(i, v) + w;
        if (x <= D2)
        {
            mx = max(mx, x);
            continue;
        }
        if (our == -1)
        {
            our = x;
            continue;
        }
        dbl = true;
        mx = D2;
        ans += (our - D2);
        our = x;
    }
    if (our != -1 && D < mx + our)
        ans += (1ll * our - (D - mx));
    else
        return max({ our, (ll)0, mx });
    return D - mx;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    memset(st, 0, sizeof(st));
    memset(res, 0, sizeof(res));
    int n, k;
    cin >> n >> k;
    ll x = 0;
    for (size_t i = 1; i < n; i++)
    {
        int a, b, c;
        cin >> a >> b >> c;
        a--; b--;
        g[a].emplace_back(b, c);
        g[b].emplace_back(a, c);
        x += c;
    }
    dfs_pos(0, 0);
    if (clock() > 0.1 * CLOCKS_PER_SEC)
        return -1;
    ll l = -1, r = max(10ll, x - k + 1ll);
    while (r - l > 1)
    {
        ll m = (l + r) / 2ll;
        D = m;
        D2 = D / 2;
        ans = 0;
        //dfs(0, 0);
        for (int i = 0; i < n; ++i)
        {
            int v = pos[i];
            ll mx = 0, our = -1;
            for (auto& [i, w] : g[v])
            {
                ll x = res[i] + w;
                if (x <= D2)
                {
                    mx = max(mx, x);
                    continue;
                }
                if (our != -1)
                {
                    mx = D2;
                    ans += (our - D2);
                }
                our = x;
            }
            if (our != -1 && D < mx + our)
            {
                ans += (our - (D - mx));
                res[v] = D - mx;
                if (ans > k)
                    break;
            }
            else
                res[v] = max(our, mx);
        }
        if (ans > k)
            l = m;
        else
            r = m;
    }
    cout << r << '\n';
    return 0;
}


// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
