﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <cmath>
#include <array>
#include <random>
#include <queue>

#include "cycles.h"
using namespace std;
typedef long long ll;
typedef long double ld;

void sortPermutation(int n) {
	int cnt = performSwap(0, 1);
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			if (cnt == n) break;
			int x = performSwap(i, j);
			if (x < cnt) {
				x = performSwap(i, j);
			}
			cnt = x;
		}
	}
}

//int main() {
//	ios_base::sync_with_stdio(0);
//	cin.tie(0);
//	cout.tie(0);
//
//	return 0;
//}