#include <bits/stdc++.h>
#include "cycles.h"

using namespace std;

void sortCycle(vector<int> &v) {
    if (v.size() == 1) return;
    int cur = performSwap(v[0], v[1]);
    vector<int> v0, v1;
    v0.push_back(v[0]);
    v1.push_back(v[1]);
    for (int i = 2; i < v.size(); i++) {
        int nw = performSwap(v[0], v[i]);
        if (nw > cur) {
            v0.push_back(v[i]);
        } else {
            v1.push_back(v[i]);
        }
        performSwap(v[0], v[i]);
    }
    sortCycle(v0);
    sortCycle(v1);
}

void sortPermutation(int N) {
    int cur = performSwap(0, 1);
    for (int i = 1; i < N; i++) {
        int nw = performSwap(i - 1, i);
        if (nw > cur) {
            nw = performSwap(i - 1, i);
        }
        cur = nw;
    }
    //assert(cur == 1);
    vector<int> v(N);
    for (int i = 0; i < N; i++) {
        v[i] = i;
    }
    sortCycle(v);
}