#include <iostream>
#include <vector>

using namespace std;

constexpr int maxn = 2e3 + 5;

vector<int> g[maxn];

int dp[maxn][maxn];

int dp_nxt[maxn];

int calc_dp(int v, int pr, int mx_d) {
    for (int i = 0; i < maxn; ++i) {
        dp[v][i] = 0;
    }
    int cnt_mx = 0;
    for (auto u : g[v]) {
        if (u != pr) {
            int cnt_add = calc_dp(u, v, mx_d);
            for (int i = 0; i <= cnt_mx + cnt_add + 1; ++i) {
                dp_nxt[i] = maxn;
            }
            for (int vl_prv = 0; vl_prv <= cnt_mx; ++vl_prv) {
                for (int vl_add = 0; vl_add <= cnt_add; ++vl_add) {
                    if (dp[v][vl_prv] + dp[u][vl_add] + 1 <= mx_d) {
                        dp_nxt[vl_prv + vl_add] = min(dp_nxt[vl_prv + vl_add], max(dp[v][vl_prv], dp[u][vl_add] + 1));
                    }
                    if (dp[v][vl_prv] + dp[u][vl_add] <= mx_d) {
                        dp_nxt[vl_prv + vl_add + 1] = min(dp_nxt[vl_prv + vl_add + 1], max(dp[v][vl_prv], dp[u][vl_add]));
                    }
                }
            }
            cnt_mx += cnt_add + 1;
            for (int i = 0; i <= cnt_mx; ++i) {
                dp[v][i] = dp_nxt[i];
            }
            for (int i = 1; i < maxn; ++i) {
                dp[v][i] = min(dp[v][i], dp[v][i - 1]);
            }
        }
    }
    return cnt_mx;
}

void solve() {
    int n, k;
    cin >> n >> k;
    k = min(k, n - 1);
    for (int i = 0; i < n - 1; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    int l = -1, r = n - 1;
    while (l < r - 1) {
        int m = (l + r) / 2;
        calc_dp(0, -1, m);
        if (dp[0][k] <= m) {
            r = m;
        } else {
            l = m;
        }
    }
    cout << r << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
