#include <bits/stdc++.h>
#include <cassert>

using namespace std;
using ll = long long;

#define all(x) (x).begin(), (x).end()
#define pb push_back
#define sz(x) (int)(x).size()

void solve() {
    int n, k; cin >> n >> k;
    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < n - 1; i++) {
        int u, v, w; cin >> u >> v >> w;
        u--; v--;
        g[u].pb({v, w});
        g[v].pb({u, w});
    }

    vector<int> ord, par(n);
    auto dfs = [&](int v, int p, auto&&self) -> void {
        par[v] = p;
        ord.pb(v);
        for (auto [u, w] : g[v]) {
            if (u != p) self(u, v, self);
        }
    };
    dfs(0, 0, dfs);
    reverse(all(ord));

    ll L = -1, R = 2000000000;
    auto calc = [&](int M) {
        int made = 0;
        vector<int> dp(n);
        for (int v : ord) {
            int mx = 0, mx2 = 0, S = 0, S2 = 0, cnt = 0;
            for (auto [u, w] : g[v]) {
                if (u != par[v]) {
                    cnt++;
                    int cs = w + dp[u];
                    S += cs;
                    S2 += min(cs, M / 2);
                    if (mx < cs) {
                        mx2 = mx; mx = cs;
                    } else if (mx2 < cs) mx2 = cs;
                }
            }
            if (!cnt) dp[v] = 0;
            else if (mx + mx2 <= M) dp[v] = mx;
            else {
                if (M % 2 == 0) {
                    if (mx2 >= M / 2) {
                        made += S - S2;
                        dp[v] = M / 2;
                    } else {
                        made += mx - (M - mx2);
                        dp[v] = M - mx2;
                    }
                } else {
                    if (mx2 >= M / 2) {
                        made += S - S2 - 1;
                        dp[v] = M / 2 + 1;
                    } else {
                        made += mx - (M - mx2);
                        dp[v] = M - mx2;
                    }
                }
            }
        }
        // auto dfs = [&](int v, int p, auto&&self) -> int {
        //     int mx = 0, mx2 = 0, S = 0, S2 = 0, cnt = 0;
        //     for (auto [u, w] : g[v]) {
        //         if (u != p) {
        //             cnt++;
        //             int cs = w + self(u, v, self);
        //             S += cs;
        //             S2 += min(cs, M / 2);
        //             if (mx < cs) {
        //                 mx2 = mx; mx = cs;
        //             } else if (mx2 < cs) mx2 = cs;
        //         }
        //     }
        //     if (!cnt) return 0;
        //     if (mx + mx2 <= M) return mx;
        //     if (M % 2 == 0) {
        //         if (mx2 >= M / 2) {
        //             made += S - S2;
        //             return M / 2;
        //         } else {
        //             made += mx - (M - mx2);
        //             return M - mx2;
        //         }
        //     } else {
        //         if (mx2 >= M / 2) {
        //             made += S - S2 - 1;
        //             return M / 2 + 1;
        //         } else {
        //             made += mx - (M - mx2);
        //             return M - mx2;
        //         }
        //     }
        // };
        // dfs(0, 0, dfs);
        return made;
    };
    while (R - L > 1) {
        ll M = (L + R) / 2;
        int made = calc(M);
        if (made <= k) R = M;
        else L = M;
    }
    cout << R << '\n';
}

signed main() {
    int tt = 1;
    #ifdef LOCAL 
        freopen("in.txt", "r", stdin);
        freopen("out.txt", "w", stdout);
        cin >> tt;
    #else 
        cin.tie(0)->sync_with_stdio(false);
    #endif

    while (tt--) {
        solve();
    }
}