#include <bits/stdc++.h>

using namespace std;

//#define int ll
using ll = long long;
using vi = vector<int>;
using ii = pair<int, int>;
using pl = pair<ll, ll>;
using vll = vector<ll>;
using ld = long double;
using pct = pair<ld, ld>;

const ld INF = 1e40;
const ld EPS = 1e-20;

int n;
vector<pct> V;

int max_a0 = -1, max_b0 = -1;
void init(const vi &A, const vi &B) {
    for(int i = 0; i < (int)A.size(); ++i) {
        if(i && A[i] == A[i - 1] && B[i] == B[i - 1]) continue; /// sare
        V.push_back({A[i], B[i]});
        if(A[i] && B[i]);
        else if(A[i]) {
            if(max_a0 == -1)
                max_a0 = A[i];
            else
                max_a0 = min(max_a0, A[i]);
        } else {
            if(max_b0 == -1) max_b0 = B[i];
            else max_b0 = min(max_b0, B[i]);
        }
    }
    n = (int)V.size();
    sort(V.begin(), V.end());
}

struct fun {
    ld a, b; /// a x + b

    fun(ld a0 = 0., ld b0 = 0.) : a(a0), b(b0) {}
    ld operator()(ld x) { return a * x + b; }
};

ld intersect(fun f1, fun f2) {
    if(abs(f1.a - f2.a) < EPS) return 0;
    return (f1.b - f2.b) / (f2.a - f1.a);
}

ld get_val(pct p1, pct p2, int Ma, int Mb) {
    auto [x1, y1] = p1; auto [x2, y2] = p2;
    fun f1{ld(x1 - x2) / (Ma + EPS), ld(x2) / (Ma + EPS)},
        f2{ld(y1 - y2) / (Mb + EPS), ld(y2) / (Mb + EPS)};

    auto get_f = [&](ld x) { /// functii de lambda !!! (interpolare intre x1 si x2)
        /// 0 <= x <= 1 !!
        return max(f1(x), f2(x));
    };
    ld re = INF;

    if(abs(f1.a - f2.a) > EPS) {
        ld x_i = intersect(f1, f2);
        if(x_i > 0. && x_i < 1.)
            re = get_f(x_i);
    }
    re = min({re, get_f(0.), get_f(1.)});

    return 1. / (re + EPS);
}

ld get_val(pct p1, int Ma, int Mb) {
    if(!Ma && p1.first > EPS) return 0;
    if(!Ma) return ld(Mb) / p1.second;
    if(!Mb && p1.second > EPS) return 0;
    if(!Mb) return ld(Ma) / p1.first;

    return min(ld(Ma) / p1.first, ld(Mb) / p1.second);
}


ld cross(pct a, pct b) {
    return a.first * b.second - a.second * b.first;
}

ld det(pct a, pct b, pct c) {
    return cross({a.first - c.first, a.second - c.second}, 
        {b.first - c.first, b.second - c.second});
}

ld re_egale = -1;
double friendDrink(int Ma, int Mb, int La, int Ra) {
    ld re = 0;
    vector<pct> C;
    if(Ma == Mb && re_egale > 0) return re_egale * Ma;

    auto good = [&](pct a, pct b, pct c) {
        return det(a, b, c) > 0;
    };
    for(auto it : V) {
        auto [x1, y1] = it;
        if(x1 < La - .5 || x1 > Ra + .5) continue;
        re = max(re, get_val(it, Ma, Mb));
        while(C.size() >= 2 && !good(C.end()[-2], C.back(), it)) C.pop_back();
        C.push_back(it);
    }
    for(int i = 0; i + 1 < C.size(); ++i) {
        re = max(re, get_val(C[i], C[i + 1], Ma, Mb));
    }
    re_egale = re;
    return re;
}

//int main() {
////	std::ios_base::sync_with_stdio(false); std::cin.tie(NULL);
//
//	int n, q;
//	std::cin >> n >> q;
//
//	std::vector<int> A(n), B(n);
//	for (int i = 0; i < n; i ++) {
//		std::cin >> A[i] >> B[i];
//	}
//	init(A, B);
//
//	for (int i = 0; i < q; i ++) {
//		int a, b, l, r;
//		std::cin >> a >> b >> l >> r;
//		const auto ret = friendDrink(a, b, l, r);
//		std::cout << fixed << setprecision(9) << ret << "\n";
//	}
//
//	return 0;
//}
