#include "cycles.h"
#include <bits/stdc++.h>

using namespace std;

//#define int ll
using ll = long long;
using vi = vector<int>;
using ii = pair<int, int>;
using pl = pair<ll, ll>;
using vll = vector<ll>;

void sortPermutation(int n) {
    vi P(n);
    iota(P.begin(), P.end(), 0);
    int nr_cyc = performSwap(0, 1);
    mt19937 rng(71);
    while(nr_cyc != n) {
        shuffle(P.begin(), P.end(), rng);
        int nr_exp = nr_cyc, p = 0;
        for(int i = 0; i + 1 < n; ++i) {
            int v = performSwap(P[i], P[i + 1]);
            if(v == --nr_exp) continue; /// a scazut nr ciclii, e ok
            else { /// hopa, am gasit unul care a mai aparut odata
                p = i; /// p + 1 a mai aparut
                break;
            }
        }
        for(int i = p; i >= 0; --i) {
            performSwap(P[i], P[i + 1]); /// undo the testing above
        }
        for(int i = 0; i <= p; ++i) {
            int v = performSwap(P[i], P[p + 1]);
            if(v > nr_cyc) {
                nr_cyc = v;
                break; /// we did it
            } else {
                performSwap(P[i], P[p + 1]); /// undo
            }
        }
    }
}


//#include <iostream>
//#include <vector>
//#include <cassert>
//#include <algorithm>
//#include "cycles.h"
//
//static int64_t cnt = 0;
//static std::vector<int> perm;
//static int64_t n;
//
//static int findPermCount() {
//	std::vector<bool> used(n, false);
//	int64_t cntc = 0;
//	for (int64_t i = 0; i < n; i ++) {
//		if (used[i]) { continue; }
//		int64_t curr = i; cntc ++;
//		while (!used[curr]) {
//			used[curr] = true;
//			curr = perm[curr];
//		}
//	}
//    return cntc;
//}
//
//int performSwap(int i, int j) {
//	++cnt;
//
//    bool valid_swap = true;
//    valid_swap &= (0 <= i && i < n);
//    valid_swap &= (0 <= j && j < n);
//    valid_swap &= (i != j);
//
//    if (!valid_swap) {
//        std::cout << "WRONG. Your program made an invalid swap: (" << i << ", " << j << ")" << std::endl;
//        exit(0);
//    }
//
//	std::swap(perm[i], perm[j]);
//	return findPermCount();
//}
//
//int main() {
//	std::cin >> n;
//	perm.resize(n);
//	for (int64_t i = 0; i < n; i ++) { std::cin >> perm[i]; }
//
//	sortPermutation(n);
//	if (findPermCount() != n) {
//		std::cout << "WRONG. The final permutation is not sorted." << std::endl;
//	} else {
//		std::cout << "CORRECT with " << cnt << " swaps" << std::endl;
//	}
//	return 0;
//}