#include <bits/stdc++.h>

using namespace std;

//#define int ll
using ll = long long;
using vi = vector<int>;
using ii = pair<int, int>;
using pl = pair<ll, ll>;
using vll = vector<ll>;

struct tree {
    int n;
    vi D;
    vector<vi> L;
    tree(int N) : n(N), D(N, 1e9), L(N) {}

    void add_edge(int u, int v) {
        L[u].push_back(v);
        L[v].push_back(u);
    }

    void init() {
        function<void(int, int)> dfs = [&](int u, int p) {
            if(L[u].size() == 1) D[u] = 0;
            if(p != -1) D[u] = min(D[u], D[p] + 1);
            for(auto it : L[u]) {
                if(it == p) continue;
                dfs(it, u);
                D[u] = min(D[u], D[it] + 1);
            }
        };
        dfs(0, -1);
        dfs(0, -1);
    }

    int solve(int k) {
        vi P(n, 0);
        iota(P.begin(), P.end(), 0);
        sort(P.begin(), P.end(), [&](auto a, auto b) { return D[a] < D[b]; });
        int cost = n - 1;
        vi active(n, 1);
        vi UltD = {0, 0};
        for(auto it : P) { // le scot
            if(cost <= k) {
                return UltD.back() + UltD.end()[-2];
            }
            for(auto it2 : L[it]) {
                if(active[it2]) {
                    --cost;
                }
            }
            active[it] = 0;
            UltD.push_back(D[it] + 1);
        }
    }
};

int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);
    int n, k;
    cin >> n >> k;
    ///rezolvam w_i = 1
    tree T(n);
    for(int i = 1; i < n; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u; --v;
        T.add_edge(u, v);
    }
    T.init();
    cout << T.solve(k) << "\n";

    return 0;
}