#include <bits/stdc++.h>
using namespace std;
const long long mxN = 2e5+5;
const long long INF = 1e12;
vector<pair<long long, long long>> adj[mxN];
vector<long long> dist(mxN);
void dfs(long long node, long long par){
    for(auto next : adj[node]){
        if(next.first==par){
            continue;
        }
        dist[next.first]=dist[node]+next.second;
        dfs(next.first,node);
    }
}
int main(){
    long long n,k; cin >> n >> k;
    for(int i=0; i<n-1; i++){
        long long a,b,c; cin >> a >> b >> c;
        adj[a].emplace_back(b,c);
        adj[b].emplace_back(a,c);
    }
    dfs(1,0);
    long long currdist = -INF; long long a = -1;
    for(int i=1; i<=n; i++){
        if(dist[i]>currdist){
            a = i;
            currdist = dist[i];
        }
    }
    dist.assign(mxN,0);
    dfs(a,0);
    long long ans = -INF;
    long long cntans = 0;
    for(int i=1; i<=n; i++){
        if(dist[i]==ans){
            cntans++;
        }
        else if(dist[i]>ans){
            cntans = 1;
            ans = dist[i];
        }
    }
    if(k==1){
        if(cntans==1){
        cout << ans-1 << endl;
        }
        else{
            cout << ans << endl;
        }
    }
    else{
    cout << ans << endl;
    }
}
