#include<bits/stdc++.h>
using namespace std;
const long long MAXN=200009;
long long N,K;
vector<int> edg[MAXN];
vector<int> ch[MAXN];
set<pair<int,int>> v[MAXN];
long long curr;

void dfs(int start,int f)
{
    ch[f].push_back(start);
    for(auto i:edg[start])
    {
        if(i!=f)dfs(i,start);
    }
}

int dfsTry(int start,int tar)
{
    pair<int,int> x,y;
    v[start].clear();
    for(auto i:ch[start])
    {
        v[start].insert({dfsTry(i,tar),i});
    }
    while(true)
    {
        if(v[start].size()==0)return 0;
        if(v[start].size()==1)
        {
            x=(*v[start].rbegin());
            if(x.first+1>tar)
            {
                curr++;
                int g=x.second;
                v[start]=v[g];
                continue;
            }
            return x.first+1;
        }
        auto t=v[start].rbegin();
        x=(*t);
        t--;
        y=(*t);
        if(x.first+y.first+2<=tar)return x.first+1;
        curr++;
        v[start].erase(x);
        if(v[start].size()<v[x.second].size())swap(v[start],v[x.second]);

        for(auto j:v[x.second])v[start].insert(j);
    }
}

bool pos(int a)
{
    curr=0;
    dfsTry(1,a);
    return curr<=K;
}

long long binary(int l,int r)
{
    int mid;
    while(l<r-1)
    {
        mid=(l+r)/2;
        if(pos(mid))
        {
            r=mid;
        }
        else
        {
            l=mid+1;
        }
    }

    if(pos(l))return l;
    return r;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    long long a,b,c;
    cin>>N>>K;
    for(int i=0; i<N-1; i++)
    {
        cin>>a>>b>>c;
        edg[a].push_back(b);
        edg[b].push_back(a);
    }
    dfs(1,0);
    if(K>=N-1)
    {
        cout<<0<<endl;
        return 0;
    }
    cout<<binary(1,N-1)<<endl;
    return 0;
}
