#include<bits/stdc++.h>
#define endl '\n'
#define pii pair<int, int>
#define tg first
#define to second
using namespace std;

    int n, k;
    const int MAXN = 1e9;
    vector <bool> used;
    vector <vector<pii>> G;
    vector <int> d;
    priority_queue <pii, vector<pii>, greater<pii>> pq;

void dijkstra (int s)
{
    //cout << "hello" << endl;
    d.resize(n, MAXN);
    used.resize(n, 0);
    d[s] = 0;
    pq.push({0, s});
    /*cout << n << endl;
    for (int i = 0; i < used.size(); i++) cout << used[i] << " ";
    cout << endl;
    for (int i = 0; i < pq.size(); i++) cout << pq[i].tg << " " << pq[i].to << " ";
    cout << endl;*/


    while (!pq.empty())
    {
        //cout << "aa" << endl;
        int curr = pq.top().to;
        pq.pop();
        //cout << pq.size() << endl;

        if (used[curr]) continue;
        used[curr] = true;
        //cout << curr << endl;
        int c = 0;
        for (auto v: G[curr])
        {
            //cout << v.tg << " " << v.to << endl;
            //cout << G[curr][c].tg << " " << G[curr][c].to << " " << d[curr] << endl;
            if (d[v.to] > G[curr][c].tg + d[curr] && !used[v.to])
            {
                d[v.to] = G[curr][c].tg + d[curr];
                pq.push({d[v.to], v.to});
            }
            c++;
        }
    }
}
int main ()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> k;
    G.resize(n);
    for (int i = 0; i < n-1; i++)
    {
        int b, e, teg;
        cin >> b >> e >> teg;
        G[b-1].push_back({teg, e-1});
        G[e-1].push_back({teg, b-1});
    }

    /*for (int i = 0; i < G.size(); i++)
    {
        for (int j = 0; j < G[i].size(); j++)
        {
            cout << i << " " << G[i][j].to << " " << G[i][j].tg << endl;
        }
    }*/

    int res = 0;
    for (int i = 0; i < n; i++)
    {
        dijkstra(i);
        int x = 0;
        for (int j = 0; j < d.size(); j++)
        {
            x = max(x, d[j]);
        }
        res = max(res, x);
    }
    /*for (int i = 0; i < d.size(); i++) cout << d[i] << " ";
    cout << endl;*/
    if (k == 0) cout << res << endl;
    else cout << res-1;
    return 0;
}

/*
5 0
1 2 5
2 3 4
2 4 3
4 5 2

10

5 1
1 2 5
2 3 4
2 4 3
4 5 2

9
*/
