# include <iostream>
# include <algorithm>
# include <vector>
using namespace std;
# include "cycles.h"
//# include "Lgrader.cpp"

const int MAX=1e3+11;

int _n;

bool check(int start)
{
    for(int i=0;i<_n;i++)
    {
        if(i==start) continue;

        int resp=performSwap(start,i);
        if(resp==_n) return true;
        performSwap(start,i);
    }

    return false;
}

void sortPermutation(int N)
{
    _n=N;

    int last=performSwap(0,1);
    if(last==N) return ;
    last=performSwap(0,1);

    if(check(0)) return ;

    int want=0;
    for(int i=1;i<N;i++)
    {
        int resp=performSwap(0,i);
        if(resp==last+1)
        {
            want=i;
            for(int j=i;j>=1;j--) performSwap(0,j);
            break;
        }
        last=resp;
    }

    //cout<<want<<"\n";
    check(want);
}

/*
5
4 1 2 3 0
*/

/*
6
0 1 3 2 4 5
*/
