# include "cycles.h"
# include <bits/stdc++.h>
using namespace std;

void sortPermutation(int N)
{
    performSwap(0, 1);
    int Original = performSwap(0, 1);
    int Leader;
    int Fake = -1;

    for(int i = 0; i < N; i++)
    {
        int Counter = 0;

        for(int j = 0; j < N; j++)
        {
            if(i == j) continue;
            int Q = performSwap(i, j);
            performSwap(i, j);
            if(Q == Original - 1)
            {
                Counter++;
            }
        }

        if(Counter == N - 1)
        {
            Leader = i;
            break;
        }
        else
        {
            Fake = i;
            break;
        }
    }

    if(Fake != -1)
    {
        for(int j = Fake + 1; j < N; j++)
        {
            int Q = performSwap(Fake, j);
            if(Q == N) return;
            performSwap(Fake, j);
        }
    }
    else
    {
        int Previous = Original;

        for(int i = Leader + 1; i < N; i++)
        {
            int Current = performSwap(i - 1, i);
            if(Current >= Previous)
            {
                Fake = i;
                break;
            }
            Previous = Current;
        }

        for(int i = Fake; i > Leader; i--)
        {
            performSwap(i - 1, i);
        }

        for(int j = 0; j < N; j++)
        {
            if(j == Fake) continue;
            int Q = performSwap(Fake, j);
            if(Q == N) return;
            performSwap(Fake, j);
        }
    }
}
