#include "cycles.h"
#include<iostream>
#include<ctime>
#include<random>
#include<cassert>

using namespace std;

typedef long long ll;

mt19937 rng(time(nullptr));

void sortPermutation(int n)
{
    int best = n - 1;

    for(int i = 0; i < n; i++)
    {
        for(int j = i + 1; j < n; j++)
        {
            if(best == n)
                return;

            int cur = performSwap(i, j);

            if(cur > best)
            {
                best = cur;
            }
            else
            {
                performSwap(i, j);
            }
        }
    }

    assert(best == n);
}