#include "cycles.h"
#include<iostream>
#include<ctime>
#include<random>
#include<cassert>

using namespace std;

typedef long long ll;

mt19937 mt(time(nullptr));

int rng(int left, int right)
{
    //cout << "Dulzhina : " << right - left + 1 << endl;
    int len = right - left + 1;

    return left + mt() % len;
}

void sortPermutation(int n)
{
    vector < bool > tru(n, false);

    for(int i = 0; i < n; i++)
    {
        for(int j = 0; j < n; j++)
            tru[j] = false;

        for(int j = i + 1; j < n; j++)
        {
            int with = rng(i + 1, n - 1);

            while(tru[with])
            {
                //cout << with << " ";
                with = rng(i + 1, n - 1);
            }     

            int cur = performSwap(i, with);

            if(cur == n)
                return;

            performSwap(i, with);
            tru[with] = true;
        }
    }
}