#include <bits/stdc++.h>
using namespace std;
const int maxN = 2e5 + 1;
#define w first
#define dest second
vector<pair<int, int>> adj[maxN];
int dist[maxN];

void dfs(int cur, int par, int curDist) {
    dist[cur] = curDist;
    for (auto e : adj[cur]) {
        if (e.dest == par) { continue; }
        dfs(e.dest, cur, curDist + e.w);
    }
}

int main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);


    int n, k;
    cin >> n >> k;
    for (int i = 0; i < n - 1; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--; b--;
        adj[a].push_back({ c, b });
        adj[b].push_back({ c, a });
    }
    dfs(0, -1, 0);
    int maxD = 0, maxDVert = 0;
    for (int i = 0; i < n; i++) {
        if (maxD < dist[i]) {
            maxD = dist[i];
            maxDVert = i;
        }
    }
    dfs(maxDVert, -1, 0);
    maxD = 0;
    for (int i = 0; i < n; i++) {
        if (maxD < dist[i]) {
            maxD = dist[i];
            maxDVert = i;
        }
    }
    cout << maxD << '\n';
}
