#include <bits/stdc++.h>

using namespace std;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

struct edge
{
    int ver,dist;
    edge(){};
    edge(int ve,int di)
    {
        ver=ve;
        dist=di;
    }
};

const int maxn=2e5+5;
int n,k,maxnode;
vector<edge>v[maxn];
long long maxpath;

void dfs(int node,int parent,long long path)
{
    if(v[node].size()==1&&path>maxpath)
    {
        maxpath=path;
        maxnode=node;
        return;
    }

    for(edge i : v[node])
    {
        if(i.ver!=parent)
        {
            dfs(i.ver,node,path+i.dist);
        }
    }
}

void find_diameter()
{
    maxpath=0;
    dfs(1,-1,0);

    maxpath=0;
    dfs(maxnode,-1,0);

    cout<<maxpath<<endl;
}

void read()
{
    cin>>n>>k;
    int a,b,c;
    for(int i=1;i<n;i++)
    {
        cin>>a>>b>>c;
        v[a].push_back({b,c});
        v[b].push_back({a,c});
    }

    find_diameter();
}

int main()
{
    speed();
    read();
    return 0;
}
