#include <bits/stdc++.h>
#define endl '\n'
#define pii pair<long long, long long>
using namespace std;

long long n, k;
vector < vector <pii> > v;
priority_queue <pii, vector<pii>  > pq;
vector <long long> d;
vector <bool> used;

void dijkstra(long long s)
{
    used.resize(n + 1, false);
    d.resize(n + 1 , -1);
    d[s] = 0;
    pq.push({0, s});
    while (!pq.empty())
    {
        s = pq.top().second;
        pq.pop();

        //if (used[s]) continue;
        //used[s] = true;

        for (auto edge : v[s])
        {
            if (d[s] + edge.first > d[edge.second])
            {
                d[edge.second] = d[s] + edge.first;
                pq.push({d[edge.second], edge.second});
            }
        }
    }
}

long long parent[200005];

long long getParent(long long v)
{
    while (parent[v] != 0)
    {
        v = parent[v];
    }
    return v;
}

int main ()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> k;
    v.resize(n + 1);
    for (long long i = 0; i < n - 1; i++)
    {
        long long from, to, tg;
        //if (from > to) swap(from, to);
        cin >> from >> to >> tg;
        v[from].push_back({tg, to});
        parent[to] = from;
    }
    dijkstra(getParent(1));
    long long maxD = 0;
    for (long long i = 1; i < n + 1; i++)
    {
        //cout << d[i] << endl;
        maxD = max(maxD, d[i]);
    }
    cout << maxD << endl;
}
/*
6 0
1 2 6
1 3 4
2 4 2
2 5 3
3 6 3
*/

