#include <bits/stdc++.h>
#define endl '\n'
#define pii pair<int, int>
using namespace std;

int n, k;
vector < vector <pii> > v;
priority_queue <pii, vector<pii>  > pq;
vector <int> d;
vector <bool> used;

void dijkstra(int s)
{
    //used.resize(n + 1, false);
    d.resize(n + 1 , -1);
    d[s] = 0;
    pq.push({0, s});
    while (!pq.empty())
    {
        s = pq.top().second;
        pq.pop();

        //if (used[s]) continue;
        //used[s] = true;

        for (auto edge : v[s])
        {
            if (d[s] + edge.first > d[edge.second])
            {
                d[edge.second] = d[s] + edge.first;
                pq.push({d[edge.second], edge.second});
            }
        }
    }
}

int parent[200005];

int getParent(int v)
{
    while (parent[v] != 0)
    {
        v = parent[v];
    }
    return v;
}
int maxSum = 0;
void dfs(int s, int sum)
{
    maxSum = max(maxSum, sum);
    used[s] = true;
    for (auto t : v[s])
    {
        if (!used[t.second])
        {
            maxSum = max(maxSum, sum);
            dfs(t.second, sum + t.first);
        }
    }
}

int main ()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> k;
    v.resize(n + 1);
    for (int i = 0; i < n - 1; i++)
    {
        int from, to, tg;
        //if (from > to) swap(from, to);
        cin >> from >> to >> tg;
        v[from].push_back({tg, to});
        parent[to] = from;
    }
    used.resize(n + 1);
    dfs(getParent(1), 0);
    cout << maxSum << endl;
}
/*
6 0
1 2 6
1 3 4
2 4 2
2 5 3
3 6 3
*/

