#include <bits/stdc++.h>
#define endl '\n'
#define pii pair<int, int>
using namespace std;

int n, k;
vector < vector <pii> > v;
vector <bool> used;


int parent[200005];

int getParent(int v)
{
    while (parent[v] != 0)
    {
        v = parent[v];
    }
    return v;
}
int maxSum = 0;
void dfs(int s, int sum)
{
    maxSum = max(maxSum, sum);
    used[s] = true;
    for (auto t : v[s])
    {
        if (!used[t.second])
        {
            maxSum = max(maxSum, sum);
            dfs(t.second, sum + t.first);
        }
    }
}

int main ()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> k;
    v.resize(n + 1);
    for (int i = 0; i < n - 1; i++)
    {
        int from, to, tg;
        //if (from > to) swap(from, to);
        cin >> from >> to >> tg;
        v[from].push_back({tg, to});
        parent[to] = from;
    }
    used.resize(n + 1);
    int maxS = 0;
    for (int i = 0; i < n; i++)
    {
        fill(used.begin(), used.end(), false);
        maxSum = 0;
        dfs(i + 1, 0);
        maxS = max(maxS, maxSum);
    }
    cout << maxS << endl;
}
/*
6 0
1 2 6
1 3 4
2 4 2
2 5 3
3 6 3

9

7 0
3 2 5
3 7 4
7 4 1
4 5 7
4 1 2
7 6 3

12
*/

