#include <bits/stdc++.h>
#define endl '\n'
#define pii pair<int, int>
using namespace std;

int n, k;
vector <int> par;
vector <int> depth;
vector < pair <int, pii> > v;

bool cmp (pair <int, pii> p, pair <int, pii> q)
{
    return p.first > q.first;
}

int getRoot(int v)
{
    while (par[v] != v)
    {
        v = par[v];
    }
    return v;
}

void join(int r1, int r2)
{
    if (depth[r1] < depth[r2]) par[r1] = r2;
    else if (depth[r1] > depth[r2]) par[r2] = r1;
    else
    {
        par[r2] = r1;
        depth[r1]++;
    }
}

int main ()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> k;
    v.resize(n + 1);
    for (int i = 0; i < n - 1; i++)
    {
        int from, to, tg;
        cin >> from >> to >> tg;
        v.push_back({tg, {from, to}});
        v.push_back({tg, {to, from}});
    }
    par.resize(n + 1);
    depth.resize(n + 1);
    for (int i = 1; i <= n; i++)
    {
        par[i] = i;
        depth[i] = 1;
    }
    sort(v.begin(), v.end(), cmp);
    int tgMST = 0;
    for (int i = 1; i <= n; i++)
    {
        int r1 = getRoot(v[i].second.first);
        int r2 = getRoot(v[i].second.second);

        if (r1 != r2)
        {
            join(r1, r2);
            tgMST += v[i].first;
        }
    }
    cout << tgMST << endl;
}
/*
6 0
1 2 6
1 3 4
2 4 2
2 5 3
3 6 3
*/

