#include "cycles.h"
#include <bits/stdc++.h>

using namespace std;

void sortPermutation(int n)
{
    unordered_set<int> positions;

    for (int i = 0; i < n; ++i)
    {
        positions.insert(i);
    }

    performSwap(0, 1);
    int cycles = performSwap(0, 1);
    //cout << "now " << cycles << endl;

    for (int i = 0; i < n; ++i)
    {
        int pos = *positions.begin(), truePos = -1;
        bool found = false;
        //cout << "for " << pos << endl;

        for (auto other : positions)
        {
            if (pos == other) continue;
            if (performSwap(pos, other) > cycles)
            {
                //cout << "found " << other << endl;
                truePos = other;
                found = true;
                break;
            }
            else
            {
                performSwap(pos, other);
            }
        }

        if (truePos != -1) positions.erase(truePos);
        else positions.erase(pos);

        if (found) ++cycles;
        if (cycles == n) break;
    }
}
