#include "cycles.h"
#include <bits/stdc++.h>

using namespace std;

void sortPermutation(int n)
{
    vector<bool> filled(n, false);

    performSwap(0, 1);
    int cntCycles = performSwap(0, 1);

    vector<vector<int>> cycles;

    for (int i = 0; i < n; ++i)
    {
        if (filled[i] == true) continue;

        vector<int> cycle;
        cycle.push_back(i);
        filled[i] = true;

        for (int j = i + 1; j < n; ++j)
        {
            if (filled[j] == true) continue;
            if (performSwap(i, j) > cntCycles)
            {
                cycle.push_back(j);
                filled[j] = true;
            }
            else
            {
                performSwap(i, j);
            }
        }

        if (cycle.size() != 1)
        {
            cycles.push_back(cycle);
        }
    }

    /*cout << "---------------" << endl;

    for (auto curr : cycles)
    {
        for (auto pos : curr) cout << pos << " ";
        cout << endl;
        cout << "now " << curr[0] << " " << curr[curr.size() - 1] << endl;
        performSwap(curr[0], curr[curr.size() - 1]);

        for (int i = curr.size() - 1; i >= 2; --i)
        {
            cout << "here" << endl;
            performSwap(curr[i], curr[i - 1]);
        }
    }*/
}
