#include <bits/stdc++.h>

using namespace std;

const int maxn = 2e5 + 5;

int n, k;
vector<pair<int, int>> g[maxn];

pair<long long, int> longest;
int diameter;
int highestNotRoot = -1;

void dfsCalc(int node, int par, int w)
{
    if (longest.first < w)
    {
        longest = {w, node};
    }

    for (auto [to, add] : g[node])
    {
        if (to != par) dfsCalc(to, node, w + add);
    }
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> k;

    for (int i = 1; i < n; ++i)
    {
        int x, y, w;
        cin >> x >> y >> w;

        g[x].push_back({y, w});
        g[y].push_back({x, w});
    }

    longest = {0, -1};
    dfsCalc(1, -1, 0);

    int node = longest.second;
    int root = node;

    longest = {0, -1};

    dfsCalc(node, -1, 0);
    diameter = longest.first;

    cout << diameter - 1 << endl;

    return 0;
}

/*
6 1
1 6 10
1 2 5
2 3 4
2 4 3
4 5 2
*/
