#include <bits/stdc++.h>

using namespace std;

const long long maxn = 2e5 + 5;

long long n, k;
vector<pair<long long, long long>> g[maxn];

pair<long long, long long> longest;
long long root;

long long cnt = 0;
long long parent[maxn];

void dfs(long long node, long long par, long long w)
{
    parent[node] = par;

    if (longest.first < w)
    {
        longest = {w, node};
    }

    for (auto [to, add] : g[node])
    {
        if (to != par) dfs(to, node, w + add);
    }
}

long long findDiameter()
{
    longest = {0, -1};
    dfs(1, -1, 0);

    int node = longest.second;
    longest = {0, -1};
    dfs(node, -1, 0);

    return longest.first;
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> k;

    for (long long i = 1; i < n; ++i)
    {
        long long x, y, w;
        cin >> x >> y >> w;

        g[x].push_back({y, w});
        g[y].push_back({x, w});
    }

    cout << findDiameter() - k << endl;

    return 0;
}
