#include <bits/stdc++.h>
using namespace std;

const int MAXN = 200007;
int n, k;
vector<pair<int, pair<int, int>>> G[MAXN];

int decEdg = -1;

pair<int, int> findFarthest(int curr, int prev=-1){
    int mxNode = curr, mxDist = 0;
    for(int i = 0; i < G[curr].size(); i++){
        int nxt = G[curr][i].first, dst = G[curr][i].second.first;
        if(nxt == prev){ continue; }

        if(G[curr][i].second.second == decEdg){ dst--; }
        pair<int, int> subcall = findFarthest(nxt, curr);
        if(subcall.second + dst > mxDist){
            mxDist = subcall.second + dst;
            mxNode = subcall.first;
        }
    }
    return {mxNode, mxDist};
}

int measureDiameter(){
    return findFarthest( findFarthest(0).first ).second;
}

int main(){
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr);
//    cout.tie(nullptr);

    cin >> n >> k;
    for(int i = 0; i < n-1; i++){
        int u, v, w;
        cin >> u >> v >> w;
        u--; v--;
        G[u].push_back({v, {w, i}});
        G[v].push_back({u, {w, i}});
    }

    if(k == 0){
        cout << measureDiameter() << '\n';
    }else if(k == 1){
        int mn = INT_MAX;
        for(int i = 0; i < n-1; i++){
            decEdg = i;
            mn = min(mn, measureDiameter());
        }
        cout << mn << '\n';
    }
}
