#include <iostream>
#include <utility>
#include <vector>

const int MAX_N = 1e6+69;
int obhodeno[MAX_N];

int n, k;

std::vector <std::pair <int, int>> durvo[MAX_N];

void fil(int path_sum, int v) {
    if (obhodeno[v] != -1) return;
    obhodeno[v] = path_sum;
    for (auto i: durvo[v]) {
        fil(path_sum + i.second, i.first);
    }
}

void prez(int v) {
    for (int i = 0; i <= n; i++) obhodeno[i] = -1;
    fil(0, v);
}

int main() {
    std::cin >> n >> k;
    for (int i = 0; i < (n-1); i++) {
        int t1, t2, t3;
        std::cin >> t1 >> t2 >> t3;
        durvo[t1].push_back({ t2, t3 });
        durvo[t2].push_back({ t1, t3 });
    }

    int max_put = -1;
    for (int i = 1; i <= n; i++) {
        prez(i);
        for (int j = 1; j <= n; j++) {
            if (max_put < obhodeno[j]) max_put = obhodeno[j];
        }
    }

    std::cout << max_put << std::endl;
}