#include <bits/stdc++.h>
#include <vector>
#include <iostream>
using namespace std;
int m = 0;
vector <vector<pair<int,int>>> G;
bool used[200005];
vector <int> d;
priority_queue < pair<int,int>, vector <pair<int,int>>, greater<pair<int,int>>> pq;

void dijkstra ( int s, int n )
{
    d.resize(n+5, 0);
    memset(used, 0, sizeof(used));
    d[s] = 0;
    while ( !pq.empty()) pq.pop();
    pq.push({0, s});
    while ( !pq.empty() )
    {
        s = pq.top().second;
        pq.pop();
        if ( used[s] == 1 ) continue;
        used[s] = 1;
        for ( auto v : G[s] )
        {
            if ( d[s] + v.first > d[v.second] )
            {
                d[v.second] = v.first + d[s];
                pq.push({d[v.second], v.second});
            }
        }
    }
    for ( int i = 1; i <= n; i++ )
    {
        m = max(m, d[i]);
    }
}
int main()
{
    int n, k, v1, v2, w;
    cin >> n >> k;
    G.resize(n+4);
    for ( int i = 0; i < n-1; i++ )
    {
        cin >> v1 >> v2 >> w;
        G[v1].push_back({w, v2});
        G[v2].push_back({w, v1});
    }
    for ( int i = 1; i <= n; i++ )
    {
        dijkstra(i, n);
    }
    cout << m << endl;
}
