#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

const int MAXN = 2e5+5;

struct edge
{
    int ver,num;
};

int n,k,sp[MAXN];
vector<edge>g[MAXN];

void read()
{
    cin >> n >> k;
    int x,y,d;
    for(int i = 1; i < n; i++)
    {
        cin >> x >> y >> d;
        g[x].push_back({y,i});
        g[y].push_back({x,i});
        sp[i] = d;
    }
}


pair<int, long long> fapp;

void dfs_far(int beg, int par, long long cost)
{
    if(cost > fapp.second) fapp = {beg,cost};

    for(edge nb : g[beg])
    {
        if(nb.ver != par) dfs_far(nb.ver,beg,cost + sp[nb.num]);
    }
}

void solve()
{
    fapp = {1,0};
    dfs_far(1,1,0);
    dfs_far(fapp.first,fapp.first,0);
    cout << fapp.second << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    solve();
    return 0;
}
