#include <bits/stdc++.h>
#define pb push_back
#define N 200001
using namespace std;

int n, k;

struct edge
{
    int ver;
    int w;
};

vector<edge>tr[N];

void read()
{
    cin>>n>>k;
    int u, v, w;
    for(int i = 0; i < n-1; i++)
    {
        cin>>u>>v>>w;
        tr[u].pb({v, w});
        tr[v].pb({u, w});
    }
}

long long path1[N], path2[N];
int maxp, maxv;

void dfs1(int beg, int p)
{
    int nb, sz = tr[beg].size();
    for(int i = 0; i < sz; i++)
    {
        nb = tr[beg][i].ver;

        if(path1[nb] == 0 && nb != p)
        {
            path1[nb] = path1[beg] + tr[beg][i].w;
            if(path1[nb] > maxp)
            {
                maxp = path1[nb];
                maxv = nb;
            }
            dfs1(nb, beg);
        }
    }
}

void dfs2(int beg, int p)
{
    int nb, sz = tr[beg].size();
    for(int i = 0; i < sz; i++)
    {
        nb = tr[beg][i].ver;

        if(path2[nb] == 0 && nb != p)
        {
            path2[nb] = path2[beg] + tr[beg][i].w;
            if(path2[nb] > maxp)
            {
                maxp = path2[nb];
                maxv = nb;
            }
            dfs2(nb, beg);
        }
    }
}



int solve()
{
    maxp = 0;
    maxv = 0;
    memset(path1, 0, sizeof(path1));
    memset(path2, 0, sizeof(path2));
    dfs1(1, 0);
    dfs2(maxv, 0);
    return maxp;
}

int main()
{
    read();
    long long minn = LONG_MAX;
    for(int i=1;i<=n;i++)
    {
        for(int j = 0;j < tr[i].size(); j++)
        {
            int nb = tr[i][j].ver;
            if(i<nb&&tr[i][j].w>0)
            {
                tr[i][j].w--;
                int x = solve();
                tr[i][j].w++;
                if(x<minn)minn = x;
            }
        }
    }
    cout<<minn<<endl;
    return 0;
}
