#include <bits/stdc++.h>
#define pb push_back
#define N 200001
using namespace std;

int n, k;

struct edge
{
    int ver;
    int w;
};

vector<edge>tr[N];

void read()
{
    cin>>n>>k;
    int u, v, w;
    for(int i = 0; i < n-1; i++)
    {
        cin>>u>>v>>w;
        tr[u].pb({v, w});
        tr[v].pb({u, w});
    }
}

long long path1[N], path2[N], path3[N];
long long maxp, maxv;
set<int>maxs;

void dfs1(int beg, int p)
{
    int nb, sz = tr[beg].size();
    for(int i = 0; i < sz; i++)
    {
        nb = tr[beg][i].ver;

        if(path1[nb] == 0 && nb != p)
        {
            path1[nb] = path1[beg] + tr[beg][i].w;
            if(path1[nb] > maxp)
            {
                maxp = path1[nb];
                maxv = nb;
                maxs.erase(maxs.begin(), maxs.end());
            }
            if(path1[nb] == maxp)maxs.insert(nb);
            dfs1(nb, beg);
        }
    }
}

set<int>d, ac;

void dfs2(int beg, int p, set<int> &s)
{
    int nb, sz = tr[beg].size();
    for(int i = 0; i < sz; i++)
    {
        nb = tr[beg][i].ver;

        if(path2[nb] == 0 && nb != p)
        {
            s.insert(nb);
            path2[nb] = path2[beg] + tr[beg][i].w;
            if(path2[nb] > maxp)
            {
                maxp = path2[nb];
                ac = s;
            }
            dfs2(nb, beg, s);
            s.erase(s.find(nb));
        }
    }
}

bool b;
long long maxp1;

void dfs3(int beg, int p)
{
    //cout<<beg<<endl;
    int nb, sz = tr[beg].size();
    auto it  = ac.find(beg);
    for(int i = 0; i < sz; i++)
    {
        nb = tr[beg][i].ver;
        auto it2 = ac.find(nb);
        if(it!=ac.end()&&it2!=ac.end())continue;
        if(path3[nb] == 0 && nb != p)
        {
            path3[nb] = path3[beg] + tr[beg][i].w;
            if(path3[nb] > maxp1)
            {
                maxp1 = path3[nb];
            }
            dfs3(nb, beg);
        }
    }
}


void solve()
{
    dfs1(1, 0);
    d.insert(maxv);
    dfs2(maxv, 0, d);

    //cout<<"POSS"<<endl;
    set<int>poss;
    /*
    for(auto it = ac.begin(); it!=ac.end();++it)
    {
        cout<<*it<<" ";
    }
    cout<<endl;
    */
    for(auto it = maxs.begin(); it!=maxs.end();++it)
    {
        if(ac.find(*it)==ac.end())poss.insert(*it);
    }
    if(poss.size()==0)
    {
        cout<<max(maxp-1, (long long)(0))<<endl;
    }
    else
    {
        int vv = *poss.begin();
        //cout<<vv<<endl;
        dfs3(vv, 0);
        if(maxp1==maxp)
        {
            cout<<maxp<<endl;
            return;
        }
    }
    cout<<max(maxp-1, (long long)(0))<<endl;
}

int main()
{
    read();
    solve();
    //cout<<0<<endl;
    return 0;
}
