#include <bits/stdc++.h>
#include "soft_drinks.h"

#ifdef __LOCAL__
#include "Lgrader.cpp"
#endif // __LOCAL__

using namespace std;

int N;
vector <double> a, b;
void init(const std::vector<int>& A, const std::vector<int>& B)
{
    N = A.size();
    for (int i = 0; i < N; i++)
    {
        a.push_back((double)A[i]);
        b.push_back((double)B[i]);
    }
}

double eps = 0.000001;
double friendDrink(int Ma, int Mb, int La, int Ra)
{
    vector <int> indecies;
    for (int i = 0; i < N; i++)
    {
        if (La <= a[i] && a[i] <= Ra)
            indecies.push_back(i);
    }

    vector <int> coeff;
    for (int ind:indecies)
    {
        int ai = (a[ind]==0?eps:a[ind]);
        int bi = (b[ind]==0?eps:b[ind]);

        coeff.push_back(ai);
        coeff.push_back(bi);
    }

    if (indecies.size() == 0)
        return 0;

    if (indecies.size() == 1)
        return min((double)Ma / coeff[0], (double)Mb / coeff[1]);

    double a1 = coeff[0], b1 = coeff[1];
    double a2 = coeff[2], b2 = coeff[3];

    double ans1 = min((double)Ma / a1, (double)Mb / b1);
    double ans2 = min((double)Ma / a2, (double)Mb / b2);

    double c1 = -Ma;
    double c2 = -Mb;

    double m1 = -a1/b1;
    double k1 = -c1/b1;

    double m2 = -a2/b2;
    double k2 = -c2/b2;

    double x_intersect = (k2-k1)/(m1-m2);
    double y_intersect = m1*x_intersect+k1;

    double ans3 = x_intersect+y_intersect;

    return max(ans1, max(ans2, ans3));
}

