#include <bits/stdc++.h>
#include "cycles.h"

#ifdef __LOCAL__
#include "Lgrader.cpp"
#endif // __LOCAL__

using namespace std;

void sortPermutation(int N)
{
    int currPerm = N-1;
    int swappedIndex = -1;

    stack <pair <int, int>> perfromedSwaps;
    for (int i = 0; i < N-1; i++)
    {
        int nextPerm = performSwap(i, i+1);
        perfromedSwaps.emplace(i, i+1);

        if (nextPerm >= currPerm)
        {
            swappedIndex = i+1;
            break;
        }

        currPerm = nextPerm;
    }

    while (!perfromedSwaps.empty())
    {
        int a = perfromedSwaps.top().first;
        int b = perfromedSwaps.top().second;
        perfromedSwaps.pop();
        performSwap(a, b);
    }

    for (int i = 0; i < N; i++)
    {
        int nextPerm = performSwap(i, swappedIndex);
        if (nextPerm == N)
            return;

        performSwap(i, swappedIndex);
    }

}

/*

6
0 1 2 5 4 3
*/
