#include<iostream>
#include<vector>
using namespace std;
const int MAX_N=1e5+5;
int dp[2005][2005],p[2005][2005];
int diam;
int mxdepth[2005];
vector<int>g[MAX_N];
int n,k;
void dfs(int u,int par)
{
    mxdepth[u]=0;

    for(int v:g[u])
    {
        if(v==par)continue;

        dfs(v,u);

        mxdepth[u]=max(mxdepth[u],1+mxdepth[v]);
    }

    for(int minmaxdist=0;minmaxdist<=min(mxdepth[u],diam);minmaxdist++)
    {
        dp[u][minmaxdist]=0;
        int minval=1e9;

        for(int v:g[u])
        {
            if(v==par)continue;

            if(minmaxdist==0)
            {
                dp[u][0]+=1+dp[v][0];

                continue;
            }

            int valnotexact=min((diam-minmaxdist-1<0 ? 1000000000 : 0+p[v][min(minmaxdist-1,diam-minmaxdist-1)]),1+p[v][min(minmaxdist,diam-minmaxdist)]);
            int valexact=min(0+dp[v][minmaxdist-1],1+dp[v][minmaxdist]);

            dp[u][minmaxdist]+=valnotexact;
            minval=min(minval,-valnotexact+valexact);
        }

        minval=0;

        if(minmaxdist>0){dp[u][minmaxdist]+=minval;p[u][minmaxdist]=min(dp[u][minmaxdist],p[u][minmaxdist-1]);}
        else p[u][0]=dp[u][0];
    }

    for(int minmaxdepth=mxdepth[u]+1;minmaxdepth<=diam;minmaxdepth++)
    {
        p[u][minmaxdepth]=p[u][minmaxdepth-1];
    }
}
bool check()
{
    dfs(1,0);
    if(p[1][diam]<=k)return 1;
    return 0;
}
int main ()
{
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n>>k;
    for(int i=1;i<n;i++)
    {
        int a,b,c;
        cin>>a>>b>>c;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    int l=0,r=n-1;
    int ans=n-1;
    while(l<=r)
    {
        int mid=(l+r)/2;
        diam=mid;
        if(check())
        {
            ans=mid;
            r=mid-1;
        }
        else l=mid+1;
    }
    cout<<ans<<"\n";

    return 0;
}
