#include<iostream>
#include <vector>
#include <queue>
#include <algorithm>
using namespace std;

struct edge{
    int u, w;
    edge(){}
    edge(int _u, int _w){
        u = _u;
        w = _w;
    }
};

bool cmp(edge e1, edge e2){
    return e1.w > e2.w;
}

int n, k;
vector<edge> graph[200001];
int diameter = 0;

vector<int> used;

void read(){
    cin >> n >> k;
    used.resize(n, 0);
    for(int i = 0; i < n-1; i++){
        int u, v, w;
        cin >> u >> v >> w;
        graph[u].push_back(edge(v, w));
        graph[v].push_back(edge(u, w));
    }
}

void get_diameter(int s){
   used[s] = 1;
   if(s == n) return;

   for(int i = 0; i < graph[s].size(); i++){
        if(!used[graph[s][i].u]){
            diameter += graph[s][i].w;
            if(graph[s][i].u == n) return;
            get_diameter(graph[s][i].u);
            //diameter -= graph[s][i].w;
        }
   }
}

int main(){
    read();
    get_diameter(1);
    cout << diameter << endl;
    return 0;
}
