#include<iostream>
#include <vector>
#include <queue>
#include <algorithm>
using namespace std;

struct edge{
    int u, w;
    edge(){}
    edge(int _u, int _w){
        u = _u;
        w = _w;
    }
};

bool cmp(edge e1, edge e2){
    return e1.w > e2.w;
}

int n, k;
edge graph[200001];
int diameter = 0;
vector<int> topo;

vector<int> used;

void read(){
    cin >> n >> k;
    used.resize(n, 0);

    for(int i = 0; i < n-1; i++){
        int u, v, w;
        cin >> u >> v >> w;
        graph[u]=(edge(v, w));
        //graph[v].push_back(edge(u, w));
    }
}

void get_diameter(int s){
   used[s] = 1;

   topo.push_back(s);
   diameter += graph[s].w;
   if(s == n) return;
   get_diameter(graph[s].u);
}

int main(){
    read();
    get_diameter(1);
    //for(int i = 0; i < topo.size(); i++) cout << topo[i] << endl;
    cout << diameter << endl;
    return 0;
}
