#include <bits/stdc++.h>
using namespace std;
#define endl '\n'

const int maxn = 1 + 2e5, INF = 1e9;
int depth[maxn], ans = 0;
vector<pair<int, int>> edges[maxn];
bool visited[maxn];

void dfs(int u) {
  visited[u] = true;
  ans = max(depth[u], ans);

  for (auto &e : edges[u]) {
    int next = e.first, w = e.second;
    if (!visited[next]) {
      depth[next] = depth[u] + w;
      dfs(next);
    }
  }
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);

  int n, k;
  cin >> n >> k;

  vector<bool> root(n + 1, true);
  for (int i = 1; i < n; i++) {
    int u, v, w;
    cin >> u >> v >> w;
    edges[u].push_back({v, w});
    edges[v].push_back({u, w});
    root[v] = false;
  }
  for (int i = 1; i <= n; i++)
    if (root[i])
      depth[i] = 0, dfs(i);

  cout << ans << endl;
}