#include<bits/stdc++.h>
#include "cycles.h"

#define MAXN 1007
using namespace std;

int n,init;
int where[MAXN],lt[MAXN],rt[MAXN];
stack< pair<int,int> > st;

int query(int x,int y){
    return performSwap(x-1,y-1);
}

int last;

void undo(){
    while(!st.empty()){
        init=query(st.top().first,st.top().second);
        st.pop();
    }
}

vector<int> v,qs[MAXN];

void solve(){
    for(int i=1;i<=n;i++)qs[i].clear();

    for(int i=1;i<=n;i++){
        if(where[i]!=0)continue;
        if(lt[i]+1==rt[i])continue;

        qs[v[(lt[i]+rt[i])/2]].push_back(i);
    }

    bool ok=false;
    for(int i=1;i<=n;i++){
        if(!qs[i].empty())ok=true;
    }

    if(!ok)return;

    int curr=init;
    for(int i=1;i<=n;i++){

        if(where[i]!=0 and i>1){
            curr=query(1,i);
            st.push({1,i});
        }

        for(int f:qs[i]){
            int nxt=query(1,f);

            if(nxt>curr){
                rt[f]=(lt[f]+rt[f])/2;
            }else{
                lt[f]=(lt[f]+rt[f])/2;
            }

            query(1,f);
        }
    }

    undo();
}

void solve_cycle(vector<int> s){
    if(s.empty() or s.size()==1)return;

    random_shuffle(s.begin(),s.end());

    init=query(s[0],s[1]);
    vector<int> l={s[0]},r={s[1]};

    for(int i=2;i<s.size();i++){
        int curr=query(s[0],s[i]);

        if(curr>init){
            l.push_back(s[i]);
        }else{
            r.push_back(s[i]);
        }

        query(s[0],s[i]);
    }

    solve_cycle(l);
    solve_cycle(r);
}

void sortPermutation(int N){
    n=N;

    for(int i=2;i<=n;i+=10){
        query(rand()%(i-1)+1,i);
    }

    init=query(1,2);
    where[1]=1;
    v={1};

    for(int i=2;i<=n;i++){
        int curr=query(1,i);

        if(curr<init){
            v.push_back(i);
            where[i]=i;
            init=curr;
            st.push({1,i});

        }else query(1,i);
    }

    undo();

    for(int i=1;i<=n;i++){
        if(where[i]!=0)continue;

        lt[i]=-1;
        for(int f=0;f<v.size();f++){
            if(v[f]<i)rt[i]=f;
        }
    }

    for(int i=0;i<10;i++)solve();
    
    for(int i=1;i<=n;i++){
        if(where[i]==0){
            where[i]=v[rt[i]];
        }
    }

    for(int i:v){
        vector<int> w;
        for(int f=i;f<=n;f++){
            if(where[f]==i)w.push_back(f);
        }

        solve_cycle(w);
    }
}