/*
    Zarad tebe vdigam vurtoleta
*/

#include "cycles.h"
#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <random>
#include <chrono>
#include <vector>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

template <typename T>
using OSet = __gnu_pbds::tree <T, __gnu_pbds::null_type, std::less <T>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

typedef long long llong;
const llong TIME = std::chrono::steady_clock::now().time_since_epoch().count();
const int MAXN = 1e6 + 10;
const int MAXLOG = 20;

int n;
std::mt19937 rng(69420);
std::vector <std::pair <int,int>> v;

void sortPermutation(int N)
{
    n = N;
    int cnt = performSwap(69, 420); 
    for (int i = 0 ; i < n && cnt < n ; ++i)
    {
        for (int j = i + 1 ; j < n && cnt < n ; ++j)
        {
            int curr = performSwap(i, j);
            if (curr < cnt)
            {
                performSwap(i, j);
            } else
            {
                cnt++;
            }
        }
    }
}