#include<bits/stdc++.h>

#define MAXN 200002

using namespace std;

int n, k, dist[MAXN], from, D, ANSS = 1e9;
bool vis[MAXN], sec = false, flag;

vector<pair<int, int> > M[MAXN];
vector<pair<int, int> > edges;

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin>>n>>k;
    for(int i = 0; i < n - 1; i ++)
    {
        int u, v, w;
        cin>>u>>v>>w;
        M[u].push_back({v, w});
        M[v].push_back({u, w});
    }
}
long long bfs(int v)
{
    long long maxDist = 0, maxV = v;
    memset(vis, 0, sizeof vis);
    fill_n(dist, n + 1, 1e9);
    queue<int> q;
    q.push(v);
    dist[v] = 0;
    while(q.size())
    {
        int tp = q.front();
        q.pop();
        if(vis[tp]) continue;
        vis[tp] = 1;
        for(int i = 0; i < M[tp].size(); i ++)
        {
            pair<int, int> edge = M[tp][i];
            q.push(edge.first);
            dist[edge.first] = min(dist[edge.first], dist[tp] + edge.second);
            if(dist[edge.first] > maxDist && dist[edge.first] != 1e9)
            {
                maxDist = dist[edge.first];
                maxV = edge.first;
                from = i;
            }
        }
    }
    return maxV;
}
void dfs(int v, int p)
{
    if(v == D)
    {
        flag = true;
        return;
    }
    for(int i = 0; i < M[v].size(); i ++)
    {
        int u = M[v][i].first;
        int w = M[v][i].second;
        if(u != p)
        {
            dfs(u, v);
            if(flag)
            {
                //cout<<v<<"    "<<M[v][i].first<<endl;
                edges.push_back({v, i});
                return;
            }
        }
    }
}
long long findDiameter()
{
    int to = bfs(1);
    int d = bfs(to);
    D = d;
    dfs(to, -1);
    ANSS = dist[d];
    if(k)
    {
        int cn = 5, sz = edges.size();
        for(int i = 0; i < min(cn, sz); i ++)
        {
            int v = edges[i].first;
            int it = edges[i].second;
            M[v][it].second -= k;
            int u = M[v][it].first;
            for(int j = 0; j < M[u].size(); j ++)
            {
                if(M[u][j].first == v)
                {
                    M[u][j].second -= k;
                    to = bfs(1);
                    d = bfs(to);
                    /*for(int i = 1; i<=n; i ++)
                    {
                        cout<<dist[i]<<" ";
                    }
                    cout<<endl;
                    cout<<d<<endl;*/
                    if(dist[d] < ANSS) return dist[d];
                    M[u][j].second += k;
                    break;
                }
            }
            M[v][it].second += k;
        }

    }

    return ANSS;
}
int main()
{
    read();
    long long d = findDiameter();
    cout<<d<<endl;
    return 0;
}
/*
5 1
1 2 5
2 3 1
2 4 3
4 5 2
*/
