#include <bits/stdc++.h>
#include "soft_drinks.h"
using namespace std;

const int maxn = 1e5+2;
int n, a[maxn], b[maxn];

void init(const std::vector<int>& A, const std::vector<int>& B)
{
    n = (int)(A.size());
    int i;
    for (i=0; i<n; ++i)
    {
        a[i+1] = A[i];
        b[i+1] = B[i];
    }
}

double friendDrink(const int Ma, const int Mb, const int La, const int Ra)
{
    if ((a[1] < La || a[1] > Ra) && (a[2] < La || a[2] > Ra))
        return (double)(0);
    if (a[1] < La || a[1] > Ra)
    {
        double volume1 = (double)(Ma) / (double)(a[2]);
        double volume2 = (double)(Mb) / (double)(b[2]);
        double volume = (volume1 < volume2) ? volume1 : volume2;
        return volume;
    }
    if (a[2] < La || a[2] > Ra)
    {
        double volume1 = (double)(Ma) / (double)(a[1]);
        double volume2 = (double)(Mb) / (double)(b[1]);
        double volume = (volume1 < volume2) ? volume1 : volume2;
        return volume;
    }

    double volume_only1, volume_only2, volume1, volume2;
    volume1 = (double)(Ma) / (double)(a[1]);
    volume2 = (double)(Mb) / (double)(b[1]);
    volume_only1 = (volume1 < volume2) ? volume1 : volume2;
    volume1 = (double)(Ma) / (double)(a[2]);
    volume2 = (double)(Mb) / (double)(b[2]);
    volume_only2 = (volume1 < volume2) ? volume1 : volume2;

    double n1 = (double)(Ma) / (double)(a[1]), n2 = (double)(Mb) / (double)(b[1]), c1, c2;
    if (n1 < n2)
        c1 = n1;
    else
        c1 = n2;
    n1 = (double)(Ma) / (double)(a[2]), n2 = (double)(Mb) / (double)(b[2]);
    if (n1 < n2)
        c2 = n1;
    else
        c2 = n2;
    double c = c1 + c2;

    volume1 = (double)(Ma) / (((c1 * (double)(a[1])) + (c2 * (double)(a[2]))) / c);
    volume2 = (double)(Mb) / (((c1 * (double)(b[1])) + (c2 * (double)(b[2]))) / c);
    double volume = (volume1 < volume2) ? volume1 : volume2;
    if (volume < volume_only1)
        volume = volume_only1;
    if (volume < volume_only2)
        volume = volume_only2;
    return volume;
}
