/// kvi sa tiq napitki ve
#include<bits/stdc++.h>

using namespace std;
typedef long long ll;


const int MAXN = 1e5 + 10;

int n, a[MAXN], b[MAXN];

const ll INF = 1e18;

void init(const vector < int > &A, const vector < int > &B)
{
    n = A.size();
    for (int i = 1; i <= n; i ++)
    {
        a[i] = A[i - 1];
        b[i] = B[i - 1];

    }
}


double friendDrink(int Ma, int Mb, int La, int Ra)
{
    double res = 0.0;
    for (int i = 1; i <= n; i ++)
        for (int j = i + 1; j <= n; j ++)
        {
            int a1 = a[i], b1 = b[i];
            int a2 = a[j], b2 = a[j];

            if (a1 > a2)
            {
                swap(a1, a2);
                swap(b1, b2);
            }

            /*
            Conditions:
            a1 * v1 + a2 * (v - v1) <= Ma
            b1 * v1 + b2 * (v - v1) <= Mb
            a1 * v1 + a2 * (v - v1) >= La * v
            a1 * v1 + a2 * (v - v1) <= Rb * v
            (a1 - a2) * v1 + <= (Rb - a2) * v

            one of the first two inequalities must be equality
            */

            /*
            a1 * v1 + a2 * (v - v1) = Ma
            a1 * v1 + a2 * v - a2 * v1 = Ma
            v1 * (a1 - a2) = Ma - a2 * v
            v1 = (Ma - a2 * v) / (a1 - a2)

            now
            (b1 - b2) * v1 + b2 * v <= Mb
            (b1 - b2) * (Ma - a2 * v) / (a1 - a2) + b2 * v <= Mb
            (b1 - b2) * (Ma - a2 * v) + (a1 - a2) * b2 * v <= Mb * (a1 - a2)
            (b1 - b2) * Ma - (b1 - b2) * a2 * v + (a1 - a2) * b2 * v <= Mb * (a1 - a2)
            - (b1 - b2) * a2 * v + (a1 - a2) * b2 * v <= Mb * (a1 - a2) - (b1 - b2) * Ma
            v * ( (a1 - a2) * b2 - (b1 - b2) * a2) <= Mb * (a1 - a2) - (b1 - b2) * Ma


            next
            Ma >= La * v

            last
            Ma <= Rb * v

            */

            double num = (double)(Mb) * (double)(a1 - a2) - (double)(b1 - b2) * (double)(Ma);
            double den = ( (double)(a1 - a2) * (double)(b2) - (double)(b1 - b2) * (double)(a2));
            double sum = num / den;

            double upper_v = min((double)(Ma) / (double)(La), sum);

            double under_v = (double)(Ma) / (double)(Ra);

            if (upper_v >= under_v)
                res = max(res, upper_v);

            /*
            Second condition becomes equality now
            a1 * v1 + a2 * (v - v1) <= Ma
            b1 * v1 + b2 * (v - v1) <= Mb
            a1 * v1 + a2 * (v - v1) >= La * v
            a1 * v1 + a2 * (v - v1) <= Rb * v
            (a1 - a2) * v1 + <= (Rb - a2) * v

            (b1 - b2) * v1 + b2 * v = Mb
            v1 = ((Mb - b2 * v) / (b1 - b2))


            now first
            (a1 - a2) * v1 + a2 * v <= Ma
            (a1 - a2) * ((Mb - b2 * v) / (b1 - b2)) + a2 * v <= Ma
            (a1 - a2) * (Mb - b2 * v) + a2 * v *(b1 - b2)<= Ma * (b1 - b2)
            (a1 - a2) * Mb - (a1 - a2) * b2 * v + a2 * v *(b1 - b2)<= Ma * (b1 - b2)
            v * (a2 * (b1 - b2) - (a1 - a2) * b2) <= Ma * (b1 -b2) - (a1 - a2) * Mb
            ...


            */
        }

    return res;
}
