#include<bits/stdc++.h>
#include "cycles.h"

using namespace std;
typedef long long ll;


const int MAXN = 1010;

int deltas[MAXN];
mt19937 rng(time(NULL)); /// make a seed

int curCycles;
void untangle(vector < int > ids)
{
    cout << ids.size() << endl;
    if (ids.size() <= 1)
        return;

    if (ids.size() == 2)
    {
        performSwap(ids[0], ids[1]);
        /*int d = performSwap(ids[0], ids[1]);
        int cycles = performSwap(ids[0], ids[1]);
        d = d - cycles;
        if (d < 0)
            performSwap(ids[0], ids[1]);*/
        return;
    }

    if (ids.size() == 3)
    {
        int cur = performSwap(ids[0], ids[1]);
        if (performSwap(ids[0], ids[2]) >= cur)
            performSwap(ids[0], ids[1]);
        return;
    }
    int sz = ids.size();

    int id1 = rng() % sz, id2 = rng() % sz;
    if (id1 == id2)
        id2 = (id2 + 1) % sz;


    int d = performSwap(ids[id1], ids[id2]);
    int cycles = performSwap(ids[id1], ids[id2]);

    d = d - cycles;
    if (d < 0)
    {
        vector < int > rest;
        for (int i = 0; i < sz; i ++)
        {
            if (i != id1 && i != id2)
                rest.push_back(i);
        }
        performSwap(ids[id1], ids[id2]);
        untangle(rest);
        return;
    }


    if (d > 0)
    {
        cycles = performSwap(ids[id1], ids[id2]);
        vector < int > id_left, id_right;

        id_left.push_back(ids[0]);
        for (int i = 1; i < sz; i ++)
        {
            int ch = performSwap(ids[i], ids[0]) - cycles;
            performSwap(ids[i], ids[0]);
            if (ch == 1)
                id_right.push_back(ids[i]);
            else
                id_left.push_back(ids[i]);

        }

        untangle(id_left);
        untangle(id_right);
    }
    else
    {
        untangle(ids);
    }
}
void sortPermutation(int N)
{

    performSwap(0, 1);
    int initCycles = performSwap(0, 1);

    for (int i = 0; i < N; i += 2)
    {
        int d = performSwap(i, i + 1);
        if (d < initCycles)
        {
            initCycles = d;
        }
        else
        {
            performSwap(i, i + 1);
        }
    }

}
