#include<bits/stdc++.h>
#include "cycles.h"

using namespace std;
typedef long long ll;


const int MAXN = 1010;

int deltas[MAXN];
mt19937 rng(time(NULL)); /// make a seed

int curCycles = 1;
void untangle(vector < int > ids)
{


    if (ids.size() <= 1)
        return;


    int sz = ids.size();

    int id1 = rng() % sz, id2 = rng() % sz;
    if (id1 == id2)
        id2 = (id2 + 1) % sz;


    int d = performSwap(ids[id1], ids[id2]) - curCycles;
    curCycles += d;
    if (ids.size() == 2)
        return;
    vector < int > ids_left, ids_right;
    ids_left.push_back(ids[id1]);
    //cout << "mark" << endl;

    for (int i = 0; i < sz; i ++)
    {
        if (i == id1)
            continue;

        int ch = performSwap(ids[id1], ids[i]) - curCycles;

        performSwap(ids[id1], ids[i]);
        if (ch > 0)
            ids_left.push_back(ids[i]);
        else
            ids_right.push_back(ids[i]);
    }
    //cout << "Here " << ids.size() << " " << ids_left.size() << " " << ids_right.size() << endl;
    untangle(ids_left);
    untangle(ids_right);
}

int d[MAXN];
void sortPermutation(int N)
{

    while(true)
    {
        for (int i = 0; i < N; i ++)
        {
            int j = rng() % N;
            if (j != i)
                performSwap(i, j);
        }


        performSwap(0, 1);
        int initialCycles = performSwap(0, 1);

        if (initialCycles == 0)
            return;

        /**vector < int > ids;

        for (int i = 1; i < N; i ++)
        {
            deltas[i] = performSwap(0, i) - initialCycles;
            performSwap(0, i);

            if (deltas[i] == 0)
                ids.push_back(i);
        }

        if (ids.size() == 0)
            break;

        cout << "Lol did not break" << endl;*/
        break;
    }

    /**
    we assume that due to random sort
    the first element is in a cycle of length > 2 and that there are no stationary elements
    */
    performSwap(0, 1);
    int initialCycles = performSwap(0, 1);

    for (int i = 1; i < N; i ++)
    {
        int d = performSwap(0, i) - initialCycles;

        if (d >= 0)
            performSwap(0, i);
        else
            initialCycles += d;
    }


    vector < int > ids;
    for (int i = 0; i < N; i ++)
        ids.push_back(i);


    untangle(ids);


}
