#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const int MAXN = 2010;

int n, k;
vector < pair < int, int > > adj[MAXN];
void input()
{
    cin >> n >> k;
    for (int i = 1; i < n; i ++)
    {
        int v, u, w;
        cin >> v >> u >> w;
        adj[v].push_back({u, w});
        adj[u].push_back({v, w});
    }
}


int dp[MAXN][MAXN], sub[MAXN], temp[MAXN], bound;
const int INF = 1e9;

void dfs(int v, int p)
{
    sub[v] = 1;
    for (int j = 0; j <= n; j ++)
        dp[v][j] = 0;
    for (pair < int, int > cur : adj[v])
    {
        int u = cur.first;
        if (u == p)
            continue;
        dfs(u, v);

        for (int j = 0; j <= sub[v] + sub[u]; j ++)
            temp[j] = INF;

        for (int j = 0; j < sub[v]; j ++)
            for (int d = 0; d < sub[u]; d ++)
                for (int p = 0; p <= cur.second; p ++)
                {
                    if (j + d + (cur.second - p) <= bound)
                    {
                        temp[max(j, d + (cur.second - p))] = min(temp[max(j, d + (cur.second - p))], dp[v][j] + dp[u][d] + p);
                    }
                }

        sub[v] += sub[u];
        for (int j = 0; j <= sub[v]; j ++)
            dp[v][j] = temp[j];
    }

    /**cout << "Finished " << v << endl;
    for (int j = 0; j <= sub[v]; j ++)
        cout << dp[v][j] << " ";
    cout << endl;*/

}

bool check(int x)
{
    bound = x;
    dfs(1, -1);
    for (int j = 0; j <= n; j ++)
        if (dp[1][j] <= k)
            return true;
    return false;
}
void bin_search()
{

    int l = -1, r = n + 1;

    while(l + 1< r)
    {
        int m = (l + r) / 2;
        if (check(m))
            r = m;
        else
            l = m;
    }

    cout << r << endl;
}
void solve()
{
    input();
    bin_search();
}

int main()
{
    speed();
    solve();
    return 0;
}
/**

5 2
1 2 1
2 3 1
2 4 1
4 5 1

*/
