#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const int MAXN = 2e5 + 10;

int n, k;
vector < pair < int, int > > adj[MAXN];
void input()
{
    cin >> n >> k;
    for (int i = 1; i < n; i ++)
    {
        int v, u, w;
        cin >> v >> u >> w;
        adj[v].push_back({u, w});
        adj[u].push_back({v, w});
    }
}


int dist[MAXN];
void dfs(int v, int p)
{
    for (pair < int, int > cur : adj[v])
    {
        if (cur.first == p)
            continue;
        dist[cur.first] = dist[v] + cur.second;
        dfs(cur.first, v);
    }
}

void solve()
{
    input();
    dfs(1, -1);
    int a = 1;
    for (int i = 1; i <= n; i ++)
        if (dist[i] > dist[a])
            a = i;
    dist[a] = 0;
    dfs(a, -1);
    set < int > st1;

    int ans = 0, b = -1;
    for (int i = 1; i <= n; i ++)
    {
        ans = max(ans, dist[i]);
        if (dist[i] == ans)
            b = i;
    }

    for (int i = 1; i <= n; i ++)
    {
        if (dist[i] == ans)
            st1.insert(i);
    }

    dist[b] = 0;
    dfs(b, -1);

    for (int i = 1; i <= n; i ++)
    {
        /*cout << "start " << b << " : " << i << " " << dist[i] << endl;
        if (dist[i] == ans)
        {
            cout << i << endl;
        }*/
        if (dist[i] == ans && st1.find(i) != st1.end())
        {
            cout << ans << endl;
            return;
        }
    }
    cout << ans - 1 << endl;
}

int main()
{
    speed();
    solve();
    return 0;
}

/*
5 1
1 2 5
2 3 5
2 4 3
4 5 2
*/
