#include "soft_drinks.h"
#include<bits/stdc++.h>
#define fi first
#define se second

using namespace std;

const int MAXN=1e5+5;
const double INFD=2e9+5;

int n;
pair<int,int> p[MAXN];

double dvd(int a,int b)
{
    if(b==0) return INFD;
    return (double)a/b;
}

int bsLA(int x)
{
    int l=1,r=n;
    while(l<r)
    {
        int mid=(l+r)/2;
        if(p[mid].fi<x) l=mid+1;
        else r=mid;
    }
    if(p[l].fi<x) return n+1;
    return l;
}
int bsRA(int x)
{
    int l=1,r=n;
    while(l<r)
    {
        int mid=(l+r)/2;
        if(p[mid].fi>x) r=mid;
        else l=mid+1;
    }
    if(p[l].fi>x) return 0;
    return l;
}

double calc(pair<int,int> p1,pair<int,int> p2,int A,int B)
{
    double x=(double)(1LL*p2.fi*B-1LL*p2.se*A)/(1LL*p1.se*p2.fi-1LL*p2.se*p1.fi);
    double y=(double)(A-x*p1.fi)/p2.fi;
    return x+y;
}

void init(const std::vector<int>& A, const std::vector<int>& B)
{
    n=A.size();
    for(int i=0;i<n;i++)
    {
        p[i+1]={A[i],B[i]};
    }
    sort(p+1,p+n+1);
}

vector<pair<int,int> > v;
double friendDrink(int Ma, int Mb, int La, int Ra)
{
    int l=bsLA(La);
    int r=bsRA(Ra);

    v.clear();
    for(int i=l;i<=r;i++)
    {
        if(1<=i && i<=n) 
        {
            if(v.empty()) v.push_back(p[i]);
            else if(p[i].se<v.back().se) v.push_back(p[i]);
        }
    }

    if(v.empty()) return 0;
    if(v.size()==1)
    {
        return min(dvd(Ma,v[0].fi), dvd(Mb,v[0].se));
    }

    double ans=0;
    for(auto [x,y]: v)
    {
        ans=max(ans, min((double)Ma/x, (double)Mb/y));
    }
    double rel=dvd(Mb,Ma);
    for(int i=1;i<v.size();i++)
    {
        if(dvd(v[i-1].se, v[i-1].fi)>=rel && rel>=dvd(v[i].se, v[i].fi))
        {
            ans=max(ans, calc(v[i-1],v[i],Ma,Mb));
        }
    }

    return ans;
}