#include "soft_drinks.h"
#include <bits/stdc++.h>
using namespace std;
const int MAXN = 1e5+7;
struct napitka{
    int a,b;
};
vector<napitka> v;
bool el(napitka x,napitka y){
    if(x.a==y.a)    return x.b<y.b;
    return x.a<y.a;
}
long long tree[4*MAXN];
void build(int l,int r,int ind){
    tree[ind]=2*1e9+7;
    if(l==r){
        tree[ind]=max(v[l].b,v[l].a);
        return;
    }
    int m = (l+r)/2;
    build(l,m,2*ind);
    build(m+1,r,2*ind+1);
    tree[ind]=min(tree[2*ind],tree[2*ind+1]);
}
int query(int l,int r,int ind,int ql,int qr){
    if(ql<=l and r<=qr) return tree[ind];

    int ans = 1e9+7;
    int m = (l+r)/2;
    if(ql<=m) ans = min(ans,query(l,m,2*ind,ql,qr));
    if(qr>m) ans = min(ans,query(m+1,r,2*ind+1,ql,qr));

    return ans;
}
void init(const vector<int>& a,const vector<int>& b){
    for(int i=0;i<a.size();i++){
        v.push_back({a[i],b[i]});
    }
    sort(v.begin(),v.end(),el);
    build(0,a.size()-1,1);
}
double friendDrink(const int Ma,const int Mb,const int La,const int Ra){
    int l=0,r=v.size()-1,m;
    int leftind,rightind;
    while(l<r){
        m=(l+r)/2;
        if(v[m].a<La){
            l=m+1;
        }else{
            r=m;
        }
    }
    leftind = l;
    l=0,r=v.size();
    while(l<r){
        m=(l+r)/2;
        if(v[m].a<=Ra){
            l=m+1;
        }else{
            r=m;
        }
    }
    rightind = l-1;
    long double ans = query(0,v.size()-1,1,leftind,rightind)*1.00000000;
    long double ma = Ma*1.00000000;
    long double mb = Mb*1.00000000;
    ans = mb/ans;
    return ans;
}
